SystemOrganization addCategory: #'Glamour-Morphic-Brick'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Announcements'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Layouts'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Layouts-compatibility'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Model'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Morphic'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Phlow'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Renderer'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Theme'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Traits'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Utils'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Widgets-Core'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Widgets-UI'!

Trait named: #GLMBrickExtensionTrait
	uses: {}
	category: 'Glamour-Morphic-Brick-Traits'!

!GLMBrickExtensionTrait commentStamp: 'AliakseiSyrel 1/30/2015 10:47' prior: 0!
I declare an api to store and read extention properties. It should be inplemented in any Brick UI to make it work.!

!GLMBrickExtensionTrait methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/26/2015 13:12'!
hasProperty: aSymbol

	^ self explicitRequirement! !

!GLMBrickExtensionTrait methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:24'!
removeProperty: aSymbol
	
	^ self explicitRequirement! !

!GLMBrickExtensionTrait methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:24'!
setProperty: aSymbol toValue: anObject
	
	^ self explicitRequirement! !

!GLMBrickExtensionTrait methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:25'!
valueOfProperty: aSymbol
	
	^ self explicitRequirement! !

!GLMBrickExtensionTrait methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:25'!
valueOfProperty: aSymbol ifAbsent: aBlock
	
	^ self explicitRequirement! !

!GLMBrickExtensionTrait methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:25'!
valueOfProperty: aSymbol ifAbsentPut: aBlock 
	
	^ self explicitRequirement! !

Trait named: #GLMBrickGeometryTrait
	uses: GLMBrickExtensionTrait
	category: 'Glamour-Morphic-Brick-Traits'!

!GLMBrickGeometryTrait commentStamp: 'AliakseiSyrel 1/30/2015 10:47' prior: 0!
I declare api and logic to work with geometry of a Brick!

GLMBrickGeometryTrait classTrait
	uses: GLMBrickExtensionTrait classTrait!

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/8/2015 12:59'!
bounds: aRectangle
	"when you use this method, it changes brickBounds
	then recalculates layout and invalidates rectangle"
	self layoutAfter: [ :b | b wrappedBounds bounds: aRectangle ]! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/1/2015 22:35'!
brickBounds

	^ self wrappedBounds brickBounds! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/8/2015 16:53'!
brickBounds: aRectangle
	"directly sets brick bounds without layouting process"
	self wrappedBounds brickBounds: aRectangle! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 2/3/2015 09:05'!
customHeight

	^ (self valueOfProperty: #brickGeometryHeightLogic) brickValue: self! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 2/3/2015 09:05'!
customWidth

	^ (self valueOfProperty: #brickGeometryWidthLogic) brickValue: self! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/8/2015 12:54'!
extent

	^ self brickBounds extent! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/3/2015 11:13'!
extent: aPoint
	"actually works only if width or height are not custom"
	"updates layout"
	self changed.
	
	self width: aPoint x.
	self height: aPoint y.
	self wrappedBounds bounds: (self brickBounds origin extent: aPoint).
	
	self flag: 'do I need to layout morphs inside?'.
	self doLayout.
	
	self changed! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/21/2015 12:22'!
globalBounds
	"converts local bounds to global bounds on fly"
	
	^ self owner ifNotNil: [ self brickBounds translateBy: self owner globalBoundsTranslateFactor ] ifNil: [ self brickBounds ].! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 1/21/2015 12:22'!
globalBoundsTranslateFactor

	^ self owner ifNotNil: [ self owner globalBoundsTranslateFactor + self brickBounds origin ] ifNil: [ 0@0 ]! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/20/2015 22:42'!
globalInnerBounds
	"converts local inner bounds to global inner bounds on fly"
	
	^ self owner ifNotNil: [ self innerBounds translateBy: self owner globalBoundsTranslateFactor ] ifNil: [ self innerBounds ].! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/20/2015 22:42'!
globalOuterBounds
	"converts local outer bounds to global inner bounds on fly"
	
	^ self owner ifNotNil: [ self outerBounds translateBy: self owner globalBoundsTranslateFactor ] ifNil: [ self outerBounds ].! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/3/2015 11:19'!
hMargin

	^ self marginLeft + self marginRight! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/3/2015 11:20'!
hPadding

	^ self paddingLeft + self paddingRight! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/8/2015 12:54'!
height

	^ self brickBounds height! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/20/2015 18:23'!
height: anObject
	
	self setProperty: #brickGeometryHeightLogic toValue: anObject.
	self updateHeight! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/1/2015 22:33'!
innerBounds
	"can be used in layouts"
	^ self wrappedBounds innerBounds! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 1/20/2015 18:26'!
isHeightCustom

	^ (self valueOfProperty: #brickGeometryHeightLogic ifAbsentPut: [ nil ]) isNotNil! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 1/20/2015 18:25'!
isWidthCustom

	^ (self valueOfProperty: #brickGeometryWidthLogic ifAbsentPut: [ nil ]) isNotNil! !

!GLMBrickGeometryTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 22:36'!
layout

	^ self explicitRequirement! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:45'!
margin: aCollection

	self wrappedBounds margin: aCollection! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginBottom

	^ self wrappedBounds marginBottom! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginBottom: anObject

	self wrappedBounds marginBottom: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginLeft

	^ self wrappedBounds marginLeft! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginLeft: anObject

	self wrappedBounds marginLeft: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginRight

	^ self wrappedBounds marginRight! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginRight: anObject

	self wrappedBounds marginRight: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginTop

	^ self wrappedBounds marginTop! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
marginTop: anObject

	self wrappedBounds marginTop: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/9/2015 23:00'!
maxHeight: anObject

	self layout maxHeight: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/9/2015 23:00'!
maxWidth: anObject

	self layout maxWidth: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/9/2015 23:01'!
minHeight: anObject

	self layout minHeight: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/9/2015 23:01'!
minWidth: anObject

	self layout minWidth: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/1/2015 22:34'!
outerBounds
	"can be used in layouts"
	^ self wrappedBounds outerBounds! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
padding: aCollection

	self wrappedBounds padding: aCollection! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
paddingBottom

	^ self wrappedBounds paddingBottom! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:40'!
paddingBottom: anObject

	self wrappedBounds paddingBottom: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:40'!
paddingLeft

	^ self wrappedBounds paddingLeft! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:40'!
paddingLeft: anObject

	self wrappedBounds paddingLeft: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:40'!
paddingRight

	^ self wrappedBounds paddingRight! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:40'!
paddingRight: anObject

	self wrappedBounds paddingRight: anObject! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:40'!
paddingTop

	^ self wrappedBounds paddingTop! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/1/2015 22:40'!
paddingTop: anObject

	self wrappedBounds paddingTop: anObject! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 1/29/2015 23:55'!
privateBounds: aRectangle
	
	^ self explicitRequirement! !

!GLMBrickGeometryTrait methodsFor: 'private-extension' stamp: ''!
removeProperty: aSymbol
	
	^ self explicitRequirement! !

!GLMBrickGeometryTrait methodsFor: 'private-extension' stamp: ''!
setProperty: aSymbol toValue: anObject
	
	^ self explicitRequirement! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-transformations' stamp: 'AliakseiSyrel 2/8/2015 20:05'!
translateBy: aPoint

	self wrappedBounds translateBy: aPoint! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-transformations' stamp: 'AliakseiSyrel 2/8/2015 20:06'!
translateX: anInteger

	self wrappedBounds translateX: anInteger! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-transformations' stamp: 'AliakseiSyrel 2/8/2015 20:06'!
translateY: anInteger

	self wrappedBounds translateY: anInteger! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 2/8/2015 16:53'!
updateHeight
	"no need to care about height, when it's logic is not customized"
	self isHeightCustom ifFalse: [ ^ self ].
	[ self bounds: (self brickBounds withHeight: ((self valueOfProperty: #brickGeometryHeightLogic) brickValue: self)) ]
		on: Exception
		do: [ "just skip and do nothing" ]! !

!GLMBrickGeometryTrait methodsFor: 'private-geometry' stamp: 'AliakseiSyrel 2/8/2015 16:54'!
updateWidth
	"no need to care about width, when it's logic is not customized"
	self isWidthCustom ifFalse: [ ^ self ].
	[ self bounds: (self brickBounds withWidth: ((self valueOfProperty: #brickGeometryWidthLogic) brickValue: self)) ]
		on: Exception
		do: [ "just skip and do nothing" ]! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/3/2015 11:20'!
vMargin

	^ self marginTop + self marginBottom! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-properties' stamp: 'AliakseiSyrel 2/3/2015 11:20'!
vPadding

	^ self paddingTop + self paddingBottom! !

!GLMBrickGeometryTrait methodsFor: 'private-extension' stamp: ''!
valueOfProperty: aSymbol
	
	^ self explicitRequirement! !

!GLMBrickGeometryTrait methodsFor: 'private-extension' stamp: ''!
valueOfProperty: aSymbol ifAbsent: aBlock
	
	^ self explicitRequirement! !

!GLMBrickGeometryTrait methodsFor: 'private-extension' stamp: ''!
valueOfProperty: aSymbol ifAbsentPut: aBlock 
	
	^ self explicitRequirement! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/8/2015 12:54'!
width

	^ self brickBounds width! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/20/2015 18:24'!
width: anObject

	self setProperty: #brickGeometryWidthLogic toValue: anObject.
	self updateWidth! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-transformations' stamp: 'AliakseiSyrel 2/10/2015 14:37'!
withHeight: anInteger

	self wrappedBounds height: anInteger! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry-transformations' stamp: 'AliakseiSyrel 2/10/2015 14:37'!
withWidth: anInteger

	self wrappedBounds width: anInteger! !

!GLMBrickGeometryTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 2/1/2015 22:39'!
wrappedBounds

	^ self explicitRequirement! !

Trait named: #GLMBrickLayoutTrait
	uses: {}
	category: 'Glamour-Morphic-Brick-Traits'!

!GLMBrickLayoutTrait commentStamp: 'AliakseiSyrel 1/30/2015 10:48' prior: 0!
I declare api and logic to layout Bricks!

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 2/2/2015 00:56'!
doLayout

	GLMBrickLayouter uniqueInstance layoutIn: self! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 2/3/2015 16:28'!
doLayoutForce

	self wrappedBounds
		markHeightDirty;
		markWidthDirty.
	
	self doLayout! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 1/27/2015 12:47'!
hResizing

	^ self layout hResizing! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 1/27/2015 12:46'!
hResizing: aSymbol

	self layout hResizing: aSymbol! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/3/2015 11:01'!
hShrinkWrap

	self layout hShrinkWrap! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/3/2015 10:39'!
hSpaceFill

	self layout hSpaceFill! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/3/2015 10:53'!
hSpaceFill: anInteger

	self layout hSpaceFill: anInteger! !

!GLMBrickLayoutTrait methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/20/2015 22:37'!
innerBounds

	^ self explicitRequirement! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 2/3/2015 16:16'!
invalidateLayout

	self layoutPolicy layout: self in: self wrappedBounds innerBounds! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 16:17'!
isHeightDependsOnChildren
	"Returns true if my height depends only from my children, otherwise false.
	It means that layouter should first position my children and only then based on their
	sizes set my height"
	
	^ self vResizing = #shrinkWrap! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 16:17'!
isHeightDependsOnMyself
	"Returns true if my height depends only from myself, otherwise false.
	It means that layouter can immediately calculate and set it"
	
	^ self isHeightCustom! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 16:17'!
isHeightDependsOnParent
	"Returns true if my height depends only from my parent, otherwise false.
	It means that layouter must first calculate height of my parent and only then my"
	
	^ self vResizing = #spaceFill! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 18:59'!
isHeightDependsOnWidth
	"Returns true if my height depends from my width, otherwise false.
	It means that layouter must first calculate my width and as soon as it is done my height"
	
	^ self vResizing = #opposite! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 16:17'!
isWidthDependsOnChildren
	"Returns true if my width depends only from my children, otherwise false.
	It means that layouter should first position my children and only then based on their
	sizes set my width"
	
	^ self hResizing = #shrinkWrap! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 18:59'!
isWidthDependsOnHeight
	"Returns true if my width depends from my height, otherwise false.
	It means that layouter must first calculate my width and as soon as it is done my width"
	
	^ self hResizing = #opposite! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 16:18'!
isWidthDependsOnMyself
	"Returns true if my width depends only from myself, otherwise false.
	It means that layouter can immediately calculate and set it"
	
	^ self isWidthCustom! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 2/1/2015 16:18'!
isWidthDependsOnParent
	"Returns true if my width depends only from my parent, otherwise false.
	It means that layouter must first calculate width of my parent and only then my"
	
	^ self hResizing = #spaceFill! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 21:19'!
layout
	"Alias for layoutProperies"
	^ self layoutProperties! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 18:55'!
layout: aLayout
	"Alias for layoutPolicy:"
	self layoutPolicy: aLayout! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 2/8/2015 12:37'!
layoutAfter: aBlock

	aBlock cull: self.
	self doLayout! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 22:37'!
layoutPolicy

	^ self explicitRequirement! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 18:54'!
layoutPolicy: aLayout

	self explicitRequirement! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 22:37'!
layoutProperties

	^ self explicitRequirement! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 18:54'!
layoutProperties: aLayoutProperties

	self explicitRequirement! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 20:43'!
layoutSubbricks

	self layoutPolicy layout: self in: self innerBounds! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 1/20/2015 20:11'!
onLayoutEvent: aLayoutEvent
	"in case layout want's to trigger any specific event"! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 2/12/2015 12:26'!
onLayouted
	"called when brick is layouted"
	self changed! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 1/20/2015 20:12'!
onPrepareLayout
	"is called before I'm started layouting"! !

!GLMBrickLayoutTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 22:37'!
subbricks

	^ self explicitRequirement! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/8/2015 17:36'!
useHorizontalLinearLayout

	self layout: GLMHorizontalLinearLayout uniqueInstance! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/8/2015 17:36'!
useVerticalLinearLayout

	self layout: GLMVerticalLinearLayout uniqueInstance! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 1/27/2015 12:47'!
vResizing

	^ self layout vResizing! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 1/27/2015 12:46'!
vResizing: aSymbol

	self layout vResizing: aSymbol! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/3/2015 11:02'!
vShrinkWrap

	self layout vShrinkWrap! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/3/2015 10:39'!
vSpaceFill

	self layout vSpaceFill! !

!GLMBrickLayoutTrait methodsFor: 'brick-layout-properties' stamp: 'AliakseiSyrel 2/3/2015 10:54'!
vSpaceFill: anInteger

	self layout vSpaceFill: anInteger! !

Trait named: #GLMBrickPropertiesTrait
	uses: GLMBrickExtensionTrait
	category: 'Glamour-Morphic-Brick-Traits'!

!GLMBrickPropertiesTrait commentStamp: 'AliakseiSyrel 1/30/2015 10:49' prior: 0!
I declare api and logic to work with properties of a Brick, such as color, shadow, renderer and more!

GLMBrickPropertiesTrait classTrait
	uses: GLMBrickExtensionTrait classTrait!

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 2/11/2015 11:24'!
border

	^ self valueOfProperty: #brickBorder ifAbsentPut: [ GLMBrickBorder new ]
	! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 2/11/2015 11:25'!
border: aBorder

	self setProperty: #brickBorder toValue: aBorder! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 2/11/2015 11:51'!
borderColor: anObject

	self border color: anObject! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 2/11/2015 13:05'!
borderDo: aBlock

	aBlock cull: self border.
	^ self! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 2/11/2015 11:45'!
borderWidth: anObject

	self border width: anObject! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 12:57'!
color

	^ self valueOfProperty: #brickBackgroundColor ifAbsent: [ self themer backgroundColor ]! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/20/2015 20:35'!
color: aColor

	self setProperty: #brickBackgroundColor toValue: aColor! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/20/2015 20:36'!
data

	^ self valueOfProperty: #brickDataObject ifAbsentPut: [ nil ]! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/20/2015 20:36'!
data: anObject

	^ self setProperty: #brickDataObject  toValue:  anObject! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties-testing' stamp: 'AliakseiSyrel 1/26/2015 13:13'!
isColorSet

	^ self hasProperty: #brickBackgroundColor! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 1/26/2015 13:01'!
onThemerChanged
! !

!GLMBrickPropertiesTrait methodsFor: 'private-properties' stamp: 'AliakseiSyrel 1/26/2015 12:33'!
privateThemer

	^ self valueOfProperty: #brickThemer ifAbsentPut: [ nil ]! !

!GLMBrickPropertiesTrait methodsFor: 'private-extension' stamp: ''!
removeProperty: aSymbol
	
	^ self explicitRequirement! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/20/2015 20:37'!
renderer

	^ self valueOfProperty: #brickRenderer ifAbsentPut: [ nil ]! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/20/2015 20:38'!
renderer: aRenderer

	self setProperty: #brickRenderer toValue: aRenderer! !

!GLMBrickPropertiesTrait methodsFor: 'private-extension' stamp: ''!
setProperty: aSymbol toValue: anObject
	
	^ self explicitRequirement! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/24/2015 00:37'!
shadowColor

	^ self valueOfProperty: #brickShadowColor ifAbsentPut: [ Color transparent ]! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/24/2015 00:37'!
shadowColor: aColor

	self setProperty: #brickShadowColor toValue: aColor! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/24/2015 00:38'!
shadowWidth

	^ self valueOfProperty: #brickShadowWidth ifAbsentPut: [ 0 ]! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/24/2015 00:38'!
shadowWidth: anInteger

	self setProperty: #brickShadowWidth toValue: anInteger! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 12:34'!
themer

	^ self privateThemer
		ifNotNil: [ self privateThemer ]
		ifNil: [ self hasOwner
			ifTrue: [ self owner themer ]
			ifFalse: [ self theme brickThemer ] ]! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 13:01'!
themer: aThemer

	self setProperty: #brickThemer toValue: aThemer.
	self themerChanged! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 13:00'!
themerChanged

	self onThemerChanged.
	self subbricks do: #themerChanged! !

!GLMBrickPropertiesTrait methodsFor: 'private-extension' stamp: ''!
valueOfProperty: aSymbol
	
	^ self explicitRequirement! !

!GLMBrickPropertiesTrait methodsFor: 'private-extension' stamp: ''!
valueOfProperty: aSymbol ifAbsent: aBlock
	
	^ self explicitRequirement! !

!GLMBrickPropertiesTrait methodsFor: 'private-extension' stamp: ''!
valueOfProperty: aSymbol ifAbsentPut: aBlock 
	
	^ self explicitRequirement! !

!GLMBrickPropertiesTrait methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 2/12/2015 17:17'!
with: aBlock

	aBlock cull: self! !

Trait named: #GLMBrickRubricStyle
	uses: {}
	category: 'Glamour-Morphic-Brick-Theme'!

!GLMBrickRubricStyle commentStamp: 'AliakseiSyrel 1/30/2015 11:50' prior: 0!
I'm a style module related to a rubric text fields and its componenets!

!GLMBrickRubricStyle methodsFor: 'brick-rubric' stamp: 'AliakseiSyrel 1/30/2015 11:52'!
rubricBackgroundColor

	^ self contentBackgroundColor! !

!GLMBrickRubricStyle methodsFor: 'brick-rubric' stamp: 'AliakseiSyrel 1/30/2015 11:54'!
rubricBorderColor

	^ Color transparent! !

!GLMBrickRubricStyle methodsFor: 'brick-rubric' stamp: 'AliakseiSyrel 1/30/2015 11:54'!
rubricBorderWidth

	^ 0! !

Trait named: #GLMBrickScrollpaneStyle
	uses: {}
	category: 'Glamour-Morphic-Brick-Theme'!

!GLMBrickScrollpaneStyle commentStamp: 'AliakseiSyrel 1/30/2015 11:04' prior: 0!
I'm a style module related to a scrollpane and its component. !

!GLMBrickScrollpaneStyle methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 13:22'!
scrollbarColor

	^ Color lightGray alpha: 0.5! !

!GLMBrickScrollpaneStyle methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 12:28'!
scrollbarCornerRadius

	^ 0! !

!GLMBrickScrollpaneStyle methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 2/10/2015 15:16'!
scrollbarOffset

	^ 1! !

!GLMBrickScrollpaneStyle methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 12:27'!
scrollbarPosition

	^ #right! !

!GLMBrickScrollpaneStyle methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 12:26'!
scrollbarWidth

	^ 3! !

!GLMBrickScrollpaneStyle methodsFor: 'brick-scrollpane' stamp: 'AliakseiSyrel 1/30/2015 11:52'!
scrollpaneBackgroundColor

	^ self contentBackgroundColor! !

Trait named: #GLMBrickStructureTrait
	uses: {}
	category: 'Glamour-Morphic-Brick-Traits'!

!GLMBrickStructureTrait commentStamp: 'AliakseiSyrel 1/30/2015 10:58' prior: 0!
I declare api and logic to work with structure of a Brick as adding, removing, testing for existance and some more!

!GLMBrickStructureTrait methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/8/2015 16:46'!
addAllBricks: aCollection
	self privateAddAllBricks: aCollection.
	self doLayoutForce! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/8/2015 16:46'!
addBrick: aBrick before: otherBrick
	|result|
	result := self privateAddBrick: aBrick before: otherBrick.
	self doLayoutForce.
	^ result! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/8/2015 15:04'!
addBrickBack: aBrick
	|result|
	result := self privateAddBrickBack: aBrick.
	self doLayoutForce.
	^ result! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/8/2015 16:46'!
addBrickFirst: aBrick
	|result|
	result := self privateAddBrickFirst: aBrick.
	self doLayoutForce.
	^ result! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 2/1/2015 13:46'!
allSubbricks
	| all |
	all := OrderedCollection new.
	self allSubbricksDo: [:each | all add: each ].
	^ all! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 2/1/2015 15:21'!
allSubbricksDo: aBlock

	self subbricks do: [:each | 
		aBlock value: each.
		each isBrick ifTrue: [ each allSubbricksDo: aBlock ] ]! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-converting' stamp: 'AliakseiSyrel 1/20/2015 20:59'!
asBrick
	^ self! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-converting' stamp: 'AliakseiSyrel 1/21/2015 16:17'!
asBrickedMorph

	^ GLMFoundationBrick new brickRoot: self! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 1/20/2015 19:18'!
brickDoubleLink

	^ self valueOfProperty: #brickDoubleLink ifAbsentPut: [ nil ]! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 1/20/2015 22:58'!
brickDoubleLink: aDoubleLink

	self setProperty: #brickDoubleLink toValue: aDoubleLink! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 20:31'!
brickRoot

	^ self owner ifNotNil: [ self owner brickRoot ] ifNil: [ ^ self ]! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 19:15'!
firstSubbrick

	^ self subbricks first! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 1/26/2015 12:31'!
hasOwner

	^ self owner isNotNil! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 1/20/2015 19:23'!
hasSubbrick: aBrick

	^ aBrick owner = self! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 1/20/2015 19:31'!
hasSubbricks

	^ self subbricks isEmpty not! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 1/20/2015 20:17'!
isBrick

	^ true! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 1/20/2015 19:22'!
isFirstInOwner

	^ self brickDoubleLink hasPredecessor not! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-testing' stamp: 'AliakseiSyrel 1/20/2015 20:10'!
isLastInOwner

	^ self brickDoubleLink hasSuccessor not! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 19:15'!
lastSubbrick

	^ self subbricks last! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-converting' stamp: 'AliakseiSyrel 1/20/2015 21:01'!
morph
	^ self! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-events' stamp: 'AliakseiSyrel 1/29/2015 00:46'!
onRemovedFrom: aBrick
	"is called when brick is removed from aBrick"
	self subbricks do: [ :each | each onRemovedFrom: aBrick ]! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 22:38'!
owner

	^ self explicitRequirement! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 1/29/2015 00:46'!
owner: aBrick
	|oldOwner|
	oldOwner := self owner.
	self privateOwner: aBrick.
	aBrick
		ifNotNil: [ self themerChanged ]
		ifNil: [ self onRemovedFrom: oldOwner ]! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 2/8/2015 13:32'!
privateAddAllBricks: aCollection

	aCollection do: [ :each | self privateAddBrickBack: each ]! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 2/8/2015 13:32'!
privateAddBrick: aBrick before: otherBrick
	| brick link otherLink otherLinkPredeccessor|
	brick := aBrick asBrick.
	
	otherLink := otherBrick brickDoubleLink.
	otherLink = self firstSubbrick brickDoubleLink
		ifTrue: [ ^ self privateAddBrickFirst: brick ].
		
	link := brick asDoubleLink.
	brick brickDoubleLink: link.
	otherLinkPredeccessor := otherLink previousLink.
	otherLink previousLink: link.
	link nextLink: otherLink.
	link previousLink: otherLinkPredeccessor.
	otherLinkPredeccessor nextLink: link.
	
	self subbricks add: brick before: otherBrick.
	
	brick owner: self.
	
	^ aBrick! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 2/8/2015 13:30'!
privateAddBrickBack: aBrick
	|link brick|
	
	brick := aBrick asBrick.
	link := brick asDoubleLink.
	brick brickDoubleLink: link.
	
	self hasSubbricks ifTrue: [
		self lastSubbrick brickDoubleLink nextLink: link.	
		link previousLink: self lastSubbrick brickDoubleLink.
	].
	
	self privateSubbricks: (self subbricks copyWith: brick).
	brick owner: self.
	
	^ aBrick! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 2/8/2015 13:31'!
privateAddBrickFirst: aBrick
	| link head tail brick|
	
	brick := aBrick asBrick.
	head := nil.
	tail := nil.
	self hasSubbricks ifTrue: [
		head := self firstSubbrick brickDoubleLink.
		tail := self lastSubbrick brickDoubleLink ].
	
	link := brick asDoubleLink.
	brick brickDoubleLink: link.
	link nextLink: head.
	head ifNotNil: [ head previousLink: link ].
	
	self privateSubbricks: (self subbricks copyWithFirst: brick).
	brick owner: self.
	
	^ aBrick! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 1/26/2015 12:46'!
privateOwner: aBrick

	^ self explicitRequirement! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 2/8/2015 13:33'!
privateRemoveAllBricks
	
	self subbricks do: [:each |
		each brickDoubleLink: nil.
		each owner: nil ].
	self subbricks removeAll! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 2/9/2015 14:58'!
privateRemoveBrick: aBrick
	| predecessor successor link head tail index|
	aBrick ifNil: [ ^ aBrick ].
	(self hasSubbrick: aBrick) ifFalse: [ ^ aBrick ].
	
	link := aBrick brickDoubleLink.
	
	head := self firstSubbrick brickDoubleLink.
	tail := self lastSubbrick brickDoubleLink.
	
	predecessor := link previousLink.
	successor := link nextLink.
	predecessor
		ifNotNil: [ predecessor nextLink: successor ].
	successor
		ifNotNil: [ successor previousLink: predecessor ].
	link clearLinks.
	
	aBrick brickDoubleLink: nil.
	
	index := self subbricks find: aBrick.
	self privateSubbricks: (self subbricks copyWithoutIndex: index).
	aBrick owner: nil.
	
	^ aBrick! !

!GLMBrickStructureTrait methodsFor: 'private-structure' stamp: 'AliakseiSyrel 1/25/2015 15:46'!
privateSubbricks: aCollection

	^ self explicitRequirement! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/8/2015 16:46'!
removeAllBricks

	self privateRemoveAllBricks.
	self doLayoutForce! !

!GLMBrickStructureTrait methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/8/2015 16:46'!
removeBrick: aBrick
	|result|
	result := self privateRemoveBrick: aBrick.
	self doLayoutForce.
	^ result! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 22:16'!
subbrickAfter

	"Return the subbbrick after (behind) me, or nil"
	| link |
	link := self brickDoubleLink.
	link ifNil: [ ^ nil ].
	link nextLink ifNil: [ ^ nil ].
	^ link nextLink value! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 19:19'!
subbrickBefore

	"Return the subbrick before me, or nil"
	| link |
	link := self brickDoubleLink.
	link ifNil: [ ^ nil ].
	link previousLink ifNil: [ ^ nil ].
	^ link previousLink value! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 22:38'!
subbricks

	^ self explicitRequirement! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 19:28'!
subbricksCount

	^ self subbricks size! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/31/2015 18:26'!
subbricksReverseDo: aBlock

	self subbricks reverseDo: aBlock! !

!GLMBrickStructureTrait methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 2/1/2015 13:47'!
withAllSubbricks

	^ self allSubbricks add: self;
		 yourself! !

Trait named: #GLMPhlowTrait
	uses: {}
	category: 'Glamour-Morphic-Brick-Traits'!

!GLMPhlowTrait commentStamp: 'AliakseiSyrel 1/30/2015 10:59' prior: 0!
I offer an api that adds support of phlow transmissions to any object!

!GLMPhlowTrait methodsFor: 'phlow-transmissions' stamp: 'AliakseiSyrel 1/23/2015 21:10'!
addTransmission: aTransmission from: aSlotSymbol
 
	^ (self portOf: aSlotSymbol) addTransmission: aTransmission! !

!GLMPhlowTrait methodsFor: 'private-phlow' stamp: 'AliakseiSyrel 1/23/2015 21:32'!
onSlotChanged: aSlot

	(self portOf: aSlot name) transmit! !

!GLMPhlowTrait methodsFor: 'phlow-transmissions' stamp: 'AliakseiSyrel 1/23/2015 21:09'!
portOf: aSlotSymbol

	^ self ports at: aSlotSymbol ifAbsentPut: [ GLMPhlowPort new ]! !

!GLMPhlowTrait methodsFor: 'phlow-transmissions' stamp: 'AliakseiSyrel 1/23/2015 21:05'!
ports

	^ self explicitRequirement! !

!GLMPhlowTrait methodsFor: 'phlow-scripting' stamp: 'AliakseiSyrel 1/23/2015 20:43'!
transmit

	^ GLMPhlowTransmissionBuilder phlow: self! !

Morph subclass: #GLMBrickedMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Morphic'!

!GLMBrickedMorph commentStamp: 'AliakseiSyrel 1/7/2015 23:25' prior: 0!
A GLMBrickedMorph is a direct subclass of Morph with removed layouting mechanism!

GLMBrickedMorph subclass: #GLMBrick
	uses: GLMBrickPropertiesTrait + GLMBrickLayoutTrait + GLMBrickStructureTrait + GLMPhlowTrait + (GLMBrickGeometryTrait - {#privateBounds:})
	instanceVariableNames: '#brickBounds => GLMPhlowSlot #ports => GLMPhlowSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMBrick commentStamp: 'AliakseiSyrel 1/22/2015 20:17' prior: 0!
A GLMBrick is xxxxxxxasdadxx.

Instance Variables
	brickBounds:		<Object>
	transmissions:		<Object>

brickBounds
	- xxxxx

transmissions
	- xxxxx
!

GLMBrick class
	uses: GLMBrickPropertiesTrait classTrait + GLMBrickGeometryTrait classTrait + GLMBrickLayoutTrait classTrait + GLMBrickStructureTrait classTrait + GLMPhlowTrait classTrait
	instanceVariableNames: ''!

GLMBrick subclass: #GLMBandBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMBandBrick commentStamp: 'AliakseiSyrel 10/18/2014 00:57' prior: 0!
A GLMBandBrick is a simple Brick with height and bounds to fit all subbricks.
Usually used within scroll panes
!

!GLMBandBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/8/2015 16:52'!
example
	<example: 'Example of GLMBandBrick with many subbricks'>
	|band count|
	count := 100.
	band := self new
		width: 400;
		height: 600.
	
	1 to: count do: [ :index | 
		
		band addBrickBack: (
		GLMLabelBrick new
			text: (index asString, ' of ', count asString);
			textPosition: #center;
			color: Color random muchLighter;
			height: 40;
			hSpaceFill ) ].
		
	band asBrickedMorph openInWindow
	! !

!GLMBandBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 17:39'!
initialize
	super initialize.
	
	self
		useVerticalLinearLayout;
		vShrinkWrap! !

GLMBandBrick subclass: #GLMTreeBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-UI'!

!GLMTreeBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/12/2015 18:28'!
example
	<example>
	
	(self new on: { 'First' -> '1' . 'Second' -> '2' . 'Third' -> { 'Sub First' -> '3-1' . 'Sub Second' -> '3-2' } })
		asBrickedMorph
			extent: 300@400;
			openInWindow
	! !

!GLMTreeBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/12/2015 18:26'!
collapsableFor: anObject
	|collapsable|
	
	collapsable := GLMCollapsableBrick new.
	collapsable
		vShrinkWrap;
		hSpaceFill.
		
	"self halt."
	collapsable headerBrick: (self headerFor: anObject in: collapsable).
	(self hasChildren: anObject)
		ifTrue: [
			collapsable contentBrick: (self class new on: anObject value).
			collapsable contentBrick
				vShrinkWrap;
				hSpaceFill;
				marginLeft: 19 ].
	
	^ collapsable! !

!GLMTreeBrick methodsFor: 'protocol' stamp: 'AliakseiSyrel 2/12/2015 18:07'!
hasChildren: anObject

	anObject ifNil: [ ^ false ].
	anObject isVariableBinding ifFalse: [ ^ false ].
	anObject value ifNil: [ ^ false ].
	anObject value isCollection ifTrue: [ anObject value isEmpty not ].
	^ true! !

!GLMTreeBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/12/2015 18:18'!
headerFor: anObject in: aCollapsable
	|header|
	
	header := GLMBrick new.
	header
		hSpaceFill;
		vShrinkWrap.
		
	header addBrickBack:
		((anObject isVariableBinding
			ifTrue: [ anObject key asBrick ]
			ifFalse: [ anObject asBrick ])
				hSpaceFill).
				
	(self hasChildren: anObject) ifTrue: [
		header addBrickFirst: (self newToggleButtonFor: aCollapsable) ].
	
	^ header! !

!GLMTreeBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/12/2015 18:26'!
newToggleButtonFor: aCollapsable

	^ (GLMActionButtonBrick new
			icon: GLMUIThemeExtraIcons glamorousRight;
			checkedImage: GLMUIThemeExtraIcons glamorousDown;
			height: [ :b | b icon height * 1.2 ];
			width: [ :b | b icon width * 1.2 ];
			addUpAction: [ :b | 
				aCollapsable toggle.
				aCollapsable isExpanded
					ifTrue: [ b check ]
					ifFalse: [ b uncheck ] ])! !

!GLMTreeBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/12/2015 18:24'!
on: anObject
	"{ 'first'-> { 'sub 1' -> '11' . 'sub 2' -> '12' } }"
	
	(anObject isCollection & anObject isString not)
		ifFalse: [ self addBrickBack: (self collapsableFor: anObject) ]
		ifTrue: [ anObject do: [ :each | self addBrickBack: (self collapsableFor: each) ] ].
	
	! !

!GLMBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/11/2015 12:22'!
exampleDynamicBorder
	<example:'Dynamic border width'>
	
	(GLMLabelBrick new
		borderColor: Color blue; 
		borderWidth: [ :b | (b height min: b width) * 0.1 ];
		color: Color white;
		text: 'Resize me';
		fontSize: 12;
		textPosition: #center) asBrickedMorph openInWindow! !

!GLMBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/10/2015 00:18'!
exampleWithMorphInsideBrick

	"self exampleWithMorphInsideBrick"

	|foundation brick morph|
	
	foundation := GLMFoundationBrick new.
	foundation extent: 800@400.

	brick := GLMLabelBrick new.
	brick text: 'Hello, I''m a Brick inside another Brick!!'.
	brick hSpaceFill: 50.
	brick color: Color lightBlue lighter.

	morph := Morph new.
	morph color: Color lightGreen lighter.
	morph layoutProperties: GLMBrickLayoutProperties new.
	morph hSpaceFill: 50.

	morph addMorphBack: (LabelMorph new
		contents: 'Hello, I''m a Morph inside another Morph inside Brick!!';
		hResizing: #spaceFill;
		vResizing: #spaceFill).

	foundation
		addBrickBack: brick;
		addBrickBack: morph;
		doLayout;
		openInWindow.! !

!GLMBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 15:47'!
exampleZindex

	"self exampleZindex"

	|foundationBrick rootBrick brick1 brick2 brick3|
	
	rootBrick := GLMBrick new.

	rootBrick color: Color blue.
	
	brick1 := GLMBrick new.
	brick1 color: Color red.
	brick1 brickBounds: (0@0 extent: 300@200).
	brick1 layoutProperties zIndex: 1.
	
	brick2 := GLMBrick new.
	brick2 color: Color green.
	brick2 brickBounds: (50@50 extent: 200@100).
	brick2 layoutProperties zIndex: 2.
	
	brick3 := GLMBrick new.
	brick3 color: Color yellow.
	brick3 brickBounds: (100@100 extent: 100@100).
	brick3 layoutProperties zIndex: 3.
	
	rootBrick
		addBrickBack: brick3;
		addBrickBack: brick2;
		addBrickBack: brick1.
		
	foundationBrick := GLMFoundationBrick new.
	foundationBrick brickRoot: rootBrick.
	foundationBrick openInWindow.
	foundationBrick color: Color pink.! !

!GLMBrick class methodsFor: 'utils' stamp: 'AliakseiSyrel 2/9/2015 14:31'!
increaseFormExtentCentered: aForm to: aPoint
	| icon rect destination |
	
	aForm ifNil: [ ^ nil ].
	rect := Rectangle origin: 0@0 extent: aPoint.
	destination := (rect extent - aForm extent) / 2.
	icon := Form extent: rect extent depth: aForm depth.
	icon copyBits: rect from: aForm at: destination clippingBox: icon boundingBox rule: Form over fillColor: nil.
	^ icon! !

!GLMBrick class methodsFor: 'utils' stamp: 'AliakseiSyrel 2/9/2015 14:31'!
makeForm32Bit: aForm
	aForm ifNil: [ ^ nil ].
	aForm depth = 32 ifTrue: [ ^ aForm ].
	aForm depth: 32.
	aForm fixAlpha.
	^ aForm.! !

!GLMBrick class methodsFor: 'utils' stamp: 'AliakseiSyrel 2/9/2015 14:32'!
makeFormTransparent: aForm factor: aFloat
	"a float must be in interval [0.0, 1.0]"
	| a |
	
	aForm ifNil: [ ^ nil ].
	aForm depth = 32 ifFalse: [^ aForm ].
	
	a := (aFloat * 255) asInteger.
	1 to: aForm bits size do: [:i |
		| v r g b |
		v := aForm bits at: i.
		r := ((v bitShift: -16) bitAnd: 255) * a // 255.
		g := ((v bitShift: -8) bitAnd: 255) * a // 255.
		b := (v bitAnd: 255) * a // 255.
		aForm bits at: i put: (a bitShift: 24) + (r bitShift: 16) + (g bitShift: 8) + b ].
	^ aForm ! !

!GLMBrick class methodsFor: 'utils' stamp: 'AliakseiSyrel 2/9/2015 14:32'!
resizeImage: anImage scale: aScale

	((aScale > (1@0)) | (aScale > (0@1))) ifTrue: [
		^ self increaseFormExtentCentered: anImage to: (anImage extent * aScale).
	].

	aScale = (1@1) ifTrue: [
		^ anImage
	].
	
	^ anImage magnify: anImage boundingBox by: aScale smoothing: 2.! !

!GLMBrick class methodsFor: 'utils' stamp: 'AliakseiSyrel 2/9/2015 14:32'!
scaleForm: aForm by: aPoint

	aForm ifNil: [ ^ nil ].
	^ aForm magnify: aForm boundingBox by: aPoint smoothing: 2! !

!GLMBrick class methodsFor: 'utils' stamp: 'AliakseiSyrel 2/9/2015 14:32'!
scaleForm: aForm to: aPoint
	|scaleX scaleY|
	
	aForm ifNil: [ ^ nil ].
	scaleX := aPoint x / aForm width.
	scaleY := aPoint y / aForm height.
	^ self scaleForm: aForm by: scaleX @ scaleY.! !

!GLMBrick class methodsFor: 'utils' stamp: 'AliakseiSyrel 2/9/2015 14:32'!
scalePatchForm: aForm size: aPoint
	"aPoint - width and height of new form
	
|form|

form := PatchForm scalePatchForm: (ImageReadWriter formFromFileNamed: 'abc_calculator_button_normal.p.png') size:800@800.
(ImageMorph withForm: form) openInWindow.

form := ImageReadWriter formFromFileNamed: 'abc_calculator_button_normal.png'.
form := PatchForm scaleForm: form by: (800/(form extent x))@(800/(form extent y)).
(ImageMorph withForm: form) openInWindow.
	
	"
	
	|x0 x1 y0 y1 width height newForm tmpForm color bottomHeight rightWidth newMiddleWidth newMiddleHeight|
	
	aForm ifNil: [ ^ nil ].
	
	color := Color red.
	x0 := x1 := y0 := y1 := 0.
	width := aForm extent x.
	height := aForm extent y.
	
	(0 to: width-1) collect: [ :each |
		(aForm colorAt: each@0) = color ifTrue: [ 
			x0 = 0 ifTrue: [ 
				x0 := each.
			]
		] ifFalse:[
			(x0 > 0 & x1 = 0) ifTrue:[
				x1 := each.
			].
		].
	].

	(0 to: height) collect: [ :each |
		(aForm colorAt: 0@each) = color ifTrue: [ 
			y0 = 0 ifTrue: [ 
				y0 := each.
			]
		] ifFalse:[
			(y0 > 0 & y1 = 0) ifTrue:[
				y1 := each.
			].
		].
	].

	rightWidth := width - x1 -1.
	bottomHeight := height - y1 - 1.
	newMiddleWidth := aPoint x - x0 - rightWidth + 1.
	newMiddleHeight := aPoint y - y0 - bottomHeight + 1.
	
	newForm := Form extent: aPoint depth: aForm depth.
	"left top corner"
	newForm copyBits: (1@1 corner: x0@y0)
		from: aForm at: 0@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"left bottom corner"
	newForm copyBits: (1@y1 corner: x0@(height - 1))
		from: aForm at: 0@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"right top corner"
	newForm copyBits: (x1@1 corner: (width-1)@y0)
		from: aForm at: (aPoint x - rightWidth)@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"right bottom corner"
	newForm copyBits: (x1@y1 corner: (width - 1)@(height - 1))
		from: aForm at: (aPoint x - rightWidth)@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"top middle block"
	tmpForm := aForm copy: (x0@1 corner: x1@y0).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@1.
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
		
	"bottom middle block"
	tmpForm := aForm copy: (x0@y1 corner: x1@height).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@1.
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"left middle block"
	tmpForm := aForm copy: (1@y0 corner: x0@y1).
	tmpForm := self scaleForm: tmpForm by: 1@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: 0@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"right middle block"
	tmpForm := aForm copy: (x1@y0 corner: width@y1).
	tmpForm := self scaleForm: tmpForm by: 1@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (aPoint x - rightWidth)@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
		
	"middle block"
	tmpForm := aForm copy: (x0@y0 corner: x1@y1).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	^ newForm.
	
! !

!GLMBrick methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/21/2015 12:25'!
bounds

	^ self globalBounds! !

!GLMBrick methodsFor: 'morph-drawing' stamp: 'AliakseiSyrel 1/20/2015 21:05'!
changed
	"Report that the area occupied by this morph should be redrawn.
	Fixed to include submorphs outside the outerBounds."
	
	"fixed direct reference to fullBounds, causing wrong results, because fullBounds are not being updated when parent's or child's bounds changed"
	^ self fullBounds 
		ifNil: [self invalidRect: self privateFullBounds]
		ifNotNil: [self invalidRect: self fullBounds]! !

!GLMBrick methodsFor: 'morph-drawing' stamp: 'AliakseiSyrel 1/21/2015 17:20'!
drawOn: aCanvas
	super drawOn: aCanvas.
	
	"translating canvas coordinates"
	 (aCanvas isKindOf: ClippingCanvas) ifTrue: [ ^self "no need to draw anything" ].
	self onDraw: (aCanvas copy setOrigin: (aCanvas origin + self globalBounds origin - self brickBounds origin) clipRect: (aCanvas clipRect translateBy: aCanvas origin))! !

!GLMBrick methodsFor: 'morph-drawing' stamp: 'AliakseiSyrel 1/23/2015 13:16'!
drawSubmorphsOn: aCanvas
	| area zIndexedBricks |
	
	self submorphs isEmpty ifTrue: [ ^ self ].

	"make sure my children will not go away of my inner bounds (we take care about paddings)"
	area := aCanvas clipRect intersect: self globalInnerBounds ifNone: (0 @ 0 extent: 0 @ 0).
	"do smart drawing logic here"
	area width = 0 | (area height = 0) ifTrue: [ 
			"draw nothing"
			^ self ].
	
	zIndexedBricks := OrderedCollection new.
	
	self subbricks
		do: [ :each | 
			| intersection canvas globalBounds |
			each ifNotNil: [ self flag: 'fix nil case'.
			globalBounds := each isBrick
				ifTrue: [ each globalBounds ]
				ifFalse: [ each fullBounds ].
				
			(area intersects: globalBounds) ifTrue: [
				| zIndex |
				zIndex := each layoutProperties zIndex.
				zIndex = 1 ifTrue: [
					"immediately draw ones with the lowest possible z-index.
					With this approach performance doesn't degrade"
					intersection := area intersect: globalBounds ifNone: (0 @ 0 extent: 0 @ 0).
					canvas := aCanvas copyClipRect: intersection.
					each fullDrawOn: canvas ]
					"if z-index is not 1 we add it to collection, in order to sort and draw as second attempt"
				ifFalse: [ zIndexedBricks add: each ] ] ] ].
		
		"z-index drawing section"
		zIndexedBricks sort: [ :first :second | first layoutProperties zIndex < second layoutProperties zIndex ].
		
		zIndexedBricks do: [ :each |
			| intersection canvas globalBounds |
			each ifNotNil: [ self flag: 'fix nil case'.
			globalBounds := each isBrick
				ifTrue: [ each globalBounds ]
				ifFalse: [ each fullBounds ].
				
			intersection := area intersect: globalBounds ifNone: (0 @ 0 extent: 0 @ 0).
			canvas := aCanvas copyClipRect: intersection.
			each fullDrawOn: canvas ] ]
		! !

!GLMBrick methodsFor: 'morph-common' stamp: 'AliakseiSyrel 1/20/2015 21:05'!
fullBounds

	^ self globalBounds! !

!GLMBrick methodsFor: 'morph-drawing' stamp: 'AliakseiSyrel 1/20/2015 21:05'!
fullDrawOn: aCanvas
	"fixes bug in canvas, when it tries to draw a morph even if clip rect has size 0"
	aCanvas clipRect width = 0 | (aCanvas clipRect height = 0) ifTrue: [ ^ self ].
	super fullDrawOn: aCanvas.! !

!GLMBrick methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/26/2015 13:12'!
hasProperty: aSymbol 
	
	^ super hasProperty: aSymbol! !

!GLMBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 17:37'!
initialize
	super initialize.
	color := Color transparent.
	submorphs := OrderedCollection new.
	
	self
		layoutProperties: GLMBrickLayoutProperties new;
		useHorizontalLinearLayout;
		renderer: GLMBrickRenderer new! !

!GLMBrick methodsFor: 'brick-testing' stamp: 'AliakseiSyrel 1/20/2015 21:05'!
isFitsInParent

	^ self owner
		"if our owner is a brick"
		ifNotNil: [ self owner globalBounds containsRect: self globalBounds ]
		"if our owner is a morph"
		ifNil: [ self owner ifNotNil: [ self owner bounds containsRect: self globalBounds ] ifNil: [ ^ true ] ]! !

!GLMBrick methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 19:00'!
layoutPolicy

	^ super layoutPolicy! !

!GLMBrick methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 19:01'!
layoutPolicy: aLayout
	
	super layoutPolicy: aLayout! !

!GLMBrick methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/20/2015 19:01'!
layoutProperties
	
	^ super layoutProperties! !

!GLMBrick methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 2/3/2015 10:57'!
layoutProperties: aLayoutProperties 

	super layoutProperties: aLayoutProperties! !

!GLMBrick methodsFor: 'brick-drawing' stamp: 'AliakseiSyrel 1/20/2015 21:05'!
onDraw: aCanvas

	self renderer render: self on: aCanvas. ! !

!GLMBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 1/26/2015 13:14'!
onThemerChanged

	self changed! !

!GLMBrick methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 22:41'!
owner

	^ owner! !

!GLMBrick methodsFor: 'phlow-transmissions' stamp: 'AliakseiSyrel 1/23/2015 21:06'!
ports

	^ ports  ifNil: [ ports := Dictionary new ]! !

!GLMBrick methodsFor: 'private-structure' stamp: 'AliakseiSyrel 1/26/2015 12:47'!
privateOwner: aBrick

	owner := aBrick! !

!GLMBrick methodsFor: 'private-structure' stamp: 'AliakseiSyrel 1/25/2015 15:46'!
privateSubbricks: aCollection

	submorphs := aCollection! !

!GLMBrick methodsFor: 'morph-common' stamp: 'AliakseiSyrel 1/20/2015 21:05'!
removeAllMorphs
	| oldMorphs myWorld |
	"we don't invalidate world"
	myWorld := self world.
	submorphs do: [:m | myWorld ifNotNil: [ m outOfWorld: myWorld ]. m privateOwner: nil].
	oldMorphs := submorphs.
	submorphs := EmptyArray.
	oldMorphs do: [ :m | self removedMorph: m ].
! !

!GLMBrick methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 18:30'!
removeProperty: aSymbol
	
	super removeProperty: aSymbol! !

!GLMBrick methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 18:29'!
setProperty: aSymbol toValue: anObject
	
	super setProperty: aSymbol toValue: anObject! !

!GLMBrick methodsFor: 'brick-structure' stamp: 'AliakseiSyrel 1/20/2015 22:34'!
subbricks

	^ self submorphs! !

!GLMBrick methodsFor: 'morph-common' stamp: 'AliakseiSyrel 1/21/2015 13:21'!
submorphAfter

	^ self subbrickAfter! !

!GLMBrick methodsFor: 'morph-common' stamp: 'AliakseiSyrel 1/21/2015 13:21'!
submorphBefore

	^ self subbrickBefore! !

!GLMBrick methodsFor: 'morph-common' stamp: 'AliakseiSyrel 2/9/2015 14:42'!
taskThumbnailOfSize: thumbExtent
	"Answer a new task thumbnail for the receiver."

	|f t r|
	r := self globalBounds scaledAndCenteredIn: (0@0 extent: thumbExtent).
	f := Form extent: r extent depth: Display depth.
	t := MatrixTransform2x3 withScale: f extent / self extent.
	f getCanvas
		transformBy: t
		clippingTo: f boundingBox
		during: [:c | c translateBy: self globalBounds topLeft negated during: [:ct | self fullDrawOn: ct]]
		smoothing: 2.
	^ImageMorph new
		form: f! !

!GLMBrick methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:16'!
valueOfProperty: aSymbol
	
	^ super valueOfProperty: aSymbol! !

!GLMBrick methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:16'!
valueOfProperty: aSymbol ifAbsent: aBlock
	
	^ super valueOfProperty: aSymbol ifAbsent: aBlock! !

!GLMBrick methodsFor: 'private-extension' stamp: 'AliakseiSyrel 1/20/2015 22:17'!
valueOfProperty: aSymbol ifAbsentPut: aBlock 
	
	^ super valueOfProperty: aSymbol ifAbsentPut: aBlock! !

!GLMBrick methodsFor: 'brick-geometry' stamp: 'AliakseiSyrel 1/29/2015 23:52'!
wrappedBounds

	^ brickBounds ifNil: [ brickBounds := GLMBrickBounds new ]! !

GLMBrick subclass: #GLMCollapsableBrick
	instanceVariableNames: 'headerBrick contentBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-UI'!

!GLMCollapsableBrick class methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/12/2015 17:27'!
createCollapsable

	^ self new
		with: [ :collapsable | 
			collapsable headerBrick:
				(GLMBrick new
					addBrickBack:
						(GLMActionButtonBrick new
							icon: GLMUIThemeExtraIcons glamorousRight;
							marginLeft: 10;
							height: [ :b | b icon height * 1.2 ];
							width: [ :b | b icon width * 1.2 ];
							checkedImage: GLMUIThemeExtraIcons glamorousDown;
							addUpAction: [ :b | 
								collapsable toggle.
								collapsable isExpanded
									ifTrue: [ b check ]
									ifFalse: [ b uncheck ] ]);
					addBrickBack:
						(GLMLabelBrick new
							marginLeft: 10;
							text: 'Header';
							hSpaceFill;
							height: [ :b | b approximateHeight ]);
					vShrinkWrap;
					hSpaceFill) ];
		contentBrick:
			(GLMBrick new
				useVerticalLinearLayout;
				hSpaceFill;
				addAllBricks: {
					(GLMBrick new color: Color random; hSpaceFill).
					(GLMBrick new color: Color random; hSpaceFill).
					(GLMBrick new color: Color random; hSpaceFill).
					(GLMBrick new color: Color random; hSpaceFill)};
				yourself)! !

!GLMCollapsableBrick class methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/12/2015 17:31'!
createCollapsableArray: anInteger

	^ (1 to: anInteger) collect: [ :index | self createCollapsable hSpaceFill  ]! !

!GLMCollapsableBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/12/2015 17:31'!
exampleInScrollPane
	<example>
	
	(GLMScrollPaneBrick new
		addAllBricks: (self createCollapsableArray: 10);
		yourself)
			asBrickedMorph
				extent: 500@300;
				color: (Color r: 249 g: 249 b: 249 range: 255);
				openInWindow! !

!GLMCollapsableBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/12/2015 17:27'!
exampleSimple
	<example>
	(self createCollapsable)
			asBrickedMorph
				extent: 300 @ 500;
				openInWindow! !

!GLMCollapsableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/12/2015 17:08'!
collapse

	self contentBrick ifNil: [ ^ self ].

	self isExpanded
		ifTrue: [ self removeBrick: self contentBrick ]! !

!GLMCollapsableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/12/2015 16:55'!
contentBrick
	^ contentBrick! !

!GLMCollapsableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/12/2015 16:57'!
contentBrick: aBrick
	contentBrick := aBrick.
	
	self contentBrick
		hSpaceFill;
		vShrinkWrap! !

!GLMCollapsableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/12/2015 17:08'!
expand

	self contentBrick ifNil: [ ^ self ].

	self isExpanded
		ifFalse: [ self addBrickBack: self contentBrick ]! !

!GLMCollapsableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/12/2015 16:55'!
headerBrick
	^ headerBrick! !

!GLMCollapsableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/12/2015 17:07'!
headerBrick: aBrick
	headerBrick := aBrick.
	
	self headerBrick hSpaceFill.
	
	self addBrickFirst: self headerBrick! !

!GLMCollapsableBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/12/2015 17:09'!
initialize
	super initialize.
	
	self
		useVerticalLinearLayout;
		vShrinkWrap! !

!GLMCollapsableBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 2/12/2015 16:59'!
isExpanded

	^ self hasSubbrick: self contentBrick! !

!GLMCollapsableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/12/2015 17:24'!
toggle

	self isExpanded
		ifTrue: [ self collapse ]
		ifFalse: [ self expand ]! !

GLMBrick subclass: #GLMCompositeBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMCompositeBrick commentStamp: 'AliakseiSyrel 1/30/2015 10:13' prior: 0!
I'm a composite brick that provides an api of creating different kind of scriptabe presentations like: 
 - list
 - pharoMethod
 - table
 - tree!

!GLMCompositeBrick class methodsFor: 'examples-transmissions' stamp: 'AndreiChis 1/23/2015 18:51'!
exampleExternalLabelChangeOnResize
	<example: 'Table transmission'>
	|first second|
	first := GLMLabelBrick new.
	second := GLMLabelBrick new.
	
	(first transmit)
		from: #brickBounds; toPort: #text:;
		when: [ :value | value extent >= (300@150) ];
		transformed: [ :value | 'resize me!! ', value asString ].
		
	(first transmit)
		from: #brickBounds; to: second port: #extent:;
		transformed: [ :value | value extent ];
		with: [ :secondBrick | secondBrick owner owner extent: secondBrick extent ].
		
	(first transmit)
		from: #label slot: #text;
		to: second port: #text:;
		transformed: [ :value | 'Do not ', value asString ];
		with: [ :label |
			label
				color: Color random muchLighter;
				changed ].
		
	((second 
		textPosition: #center;
		color: Color lightBlue)
			asBrickedMorph
			extent: 300@100;
			openInWindow) position: 200@200.
			
	((first 
		textPosition: #center;
		color: Color lightGreen)
			asBrickedMorph
			extent: 300@200;
			openInWindow)position: 500@500! !

!GLMCompositeBrick class methodsFor: 'examples-transmissions' stamp: 'AliakseiSyrel 1/28/2015 17:15'!
exampleExternalLabelChangeOnResizeMultiple
	<example: 'Transmission from multiple origins'>
	|first second third|
	first := GLMLabelBrick new.
	second := GLMLabelBrick new.
	third := GLMLabelBrick new.
	
	(first transmit + second transmit + third transmit)
		from: #brickBounds; toPort: #text:;
		transformed: [ :value | 'My bounds: ', value asString ].
	
	(third transmit)
		from: first slot: #brickBounds;
		from: second slot: #brickBounds;
		to: [:brick | brick owner owner ] port: #extent:;
		when: [ :firstBounds :secondBounds | firstBounds isNotNil & secondBounds isNotNil ];
		transformed: [ :firstBounds :secondBounds | firstBounds extent + secondBounds extent ].
		
	
	"just showing widgets"
	 ((third 
		textPosition: #center;
		color: Color lightBlue)
			asBrickedMorph
			extent: 300@100;
			openInWindow) position: 500@50.
			
	((second 
		textPosition: #center;
		color: Color lightRed)
			asBrickedMorph
			extent: 300@100;
			openInWindow) position: 50@50.
			
	((first 
		textPosition: #center;
		color: Color lightGreen)
			asBrickedMorph
			extent: 300@200;
			openInWindow)position: 500@300! !

!GLMCompositeBrick class methodsFor: 'examples-transmissions' stamp: 'AndreiChis 1/23/2015 15:03'!
exampleInternalLabelChangeOnResize
	<example: 'Table transmission'>
	|first|
	first := GLMLabelBrick new.
	
	(first transmit)
		from: #brickBounds; toPort: #text:;
		when: [ :value | value extent >= (300@150) ];
		transformed: [ :value | 'resize me!! ', value asString ].
			
	(first 
		textPosition: #center;
		color: Color lightGreen)
			asBrickedMorph
			extent: 300@200;
			openInWindow! !

!GLMCompositeBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/12/2015 17:10'!
exampleList
	<example: 'Phlowr simple list'>
	|composite|
	
	composite := self new.
	composite list
		title: 'Example';
		display: [ :x | x + 3 ];
		format: [ :anInteger | anInteger asString, ')' ];
		entity: (1 to: 100).
	
	composite asBrickedMorph
		extent: 600@400;
		openInWindow! !

!GLMCompositeBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/28/2015 14:38'!
exampleListClassMethods
	<example: 'Phlowr list displaying a list '>
	|composite|
	
	composite := self new.
	composite list
		title: 'Methods of Object';
		display: #yourself;
		format: [ :compiledMethod | compiledMethod gtDisplayString ];
		styled: [ :brick | brick height: 30 ];
		entity: Object methods.
	
	composite asBrickedMorph
		extent: 600@400;
		openInWindow! !

!GLMCompositeBrick class methodsFor: 'examples' stamp: 'AndreiChis 1/23/2015 17:18'!
exampleListWithCustomItem
	<example: 'Phlowr list with custom items'>
	|composite|
	
	composite := self new.
	composite list
		title: 'Example with custom items';
		display: [ :x | x + 3 ];
		format: [ :anInteger | anInteger asString ];
		styled: [ :aBrick | aBrick textPosition: #center; textColor: Color random ];
		entity: (1 to: 100).
	
	composite asBrickedMorph
		extent: 600@400;
		openInWindow! !

!GLMCompositeBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/12/2015 17:10'!
examplePharoMethod
	<example: 'Phlowr Pharo method'>
	|composite|
	
	composite := self new.
	composite pharoMethod
		title: #printString;
		display: #getSource;
		smalltalkClass: #methodClass;
		entity: Morph>>#bounds.
	
	composite asBrickedMorph
		extent: 600@400;
		openInWindow! !

!GLMCompositeBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/12/2015 17:10'!
exampleTable
	<example: 'Phlowr table'>
	|composite|
	
	composite := self new.
	composite table
		title: #asString;
		display: [ :anObject | (anObject gtInspectorVariableValuePairs asSortedCollection asOrderedCollection yourself) addFirst: 'self' -> anObject; yourself ];
		column: 'Variable'
			evaluated: [:assoc |	GTObjectPrinter new asNonTruncatedTextFrom: assoc key ]
			styled: [ :aBrick | aBrick textPosition: #rightCenter; margin: #(0 15 0 0); textColor: Color lightGray ];
		column: 'Variable'
			evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ]
			styled: [ :aBrick | aBrick margin: #(0 0 0 15) ];
		entity: Morph new.
	
	composite asBrickedMorph
		color: Color white;
		extent: 600@400;
		openInWindow! !

!GLMCompositeBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 2/10/2015 14:52'!
custom: aBrick
	self flag: 'for now we only allow one subbrick in the composite.
	We have to revisit this implementation after the composite will allow for multiple subbricks'.
	self hasSubbricks ifFalse: [ self addBrickBack: aBrick ].
	^ aBrick! !

!GLMCompositeBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/30/2015 10:09'!
list

	^ self custom: GLMPhlowListBrick new! !

!GLMCompositeBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/30/2015 10:10'!
pharoMethod

	^ self custom: GLMPhlowPharoMethodBrick new! !

!GLMCompositeBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/30/2015 10:10'!
table

	^ self custom: GLMPhlowTableBrick new! !

!GLMCompositeBrick methodsFor: 'phlow' stamp: 'TudorGirba 2/4/2015 13:39'!
text

	^ self custom: GLMPhlowTextBrick new! !

!GLMCompositeBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/11/2015 14:34'!
tree! !

GLMBrick subclass: #GLMHorizontalBandBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMHorizontalBandBrick commentStamp: 'AliakseiSyrel 12/10/2014 14:22' prior: 0!
A GLMHorizontalBandBrick is a simple Brick with width and bounds to fit all subbricks.
Usually used within horizontal scroll panes!

!GLMHorizontalBandBrick methodsFor: 'layout brick' stamp: 'AliakseiSyrel 12/10/2014 14:21'!
doLayout
	
	self layoutChildren.

	self subbricks do: [ :each | each isBrick ifTrue: [ each doLayout ] ]! !

!GLMHorizontalBandBrick methodsFor: 'layout brick' stamp: 'AliakseiSyrel 1/21/2015 13:22'!
layoutChildren

	|mBounds mOwner|
	"most of the time you don't want to call this method manually"
	"nice example to check is GLMLabelBrick>>doLayout"
	
	mOwner := self owner ifNil: [ self ] ifNotNil: [ self owner ].
	mBounds := mOwner isBrick ifTrue: [ mOwner globalInnerBounds ] ifFalse: [ mOwner globalBounds ].
	
	^ self layoutPolicy layout: self in: mBounds.! !

!GLMHorizontalBandBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/4/2015 18:13'!
width
	|width|
	self widthBlock ifNotNil: [ ^ self widthBlock cull: self ].
		
	width := self hPadding.
	self subbricks do: [ :each | width := width + each width + each hMargin ].
	^ width! !

GLMBrick subclass: #GLMInteractableBrick
	instanceVariableNames: 'normalImage pressedImage selectedImage checkedImage announcer checkedColor normalColor pressedColor selectedColor isSelected isPressed isChecked isEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMInteractableBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:08' prior: 0!
A GLMInteractableBrick is a subclass of GLMBrick to allow user interactions such as: mouseLeave, mouseEnter, mouseDown, mouseUp and for each state can change background color or background image, that resizes accordinately to Brick's size

Instance Variables
	announcer:		<Object>
	checkedColor:		<Object>
	checkedImage:		<Object>
	isChecked:		<Object>
	isEnabled:		<Object>
	isPressed:		<Object>
	isSelected:		<Object>
	normalColor:		<Object>
	normalImage:		<Object>
	pressedColor:		<Object>
	pressedImage:		<Object>
	selectedColor:		<Object>
	selectedImage:		<Object>

announcer
	- xxxxx

checkedColor
	- xxxxx

checkedImage
	- xxxxx

isChecked
	- xxxxx

isEnabled
	- xxxxx

isPressed
	- xxxxx

isSelected
	- xxxxx

normalColor
	- xxxxx

normalImage
	- xxxxx

pressedColor
	- xxxxx

pressedImage
	- xxxxx

selectedColor
	- xxxxx

selectedImage
	- xxxxx
!

GLMInteractableBrick subclass: #GLMActionButtonBrick
	instanceVariableNames: 'action hoverAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMActionButtonBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:08' prior: 0!
A GLMActionButtonBrick is a button for Glamour actions, used in Tabbed presentations

Instance Variables
	action:		<Object>

action
	- xxxxx
!

!GLMActionButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 16:19'!
action: anAction

	action := anAction.
	
	self normalImage: action icon.
	self pressedColor: Color veryVeryLightGray! !

!GLMActionButtonBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 2/11/2015 13:28'!
addHoverAction: anObject

	hoverAction := anObject! !

!GLMActionButtonBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 15:56'!
addUpAction: anActionOrBlock

	anActionOrBlock isBlock
		ifTrue: [ action := anActionOrBlock ]
		ifFalse: [ self action: anActionOrBlock ]! !

!GLMActionButtonBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/11/2015 12:42'!
click: evt
	
	action ifNil: [ ^ false ].
	action isBlock
		ifTrue: [ action cull: self ]
		ifFalse: [ action performOn: self data ].
	
	^ true! !

!GLMActionButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/11/2015 11:11'!
icon

	^ self normalImage! !

!GLMActionButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 15:53'!
icon: anImage

	self normalImage: anImage.! !

!GLMActionButtonBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 16:19'!
initialize
	super initialize.
	
	self enable.! !

!GLMActionButtonBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/11/2015 13:29'!
select
	super select.
	
	hoverAction ifNotNil: [ :a | a cull: self ]! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
normalColorOf: aTrick
	^ self pressedColor: false selectedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
normalOf: aTrick
	^ self pressed: false selected: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
pressed: isPressed of: aTrick
	^ self pressed: isPressed selected: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 11/27/2014 12:58'!
pressed: isPressed selected: isSelected checked: isChecked of: aTrick
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & aTrick pressedImage notNil)
		ifTrue: [ ^ aTrick pressedImage ].
	
	(isChecked & aTrick checkedImage notNil)
		ifTrue: [ ^ aTrick checkedImage ].
		
	(((isPressed & aTrick pressedImage isNil) | isSelected) & aTrick selectedImage notNil)
		ifTrue: [ ^ aTrick selectedImage ].
	
	^ aTrick normalImage.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressed: isPressed selected: isSelected of: aTrick
	^ self pressed: isPressed selected: isSelected checked: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressedColor: isPressed of: aTrick
	^ self pressedColor: isPressed selectedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 11/27/2014 12:59'!
pressedColor: isPressed selectedColor: isSelected checkedColor: isChecked of:aTrick
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & aTrick pressedColor notNil)
		ifTrue: [ ^ aTrick pressedColor ].
		
	(isChecked & aTrick checkedColor notNil)
		ifTrue: [ ^ aTrick checkedColor ].
		
	(((isPressed & aTrick pressedColor isNil) | isSelected) & aTrick selectedColor notNil)
		ifTrue: [ ^ aTrick selectedColor ].

	
	^ aTrick normalColor.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressedColor: isPressed selectedColor: isSelected of: aTrick
	^ self pressedColor: isPressed selectedColor: isSelected checkedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
selected: isSelected of: aTrick
	^ self pressed: false selected: isSelected of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
selectedColor: isSelected of: aTrick
	^ self pressedColor: false selectedColor: isSelected of: aTrick! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
check
	self isChecked ifFalse: [
		isChecked := true.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedColor
	^ checkedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedColor: anObject
	checkedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedImage
	^ checkedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedImage: anObject
	checkedImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:47'!
click: evt
	^ false! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
currentColor
	^ self state pressedColor: (self isPressed) selectedColor: (self isSelected) checkedColor: (self isChecked) of: self! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
currentImage
	^ self state pressed: (self isPressed) selected: (self isSelected) checked: (self isChecked) of: self! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
depress
	self isPressed ifTrue: [
		isPressed := false.
		self changed.
		^ true
	].

	^ false! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 23:33'!
deselect
	self isSelected ifTrue: [
		isSelected := false.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
disable
	isEnabled := false.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
enable
	
	isEnabled := true.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:10'!
handlesMouseDown: evt
	
	^ self isEnabled
		ifTrue: [ true ]
		ifFalse: [ super handlesMouseDown: evt ]
	! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:00'!
handlesMouseOver: evt
	^ self isEnabled
		ifTrue: [ true ]
		ifFalse: [ super handlesMouseDown: evt ]! !

!GLMInteractableBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 12/20/2014 16:30'!
initialize
	super initialize.
	
	isChecked := false.
	isPressed := false.
	isSelected := false.
	
	self renderer: GLMInteractableBrickRenderer new.
	
	self disable.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
isChecked
	^ isChecked.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isEnabled
	^ isEnabled! !

!GLMInteractableBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/11/2014 14:06'!
isFocused

	^ false! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isPressed
	^ isPressed.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isSelected
	^ isSelected.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:06'!
mouseDown: evt
	super mouseDown: evt.
	^ self press.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:22'!
mouseEnter: evt
	super mouseEnter: evt.
	^ self select! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:22'!
mouseLeave: evt
	super mouseLeave: evt.
	^ self deselect! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/23/2014 20:00'!
mouseUp: evt
	super mouseUp: evt.
	(self bounds containsPoint: evt position) & (self isPressed) ifTrue: [
		self depress.
		^ self click: evt
	] ifFalse: [
		self deselect.
		^ self depress.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalColor
	^ normalColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalColor: anObject
	normalColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalImage
	^ normalImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalImage: anObject
	normalImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
press
	self isPressed ifFalse: [
		isPressed := true.
		self changed.
	].

	^ false! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedColor
	^ pressedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedColor: anObject
	pressedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedImage
	^ pressedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
pressedImage: anObject
	pressedImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 23:33'!
select
	self isSelected ifFalse: [ 
		isSelected := true.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
selectedColor
	^ selectedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedColor: anObject
	selectedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedImage
	^ selectedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedImage: anObject
	selectedImage := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
state

	^ self class! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
uncheck
	self isChecked ifTrue: [
		isChecked := false.
		self changed.
	]! !

GLMInteractableBrick subclass: #GLMLabelBrick
	instanceVariableNames: 'isDotsAdded dotsBrick stringBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMLabelBrick commentStamp: 'AliakseiSyrel 10/18/2014 14:18' prior: 0!
A GLMLabelBrick is standard label Brick, that can shrink text if it's size becomes smaller then actual text size.

Text shrinking works out of box, you don't need to do anything

Instance Variables
	dotsBrick		<GLMStringBrick>
	isDotsAdded:		<boolean>
	stringBrick rick		<GLMStringBrick>

dotsBrick
	- represents a Brick that is added at the end of the text when Brick's size becomes smaller than actual text size

isDotsAdded
	- true if dotsBrick is currently added visible, false otherwise

stringBrick
	- represents actual label text Brick
!

!GLMLabelBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/8/2015 17:42'!
example
	"this example must be called on my subclasses"
	| rootBrick brick1 brick2 brick3 |
	
	rootBrick := GLMInteractableBrick new
		useVerticalLinearLayout;
		height: 400;
		width: 400;
		enable;
		selectedColor: Color blue darker;
		color: Color blue;
		paddingLeft: 10;
		paddingTop: 15;
		paddingRight: 20;
		paddingBottom: 5.
	
	" ---- Creating first brick ---- "
	brick1 := GLMStringBrick new
		text: 'Welcome to Brick!!';
		textColor: Color white;
		textPosition: #center;
		color: Color green;
		selectedColor: Color darkGray;
		normalColor: Color red;
		pressedColor: Color gray;
		enable;
		hSpaceFill: 30;
		height: 30.		
		
	" ---- Creating second brick ---- "
	brick2 := GLMInteractableBrick new
		color: Color green;
		selectedColor: Color pink;
		normalColor: Color green;
		pressedColor: Color lightGray;
		enable;
		margin: #(15 20 5 10);
		hSpaceFill: 50;
		vSpaceFill: 50.
		
		
	" ---- Creating third brick ---- "
	brick3 := GLMStringBrick new
		text: 'Welcome to Brick!!';
		textColor: Color black;
		color: Color yellow;
		margin: #(15 20 5 10);
		hSpaceFill: 20;
		vSpaceFill: 20.
		
		
	" ---- Add them to the root brick ---- "
	rootBrick
		addBrickBack: brick1;
		addBrickBack: brick2;
		addBrickBack: brick3.
	
	rootBrick asBrickedMorph openInWindow! !

!GLMLabelBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/11/2015 12:31'!
approximateHeight
	
	^ self label approximateHeight + self vMargin + self vPadding! !

!GLMLabelBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/11/2015 12:28'!
approximateWidth
	
	^ self label approximateWidth + self hMargin + self hPadding! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 17:26'!
contents: aStringOrText

	self text: aStringOrText asString! !

!GLMLabelBrick methodsFor: 'default values' stamp: 'AliakseiSyrel 10/16/2014 14:33'!
defaultDotsText
	^ '...'! !

!GLMLabelBrick methodsFor: 'default values' stamp: 'AliakseiSyrel 10/16/2014 14:03'!
defaultInsetBeforeDots
	^ 1! !

!GLMLabelBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 2/8/2015 16:31'!
doLayout
	"contolls logic of text schrinking"
	|isFit|
	self flag: 'fix me'.
	super doLayout.
	
	"checking if label text fits in me"
	"isFit := self label isFitsInParent.
	
	(isFit & (self isDotsAdded not)) ifTrue: [ ^ self ].
	(isFit not & self isDotsAdded) ifTrue: [ ^ self ].
	
	(isFit & self isDotsAdded) ifTrue: [
		self removeBrick: self dotsBrick.
		isDotsAdded := false.
		super doLayout.
	] ifFalse: [ 
		self addBrickBack: self dotsBrick.
		isDotsAdded := true.
		super doLayout.
	]"
	! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:00'!
dotsBrick

	^ dotsBrick! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/24/2015 01:19'!
familyName: aString

	self label familyName: aString.
	self dotsBrick familyName: aString! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/24/2015 01:20'!
fontSize: aNumber

	self label fontSize: aNumber.
	self dotsBrick fontSize: aNumber! !

!GLMLabelBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 13:46'!
initialize
	super initialize.
	
	stringBrick := self privateAddBrickBack: (
		self newStringBrick
			hSpaceFill;
			vSpaceFill;
			marginRight: self defaultInsetBeforeDots).
	
	"creating dots morph, that will be displayed when text is being clipped"
	dotsBrick := self newStringBrick.
	dotsBrick text: self defaultDotsText.
	dotsBrick fontSize: 9.
	dotsBrick width: [ :b | b approximateWidth ].
	dotsBrick vSpaceFill.
	
	isDotsAdded := false.
	! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 14:05'!
isDotsAdded
	^ isDotsAdded! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:00'!
label
	^ stringBrick! !

!GLMLabelBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/17/2014 09:59'!
newStringBrick
	^ GLMStringBrick new! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 14:09'!
text
	^ self label text! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/5/2014 16:44'!
text: aString

	self label text: aString! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:29'!
textColor: aColor

	self label textColor: aColor.
	self dotsBrick textColor: aColor! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:21'!
textPosition: aSymbol

	self label textPosition: aSymbol.
	self dotsBrick textPosition: aSymbol.! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:42'!
weightValue: anInteger

	self label weightValue: anInteger.
	self dotsBrick weightValue: anInteger.! !

GLMInteractableBrick subclass: #GLMPopupBrick
	instanceVariableNames: 'anchorBrick triggerBrick contentBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-UI'!

!GLMPopupBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/11/2015 14:17'!
createButton: hoverAction

	^ (GLMActionButtonBrick new
			color: Color white;
			icon: GLMUIThemeExtraIcons glamorousBrowse;
			addHoverAction: hoverAction;
			width: [ :b | b icon width * 2 ];
			height: [ :b | b icon height * 2 ])! !

!GLMPopupBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/12/2015 17:08'!
exampleAll
	<example: 'all types'>

	(GLMBrick new
		addBrickBack: (self createButton: [ :b | self new openFor: b ]);
		addBrickBack: (self createButton: [ :b | self new beHelp; openFor: b ]);
		addBrickBack: (self createButton: [ :b | self new beError; openFor: b ]);
		addBrickBack: (self createButton: [ :b | self new beSuccess; openFor: b ]);
		marginTop: 35)
			asBrickedMorph
				extent: 300@120;
				openInWindow! !

!GLMPopupBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/11/2015 14:00'!
exampleError
	<example: 'Popup brick example with anchor'>

	self openExample: [ :b | self new beError; openFor: b ]! !

!GLMPopupBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/11/2015 13:59'!
exampleHelp
	<example: 'Popup brick example with anchor'>

	self openExample: [ :b | self new beHelp; openFor: b ]! !

!GLMPopupBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/11/2015 13:59'!
exampleNormal
	<example: 'Popup brick example with anchor'>

	self openExample: [ :b | self new openFor: b ]! !

!GLMPopupBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/11/2015 14:00'!
exampleSuccess
	<example: 'Popup brick example with anchor'>

	self openExample: [ :b | self new beSuccess; openFor: b ]! !

!GLMPopupBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/11/2015 14:24'!
openExample: hoverAction
	|root|
	
	root := GLMBrick new marginTop: 35.
	1 to: 4 do: [ :i | root addBrickBack: (self createButton: hoverAction) ].
			
	root
		asBrickedMorph
			extent: 300@100;
			openInWindow! !

!GLMPopupBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 15:31'!
anchorBrick

	^ anchorBrick! !

!GLMPopupBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 15:31'!
anchorBrick: aBrick

	anchorBrick := aBrick! !

!GLMPopupBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/11/2015 13:55'!
beError

	self themer: self themer popupErrorThemer themer! !

!GLMPopupBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/11/2015 13:55'!
beHelp

	self themer: self themer popupHelpThemer themer! !

!GLMPopupBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/11/2015 13:55'!
beSuccess

	self themer: self themer popupSuccessThemer themer! !

!GLMPopupBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/11/2015 12:51'!
contentBrick

	^ contentBrick

	! !

!GLMPopupBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/11/2015 13:56'!
contentBrick: aBrick

	contentBrick := aBrick.
	self contentBrick
		color: self themer popupThemer backgroundColor; 
		borderColor: self themer popupThemer borderColor;
		textColor: self themer popupThemer textColor;
	 	borderWidth: self themer popupThemer borderWidth.
	self addBrickBack: contentBrick

	! !

!GLMPopupBrick methodsFor: 'events-processing' stamp: 'AliakseiSyrel 2/11/2015 13:22'!
handleListenEvent: anEvent
	
	(self triggerBrick boundsInWorld containsPoint: anEvent position) |
		(self contentBrick boundsInWorld containsPoint: anEvent position) ifFalse: [
			(self owner isKindOf: GLMFoundationBrick)
				ifTrue: [ self owner delete ]
				ifFalse: [ self delete ] ]! !

!GLMPopupBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/11/2015 13:55'!
initialize
	super initialize.
	
	self
		initializeListeners;
		useVerticalLinearLayout;
		vShrinkWrap;
		hShrinkWrap;
		enable.
	
	
	! !

!GLMPopupBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/11/2015 13:14'!
initializeListeners

	"using the most general event subscribtion for all events spawned by the hand"
	self activeHand addEventListener: self.! !

!GLMPopupBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/11/2015 13:08'!
newContentBrick

	^ GLMLabelBrick new
		text: 'Press CMD+Right';
		padding: #(10 10);
		width: [ :b | b approximateWidth ];
		height: [ :b | b approximateHeight ]! !

!GLMPopupBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/11/2015 12:56'!
newTriggerBrick

	^ GLMActionButtonBrick new
		icon: (self anchorBrick
			ifNil: [ GLMUIThemeExtraIcons glamorousExample ]
			ifNotNil: [ self anchorBrick brickTransparentImageForm ]);
		width: [ :b | b icon width ];
		height: [ :b | b icon width ]! !

!GLMPopupBrick methodsFor: 'opening' stamp: 'AliakseiSyrel 2/11/2015 13:57'!
openAbove: aRectangle
	"aRectangle must be in global coordinates"
	self asBrickedMorph
		bounds: ((aRectangle origin - (0@self contentBrick height) + (0@self themer popupThemer borderWidth)) extent: self extent);
		openInWorld
	! !

!GLMPopupBrick methodsFor: 'opening' stamp: 'AliakseiSyrel 2/11/2015 13:55'!
openFor: aBrick

	self anchorBrick: aBrick.
	self contentBrick: self newContentBrick.
	self triggerBrick: self newTriggerBrick.
	
	aBrick ifNotNil: [ self openAbove: aBrick boundsInWorld ]! !

!GLMPopupBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/11/2015 13:14'!
outOfWorld: aWorld
	super outOfWorld: aWorld.
	
	self unsubscribeListeners! !

!GLMPopupBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/11/2015 13:03'!
triggerBrick

	^ triggerBrick! !

!GLMPopupBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/11/2015 13:57'!
triggerBrick: aBrick

	triggerBrick := aBrick.
	self triggerBrick
		color: self themer popupThemer backgroundColor;
		borderColor: self themer popupThemer borderColor;
		borderWidth: self themer popupThemer borderWidth;
		borderDo: [ :b | b widthTop: 0 ];
		marginTop: self themer popupThemer borderWidth negated.
		
	self addBrickBack: self triggerBrick.! !

!GLMPopupBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/11/2015 13:15'!
unsubscribeListeners

	self activeHand removeEventListener: self! !

GLMInteractableBrick subclass: #GLMStringBrick
	instanceVariableNames: '#font #familyName #fontSize #textSize #text => GLMPhlowSlot #textColor #textPosition #highlightedString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMStringBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:06' prior: 0!
A GLMStringBrick is low level String Brick. Text can't be drawn outside of Brick's bounds, which makes it very usefull for smart text shrinking.

Instance Variables
	familyName:		<Object>
	font:		<Object>
	fontSize:		<Object>
	text:		<Object>
	textColor:		<Object>
	textPosition:		<Object>
	textSize:		<Object>

familyName
	- xxxxx

font
	- xxxxx

fontSize
	- xxxxx

text
	- xxxxx

textColor
	- xxxxx

textPosition
	- xxxxx

textSize
	- xxxxx
!

!GLMStringBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/3/2015 14:59'!
example
	<example>
	| brick brick1 brick2 brick3|
	brick := GLMBrick new
		color: Color blue;
		width: 400;
		height: 300.
		
	brick1 := self new
		color: Color red;
		hSpaceFill: 75;
		vSpaceFill: 25;
		textPosition: #center;
		text: 'Brick 1'.
	
	brick2 := self new
		color: Color green;
		hSpaceFill: 25;
		vSpaceFill: 75;
		textPosition: #center;
		text: 'Brick 2'.
	
	brick3 := self new
		color: Color yellow;
		width: 50;
		height: 50;
		textPosition: #center;
		text: 'Brick 3'.
	
	brick
		addBrickBack: brick1;
		addBrickBack: brick2;
		addBrickBack: brick3.
		
	brick asBrickedMorph
		color: Color white;
		openInWindow! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/11/2015 12:33'!
approximateHeight

	^ self font height + self vMargin + self vPadding! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/3/2015 11:20'!
approximateWidth

	^ self textSize x + self hMargin + self hPadding! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 17:21'!
calculateHighlightingBounds
	|textBounds highlightBounds last|
	
	highlightBounds := OrderedCollection new.
	
	textBounds := (self calculateTextPosition extent: self textSize) translateBy: (0@0)negated.
	
	last := self text asLowercase findString: self highlightedText asLowercase startingAt: 1.
	last = 0 ifTrue: [^ highlightBounds].
	[last > 0] whileTrue: [ |beforeHighlightTextSize highlightSize matchingString|		
		matchingString := self text copyFrom: last to: last + self highlightedText size - 1.
		highlightSize := self sizeOf: matchingString.
		beforeHighlightTextSize := self sizeOf: (self text first: (last - 1)).
		highlightBounds add: ((textBounds translateBy: ((beforeHighlightTextSize x)@0)) withWidth: highlightSize x).
		last := self text asLowercase findString: self highlightedText asLowercase startingAt: last + 1 ].
	
	^ highlightBounds! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 17:21'!
calculateTextPosition

	self textPosition = #leftCenter ifTrue: [ 
		^ (self brickBounds origin + self textPositionVerticalCenter) floor
	].

	self textPosition = #center ifTrue: [ 
		^ (self brickBounds origin + self textPositionVerticalCenter + self textPositionHorizontalCenter)floor
	].

	self textPosition = #leftTop ifTrue: [
		^ self brickBounds origin
	].

	self textPosition = #rightCenter ifTrue: [
		^ ((self brickBounds topRight + self textPositionVerticalCenter - (self textSize x@0)) max: self brickBounds origin) floor
	].

	^ self brickBounds origin! !

!GLMStringBrick methodsFor: 'defaults' stamp: 'AliakseiSyrel 12/20/2014 15:18'!
defaultFamilyName

	^ self theme labelFont familyName! !

!GLMStringBrick methodsFor: 'defaults' stamp: 'AliakseiSyrel 10/17/2014 10:31'!
defaultSize
	^ self theme labelFont pointSize! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 15:14'!
familyName
	^ familyName! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:04'!
familyName: aString
	familyName := aString.
	self updateFont.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:06'!
font

	^ font! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 16:34'!
font: aFont

	font := aFont.
	
	aFont ifNil: [ self updateFont ].
	
	familyName := font familyName.
	fontSize := font pointSize.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:04'!
fontSize
	^ fontSize! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:05'!
fontSize: aNumber
	fontSize := aNumber.
	self updateFont.! !

!GLMStringBrick methodsFor: 'public' stamp: 'AliakseiSyrel 12/4/2014 10:39'!
highlight: aString

	highlightedString := aString! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 10:34'!
highlightedText
	
	^ highlightedString ifNil: [ highlightedString := '' ]! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/12/2015 12:32'!
highlightingLogic
	"[ :aCanvas :aRectangle ]"
	
	^ self valueOfProperty: #brickHighlightingLogic ifAbsentPut: [
		[ :aCanvas :aRectangle | |rectangle|
			"because font calculates text width wrong"
			rectangle := aRectangle translateBy: (-3@0).
			aCanvas line: rectangle bottomLeft to: rectangle bottomRight width: 1 color: self textColor ] ] ! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 11:17'!
highlightingLogic: aBlockWithTwoParameters
	"[ :aCanvas :aRectangle ]"
	
	self setProperty: #brickHighlightingLogic toValue: aBlockWithTwoParameters! !

!GLMStringBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/30/2015 12:34'!
initialize
	super initialize.
	
	fontSize := self defaultSize.
	familyName := self defaultFamilyName.
	text := ''.
	
	textPosition := #leftCenter.
	
	self updateFont.
	! !

!GLMStringBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 2/3/2015 11:22'!
isFitsInParent

	^ self owner
		ifNil: [ self brickBounds containsRect: (self outerBounds origin extent: self textSize) ]
		ifNotNil: [
			self owner brickBounds extent >= self textSize ]
				! !

!GLMStringBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 1/12/2015 17:17'!
onDraw: aCanvas

	super onDraw: aCanvas.
	
	self calculateHighlightingBounds do: [ :each |
		self highlightingLogic
			ifNil: [ aCanvas line: each bottomLeft to: each bottomRight width: 1 color: self textColor ]
			ifNotNil: [ self highlightingLogic cull: aCanvas cull: each ] ].
	
	aCanvas
		drawString: self text
		at: self calculateTextPosition
		font: self font
		color: self textColor! !

!GLMStringBrick methodsFor: 'private' stamp: 'AliakseiSyrel 1/22/2015 22:17'!
privateSetText: aString

	text := aString asString.
	textSize := nil.! !

!GLMStringBrick methodsFor: 'public' stamp: 'AliakseiSyrel 1/12/2015 17:17'!
sizeOf: aString

	^ (self font widthOfString: aString) @ self font height! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:12'!
text

	^ text! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/7/2015 23:48'!
text: aString

	self privateSetText: aString! !

!GLMStringBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 12:34'!
textColor

	^ self valueOfProperty: #brickTextColor ifAbsent: [ self themer textColor ]! !

!GLMStringBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 12:33'!
textColor: aColor

	self setProperty: #brickTextColor toValue: aColor.
	self updateFont.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 01:13'!
textPosition

	^ textPosition! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:19'!
textPosition: aSymbol
	"supported:
	#leftCenter
	#center
	#leftTop
	"
	textPosition := aSymbol.! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/12/2015 17:18'!
textPositionHorizontalCenter

	^ (((self brickBounds width - self textSize x) max: 0) /2)@0! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/12/2015 17:18'!
textPositionVerticalCenter

		^ (0@(self brickBounds height / 2)) - (0@(self fontSize/2)) - (0@3)
	! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:13'!
textSize

	^ textSize ifNil: [ textSize := self sizeOf: self text ]! !

!GLMStringBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/18/2014 16:33'!
updateFont
	font := LogicalFont familyName: self familyName pointSize: self fontSize.! !

GLMInteractableBrick subclass: #GLMTabLabelBrick
	instanceVariableNames: 'tabSelector normalLabel selectedLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMTabLabelBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:06' prior: 0!
A GLMTabLabelTurboBrick is  single resizable Tab Label used in LazyTabGroupMorph.

Instance Variables
	normalLabel:		<Object>
	selectedLabel:		<Object>
	tabSelector:		<Object>

normalLabel
	- xxxxx

selectedLabel
	- xxxxx

tabSelector
	- xxxxx
!

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
adoptPaneColor: paneColor
	"Use the theme for fillStyle and border."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self isSelected
		ifTrue: [self theme tabLabelSelectedBorderStyleFor: self]
		ifFalse: [self theme tabLabelNormalBorderStyleFor: self]! !

!GLMTabLabelBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
deselect
	self layoutProperties minWidth: 0.
	self brickRoot changed.
	self brickRoot doLayout.
	self brickRoot changed.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
fillStyleToUse
	"Answer the basic fill style for the receiver."

	^self isSelected
		ifTrue: [self selectedFillStyle] 
		ifFalse: [self normalFillStyle]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
font: aFont
	"Set the label font"

	self normalLabel allMorphsDo: [:m |
		(m respondsTo: #font:) ifTrue: [m font: aFont]].
	self selectedLabel allMorphsDo: [:m |
		(m respondsTo: #font:) ifTrue: [m font: aFont]]! !

!GLMTabLabelBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 23:26'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse.
	
	self enable.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
isSelected
	"Answer whether the tab is selected."

	^self tabSelector
		ifNil: [false]
		ifNotNil: [:selector | selector selectedTab == self]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
label
	"Answer the label contents."

	^self isSelected
		ifTrue: [self selectedLabel userString ifNil: [self firstSubmorph]]
		ifFalse: [self normalLabel userString ifNil: [self firstSubmorph]]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 00:06'!
label: aBrick
	"Change the label contents"
	
	aBrick hSpaceFill.
	self maxWidth: aBrick layout maxWidth.

	self
		normalLabel: aBrick;
		selectedLabel: aBrick;
		selected: self isSelected! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/10/2015 00:06'!
label: aBrick selected: aSelectedBrick
	"Change the label contents"

	aBrick hSpaceFill.
	aBrick vSpaceFill.
	aSelectedBrick hSpaceFill.
	aSelectedBrick vSpaceFill.
	
	self maxWidth: aBrick layout maxWidth.
	
	self
		normalLabel: aBrick;
		selectedLabel: aSelectedBrick;
		selected: self isSelected! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/2/2014 17:13'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^ self theme tabLabelNormalFillStyleFor: self! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
normalLabel

	^ normalLabel! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
normalLabel: anObject

	normalLabel := anObject! !

!GLMTabLabelBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/10/2015 00:14'!
select
	self minWidth: [ (self label layout maxWidth brickValue: self label) min: self brickRoot width ].
	self brickRoot doLayoutForce.
	self brickRoot changed.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
selected: aBoolean
	"Use the appropriate label."

	self removeAllBricks.
	self isSelected
		ifTrue: [self addBrickBack: self selectedLabel]
		ifFalse: [self addBrickBack: self normalLabel]! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/2/2014 17:13'!
selectedFillStyle
	"Return the selected fillStyle of the receiver."
	
	^ self theme tabLabelSelectedFillStyleFor: self! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
selectedLabel

	^ selectedLabel! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
selectedLabel: anObject

	selectedLabel := anObject! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
tabSelector

	^ tabSelector! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
tabSelector: anObject

	tabSelector := anObject! !

GLMBrick subclass: #GLMMorphBrick
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Morphic'!

!GLMMorphBrick commentStamp: 'AliakseiSyrel 1/30/2015 10:14' prior: 0!
A GLMMorphBrick is used as container for morphs to embed them inside bricks

Instance Variables
	morph:		<Morph>

morph
	- xxxxx
!

!GLMMorphBrick class methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 17:02'!
on: aMorph

	^ self new on: aMorph! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/30/2015 15:26'!
addBrickBack: aBrick
	|link|
	link := aBrick asDoubleLink.
	aBrick brickDoubleLink: link.
	
	self hasSubbricks ifTrue: [
		self lastSubbrick brickDoubleLink nextLink: link.	
		link previousLink: self lastSubbrick brickDoubleLink.
	].
	
	self privateSubbricks: (self subbricks copyWith: aBrick).
	aBrick privateOwner: self.! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/30/2015 15:12'!
brickBounds: aRectangle
	|origin corner newBounds|
	super brickBounds: aRectangle.
	
	origin := self paddingLeft @ self paddingTop.
	corner := self paddingRight @ self paddingBottom.
	newBounds := self globalBounds.
	newBounds := ((newBounds origin + origin) corner: (newBounds corner - corner)).
	
	self morph bounds: newBounds! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/21/2015 17:32'!
drawSubmorphsOn: aCanvas
	
	self morph fullDrawOn: (aCanvas copy setOrigin: (aCanvas origin + self bounds origin - self morph bounds origin) clipRect: (aCanvas clipRect translateBy: aCanvas origin))! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/3/2015 16:17'!
invalidateLayout

	! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 17:13'!
morph

	^ morph! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/30/2015 15:37'!
on: aMorph
	
	aMorph layoutProperties ifNil: [ 
		aMorph layoutProperties: GLMBrickLayoutProperties new.
		aMorph layoutProperties
		hSpaceFill;
		vSpaceFill ].
	self layoutProperties: aMorph layoutProperties.

	morph := aMorph.
	morph layoutProperties: (GLMBrickLayoutProperties new).
	morph layoutProperties
		hSpaceFill;
		vSpaceFill.
	self addBrickBack: morph.
	super brickBounds: (0@0 extent: (morph width@morph height)).! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/3/2015 21:17'!
onLayouted
	|origin corner newBounds|
	super onLayouted.
	
	origin := self paddingLeft @ self paddingTop.
	corner := self paddingRight @ self paddingBottom.
	newBounds := self globalBounds.
	newBounds := ((newBounds origin + origin) corner: (newBounds corner - corner)).
	
	self morph bounds: newBounds! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 18:54'!
onRemovedFrom: aBrick
	
	"we should just override it and left empty,
	to prevent recursion calls of this method
	to be propagated to morph"! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/26/2015 12:48'!
onThemerChanged
	! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/30/2015 16:47'!
themerChanged

	self onThemerChanged.
	self morph brickThemerChanged! !

GLMMorphBrick subclass: #GLMRubScrolledTextBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMRubScrolledTextBrick commentStamp: 'AliakseiSyrel 1/30/2015 11:35' prior: 0!
A GLMRubScrolledTextBrick is a wrapper for rubric scrolled text morph, to allow simple integration of rubric text field in brick

Instance Variables
	rubricMorph:		<Object>

rubricMorph
	- xxxxx
!

GLMRubScrolledTextBrick subclass: #GLMRubEditingAreaBrick
	instanceVariableNames: 'isLayouting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Core'!

!GLMRubEditingAreaBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/12/2015 11:38'!
exampleBand
	<example: 'Two rubric text areas in band'>
	
	(GLMBandBrick new
		color: Color lightRed;
		addAllBricks: { self new. self new })
			asBrickedMorph
				extent: 300@200;
				openInWindow! !

!GLMRubEditingAreaBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/12/2015 11:39'!
exampleScrollPane
	<example: 'Two rubric text areas in scroll pane'>
	
	(GLMScrollPaneBrick new
		color: Color lightRed;
		addAllBricks: { self new. self new })
			asBrickedMorph
				extent: 300@200;
				openInWindow! !

!GLMRubEditingAreaBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/12/2015 11:34'!
initialize
	super initialize.
	
	self hSpaceFill.
	isLayouting := false! !

!GLMRubEditingAreaBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/12/2015 12:26'!
layoutChanged
	super layoutChanged.
	
	self morph ifNil: [ ^ self ].
	
	isLayouting ifFalse: [
		isLayouting := true.
		self height: self morph height.
		isLayouting := false ]! !

!GLMRubEditingAreaBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/12/2015 11:31'!
newRubricMorph

	^ RubEditingArea new beWrapped! !

!GLMRubEditingAreaBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/12/2015 11:32'!
on: aMorph
	
	aMorph layoutProperties ifNil: [ 
		aMorph layoutProperties: GLMBrickLayoutProperties new ].

	morph := aMorph.
	
	self addBrickBack: morph! !

!GLMRubScrolledTextBrick methodsFor: 'reflective operations' stamp: 'AliakseiSyrel 1/30/2015 11:42'!
doesNotUnderstand: aMessage
	^ self rubric
		perform: aMessage selector 
		withArguments: aMessage arguments! !

!GLMRubScrolledTextBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/30/2015 11:44'!
initialize
	super initialize.
	
	self rubric: self newRubricMorph! !

!GLMRubScrolledTextBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/30/2015 11:29'!
newRubricMorph

	^ RubScrolledTextMorph new! !

!GLMRubScrolledTextBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 1/30/2015 12:12'!
onThemerChanged

	self updateStyle! !

!GLMRubScrolledTextBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 11:38'!
rubric

	^ self morph! !

!GLMRubScrolledTextBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 11:38'!
rubric: aMorph

	self morph ifNotNil: [ self removeMorph: self morph ].
	self on: aMorph! !

!GLMRubScrolledTextBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 11:55'!
rubricBackgroundColor

	^ self valueOfProperty: #brickRubricBackgroundColor ifAbsent: [ self themer rubricBackgroundColor ]! !

!GLMRubScrolledTextBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 11:57'!
rubricBackgroundColor: aColor

	self setProperty: #brickRubricBackgroundColor toValue: aColor.
	self updateStyle! !

!GLMRubScrolledTextBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 11:55'!
rubricBorderColor

	^ self valueOfProperty: #brickRubricBorderColor ifAbsent: [ self themer rubricBorderColor ]! !

!GLMRubScrolledTextBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 11:57'!
rubricBorderColor: aColor

	self setProperty: #brickRubricBorderColor toValue: aColor.
	self updateStyle! !

!GLMRubScrolledTextBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 11:56'!
rubricBorderWidth

	^ self valueOfProperty: #brickRubricBorderWidth ifAbsent: [ self themer rubricBorderWidth ]! !

!GLMRubScrolledTextBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/30/2015 11:57'!
rubricBorderWidth: aColor

	self setProperty: #brickRubricBorderWidth toValue: aColor.
	self updateStyle! !

!GLMRubScrolledTextBrick methodsFor: 'rubric-updating' stamp: 'AliakseiSyrel 1/30/2015 12:11'!
updateStyle

	self rubric color: self rubricBackgroundColor.
	self rubric borderColor: self rubricBorderColor.
	self rubric borderWidth: self rubricBorderWidth! !

GLMBrick subclass: #GLMPhlowBrick
	instanceVariableNames: '#entity => GLMPhlowSlot #titleBrick => GLMPhlowSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/11/2015 17:25'!
display: aBlockOrSymbol

	self subclassResponsibility! !

!GLMPhlowBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/11/2015 17:53'!
entity

	^ entity! !

!GLMPhlowBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:19'!
entity: anObject

	entity := anObject.
	self setTitle: (self titleLogic phlowValue: self entity)
	! !

!GLMPhlowBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 17:42'!
initialize
	super initialize.
		
	self
		useVerticalLinearLayout;
		titleBrick: self newTitleBrick;
		hSpaceFill;
		vSpaceFill! !

!GLMPhlowBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/11/2015 17:24'!
newTitleBrick

	^ GLMLabelBrick new! !

!GLMPhlowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/5/2015 15:38'!
setTitle: aString

	self titleBrick text: aString.
	
	titleBrick height: (
		(aString isEmpty | aString isNil)
			ifFalse: [ 30 ]
			ifTrue: [ 0 ])! !

!GLMPhlowBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:18'!
title: anObject
	
	self setProperty: #phlowTitle toValue: anObject! !

!GLMPhlowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 17:24'!
titleBrick
	^ titleBrick! !

!GLMPhlowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/5/2015 15:37'!
titleBrick: aBrick

	titleBrick := aBrick
		textPosition: #center;
		height: 0;
		hSpaceFill.
	self addBrickBack: titleBrick! !

!GLMPhlowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 12:23'!
titleLogic

	^ self valueOfProperty: #phlowTitle ifAbsent: [ '' ]! !

GLMPhlowBrick subclass: #GLMPhlowListBrick
	instanceVariableNames: '#scrollList => GLMPhlowSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowListBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/11/2015 23:31'!
example
	
	^ GLMCompositeBrick exampleList! !

!GLMPhlowListBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/11/2015 23:31'!
example2
	
	^ GLMCompositeBrick exampleListWithCustomItem! !

!GLMPhlowListBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 2/6/2015 11:31'!
display: anObject

	self setProperty: #phlowDisplay toValue: anObject! !

!GLMPhlowListBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/6/2015 11:33'!
displayLogic

	^ self valueOfProperty: #phlowDisplay ifAbsent: [ #yourself ]! !

!GLMPhlowListBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 2/6/2015 11:37'!
entity: anObject

	super entity: anObject.
	self setAdaptor! !

!GLMPhlowListBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:20'!
format: anObject

	self setProperty: #phlowFormat toValue: anObject! !

!GLMPhlowListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 12:22'!
formatLogic

	^ self valueOfProperty: #phlowFormat ifAbsent: [ #yourself ]! !

!GLMPhlowListBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/11/2015 17:25'!
initialize
	super initialize.
		
	self listBrick: self newScrollList! !

!GLMPhlowListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 16:30'!
listBrick

	^ scrollList! !

!GLMPhlowListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/6/2015 11:30'!
listBrick: aBrick

	scrollList := aBrick.
	self listBrick
		vSpaceFill;
		hSpaceFill.
		
	self addBrickBack: self listBrick! !

!GLMPhlowListBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/10/2015 14:58'!
newScrollList

	^ GLMFallbackScrollListBrick"GLMScrollListBrick" new! !

!GLMPhlowListBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/6/2015 11:36'!
setAdaptor
	| adaptor |
	adaptor := (GLMBrickListAdaptor on: self entity)
		morphAtLogic: [ :index :morph |
			self styledLogic
				phlowValue: (self formatLogic phlowValue: (self displayLogic phlowValue: (self entity at: index))) asBrick ].
	self listBrick adaptor: adaptor! !

!GLMPhlowListBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:20'!
styled: anObject
	
	self setProperty: #phlowStyled toValue: anObject! !

!GLMPhlowListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 12:22'!
styledLogic
	
	^ self valueOfProperty: #phlowStyled ifAbsent: [ #yourself ]! !

GLMPhlowListBrick subclass: #GLMPhlowTableBrick
	instanceVariableNames: '#transformedEntity => GLMPhlowSlot #columns => GLMPhlowSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowTableBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/11/2015 23:31'!
example
	
	^ GLMCompositeBrick exampleTable! !

!GLMPhlowTableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 22:23'!
addColumn: aColumn

	self columns add: aColumn! !

!GLMPhlowTableBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:29'!
column: anObject evaluated: otherObject

	self column: anObject evaluated: otherObject styled: nil! !

!GLMPhlowTableBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/30/2015 10:10'!
column: anObject evaluated: otherObject styled: anotherObject

	self addColumn: (GLMPhlowTableColumn new 
		title: anObject;
		computation: otherObject;
		style: anotherObject)! !

!GLMPhlowTableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 22:04'!
columns

	^ columns ifNil: [ columns := OrderedCollection new ]! !

!GLMPhlowTableBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:28'!
display: anObject
	
	self setProperty: #phlowDisplay toValue: anObject
	! !

!GLMPhlowTableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 12:28'!
displayLogic

	^ self valueOfProperty: #phlowDisplay ifAbsent: [ #yourself ]! !

!GLMPhlowTableBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 2/6/2015 11:37'!
entity: anObject

	self transformedEntity: (self displayLogic phlowValue: anObject).
	super entity: anObject.! !

!GLMPhlowTableBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/6/2015 11:37'!
setAdaptor
	| adaptor |
	adaptor := (GLMBrickListAdaptor on: self transformedEntity)
		morphAtLogic: [ :index | 
			GLMPhlowTableRowBrick new
				in: self;
				entity: (self transformedEntity at: index) ].
	self listBrick adaptor: adaptor! !

!GLMPhlowTableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 23:08'!
transformedEntity

	^ transformedEntity! !

!GLMPhlowTableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 23:09'!
transformedEntity: anObject

	transformedEntity := anObject! !

GLMPhlowBrick subclass: #GLMPhlowTextBrick
	instanceVariableNames: '#textBrick => GLMPhlowSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

GLMPhlowTextBrick subclass: #GLMPhlowPharoMethodBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowPharoMethodBrick methodsFor: 'phlow' stamp: 'TudorGirba 2/4/2015 13:38'!
installEntity
	self textBrick classOrMetaClass: (self smalltalkClassLogic phlowValue: self entity).
	self textBrick setTextWith: (self displayLogic phlowValue: self entity)! !

!GLMPhlowPharoMethodBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:25'!
smalltalkClass: anObject
	
	self setProperty: #phlowSmalltalkClass toValue: anObject! !

!GLMPhlowPharoMethodBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 12:25'!
smalltalkClassLogic

	^ self valueOfProperty: #phlowSmalltalkClass ifAbsent: [ #yourself ]! !

!GLMPhlowPharoMethodBrick methodsFor: 'accessing' stamp: 'TudorGirba 2/4/2015 13:36'!
textBrick: aBrick

	super textBrick: aBrick.
	self textBrick beForSmalltalkCode.! !

!GLMPhlowTextBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/11/2015 23:31'!
example
	
	^ GLMCompositeBrick examplePharoMethod! !

!GLMPhlowTextBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/23/2015 12:24'!
display: anObject

	self setProperty: #phlowDisplay toValue: anObject! !

!GLMPhlowTextBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 12:24'!
displayLogic

	^ self valueOfProperty: #phlowDisplay ifAbsent: [ #yourself ]! !

!GLMPhlowTextBrick methodsFor: 'phlow' stamp: 'TudorGirba 2/4/2015 13:38'!
entity: anObject
	super entity: anObject.
	
	self installEntity! !

!GLMPhlowTextBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/11/2015 22:42'!
initialize
	super initialize.
	
	self textBrick: self newTextBrick.! !

!GLMPhlowTextBrick methodsFor: 'phlow' stamp: 'TudorGirba 2/4/2015 13:37'!
installEntity
	self textBrick setTextWith: (self displayLogic phlowValue: self entity)
	! !

!GLMPhlowTextBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/30/2015 12:13'!
newTextBrick

	^ GLMRubScrolledTextBrick new! !

!GLMPhlowTextBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 17:20'!
textBrick

	^ textBrick
	
! !

!GLMPhlowTextBrick methodsFor: 'accessing' stamp: 'TudorGirba 2/4/2015 13:35'!
textBrick: aBrick

	textBrick := aBrick.
	self textBrick
		wrapped: true.
		
	self textBrick layoutProperties
		vSpaceFill;
		hSpaceFill.
	self addBrickBack: self textBrick
	
! !

GLMBrick subclass: #GLMPhlowTableRowBrick
	instanceVariableNames: '#entity => GLMPhlowSlot #table => GLMPhlowSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowTableRowBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 1/23/2015 12:30'!
addColumn: aColumn
	|brick|
	brick := (aColumn computation phlowValue: self entity) asBrick.
	brick := aColumn style phlowValue: brick.
	^ self addBrickBack: brick! !

!GLMPhlowTableRowBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/11/2015 21:48'!
entity

	^ entity! !

!GLMPhlowTableRowBrick methodsFor: 'phlow' stamp: 'AliakseiSyrel 1/11/2015 22:32'!
entity: anObject
	
	entity := anObject.
	self initializeColumns.! !

!GLMPhlowTableRowBrick methodsFor: 'acessing' stamp: 'AliakseiSyrel 1/11/2015 22:32'!
in: aTableBrick

	table := aTableBrick.
	self initializeColumns.! !

!GLMPhlowTableRowBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/5/2015 15:42'!
initialize
	super initialize.
	
	"My height is the height of the tallest subbrick"
	self
		vShrinkWrap;
		hSpaceFill! !

!GLMPhlowTableRowBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/11/2015 22:38'!
initializeColumns
	"you can initialize only if entity and table both not nil"
	self removeAllBricks.
	(self entity isNil | self table isNil) ifTrue: [ ^ self ].
	self table columns do: [ :each | self addColumn: each ].
	self updateWidthPercentage! !

!GLMPhlowTableRowBrick methodsFor: 'acessing' stamp: 'AliakseiSyrel 1/11/2015 22:19'!
table

	^ table! !

!GLMPhlowTableRowBrick methodsFor: 'updating' stamp: 'AliakseiSyrel 2/10/2015 00:18'!
updateWidthPercentage
	
	self subbricks ifEmpty: [ ^ self ].
	self subbricks do: [ :each | each hSpaceFill: (100 / self subbricksCount) ]! !

GLMBrick subclass: #GLMScrollPaneBrick
	instanceVariableNames: 'band lastScrollTimeStamp scrollPosition verticalScrollbar velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!

!GLMScrollPaneBrick commentStamp: 'AliakseiSyrel 1/30/2015 11:06' prior: 0!
A GLMScrollPaneBrick is a simple scrollpane with customisable scrollbars

Instance Variables
	band:		<Object>
	lastScrollTimeStamp:		<Object>
	scrollPosition:		<Object>
	velocity:		<Object>
	verticalScrollbar:		<Object>

band
	- xxxxx

lastScrollTimeStamp
	- xxxxx

scrollPosition
	- xxxxx

velocity
	- xxxxx

verticalScrollbar
	- xxxxx
!

GLMScrollPaneBrick subclass: #GLMFallbackScrollListBrick
	instanceVariableNames: 'adaptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!

!GLMFallbackScrollListBrick commentStamp: 'AliakseiSyrel 1/24/2015 18:21' prior: 0!
Use me in case something went wrong on production!

!GLMFallbackScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/21/2015 16:27'!
adaptor

	^ adaptor! !

!GLMFallbackScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 14:59'!
adaptor: anAdaptor

	adaptor := anAdaptor.
	self initializeItems! !

!GLMFallbackScrollListBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/10/2015 14:58'!
initializeItems

	1 to: self adaptor count do: [ :index |
		self band addBrickBack: (self adaptor morphAt: index convert: nil) ].
	
	self band hasSubbricks ifFalse: [ ^ self ]! !

!GLMFallbackScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/21/2015 16:29'!
invalidate

	self band removeAllBricks.
	self initializeItems! !

GLMScrollPaneBrick subclass: #GLMHorizontalScrollPaneBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!

!GLMHorizontalScrollPaneBrick commentStamp: 'AliakseiSyrel 1/7/2015 23:38' prior: 0!
A GLMHorizontalScrollPaneBrick is a very simple scrollpane with support of light scrollbar.
Acceleration mechanism is used for scrolling, as longer user scrolls faster it becomes.
!

!GLMHorizontalScrollPaneBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/10/2014 14:24'!
calculateMaxVelocity

	"max velocity must depend from the height of the band"
	^ (self band width / 15) max: self class defaultMaxVelocity! !

!GLMHorizontalScrollPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/10/2014 14:23'!
newBand
	^ GLMHorizontalBandBrick new! !

!GLMHorizontalScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/10/2014 14:25'!
scrollDown: anInteger
	
	band brickBounds corner x <= self width ifTrue: [ ^ self ].
	band brickBounds: (band brickBounds translateBy: (anInteger@ 0) negated).
	band brickBounds corner x < self width ifTrue: [ band brickBounds: (band brickBounds translateBy: ((self width - band brickBounds corner x)@0)) ]! !

!GLMHorizontalScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/10/2014 14:29'!
scrollTo: aBrick

	self shouldBeImplemented! !

!GLMHorizontalScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/10/2014 14:06'!
scrollUp: anInteger

	"preventing from scrolling if already at the top"
	band brickBounds origin x >= 0 ifTrue: [ ^ self ].
	"actuall scrolling"
	band brickBounds: (band brickBounds translateBy: (anInteger@ 0)).
	"returning scrollpane back if went away"
	band brickBounds origin x > 0 ifTrue: [ band brickBounds: (band brickBounds translateBy: (band brickBounds origin x@ 0 ) negated) ]! !

GLMScrollPaneBrick subclass: #GLMScrollListBrick
	instanceVariableNames: 'adaptor visibleIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!

!GLMScrollListBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 22:19'!
example
	|adaptor|
	adaptor := nil.
	adaptor := GLMBrickListAdaptor new
		sizeLogic: [ 2000 ];
		morphAtLogic: [ :index :morph |
			(morph ifNil: [ GLMLabelBrick new ])
				color: Color random muchLighter;
				text: index asString, ' of ', adaptor count asString;
				textPosition: #center;
				hSpaceFill;
				yourself ].

	GLMFoundationBrick new
		brickRoot: (self new adaptor: adaptor);
		extent: 300@400;
		openInWindow! !

!GLMScrollListBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 12/10/2014 20:07'!
exampleCollection

	GLMFoundationBrick new
		brickRoot: (self new adaptor: (GLMBrickListAdaptor new on: Smalltalk allClasses));
		extent: 300@400;
		openInWindow! !

!GLMScrollListBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 22:20'!
exampleDifferentHeights
	|adaptor|
	adaptor := nil.
	adaptor := GLMBrickListAdaptor new
		sizeLogic: [ 50 ];
		morphAtLogic: [ :index :morph |
			(morph ifNil: [ GLMLabelBrick new ])
				color: Color random muchLighter;
				text: index asString, ' of ', adaptor count asString;
				textPosition: #center;
				enable;
				height: [ :b | (((index % 10)*10 + 30) +  (10000 * (2 / b width))) asInteger ];
				hSpaceFill;
				yourself ].

	GLMFoundationBrick new
		brickRoot: (self new adaptor: adaptor);
		extent: 800@400;
		openInWindow! !

!GLMScrollListBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 22:20'!
exampleInfinity
	|adaptor|
	adaptor := nil.
	adaptor := GLMBrickListAdaptor new
		sizeLogic: [ Float infinity ];
		morphAtLogic: [ :index :morph | 
			(morph ifNil: [ GLMLabelBrick new ])
				color: Color random muchLighter;
				text: index asString, ' of ', adaptor count asString;
				textPosition: #center;
				hSpaceFill;
				yourself ].

	GLMFoundationBrick new
		brickRoot: (self new adaptor: adaptor);
		extent: 300@400;
		openInWindow! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 20:14'!
adaptor

	^ adaptor! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/6/2015 11:27'!
adaptor: anAdaptor

	adaptor := anAdaptor.
	self band hasSubbricks ifFalse: [ self updateVisible ].
	
	"self layoutPolicy layout: self in: self brickBounds.
	self flag: 'Fix bug in Layouts'."
	self update.! !

!GLMScrollListBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 1/25/2015 02:51'!
addItemMorph: aMorph after: anotherMorph

	self addBrickBack: aMorph.
	self setBoundsOf: aMorph after: anotherMorph.
	(self isPartiallyVisible: aMorph) ifFalse: [ self removeBrick: aMorph. ^ nil ].
	^ aMorph! !

!GLMScrollListBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 2/3/2015 22:22'!
addItemMorph: aMorph before: anotherMorph

	self addBrick: aMorph before: anotherMorph.
	self setBoundsOf: aMorph before: anotherMorph.
	(self isPartiallyVisible: aMorph) ifFalse: [ self removeBrick: aMorph. ^ nil ].
	
	aMorph brickBounds top < 0
		ifTrue: [ self moveAllSubbricksBy: aMorph brickBounds top negated ]
		ifFalse: [ (self getIndex: aMorph) = 1 ifTrue: [
				self moveAllSubbricksBy: aMorph brickBounds top negated ] ].
	
	^ aMorph! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/25/2015 03:02'!
calculateMaxVelocity
	"max velocity must depend from the height of the band"
	^ (self height * 0.9) asInteger! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 02:58'!
gatherInvisibleItems
			
	^ self band subbricks select: [ :each | (self isPartiallyVisible: each) not ]! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 1/25/2015 02:58'!
getAndRemoveInvisibleMorph: aCollection
	|brick|
	brick := self retrieveLast: aCollection.
	^ brick ifNotNil: [ self removeBrick: brick. brick morph ]! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/24/2015 16:39'!
getIndex: aBrick 

	^ aBrick valueOfProperty: #brickScrollListIndex ifAbsent: [ ]! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 2/5/2015 16:11'!
getMorphAt: anInteger recycled: aMorph
	|newMorph|
	
	newMorph := (self adaptor morphAt: anInteger convert: aMorph) asBrick.
	newMorph hSpaceFill.
	self setIndex: anInteger in: newMorph.
	^ newMorph! !

!GLMScrollListBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 17:42'!
initialize
	super initialize.
	
	self band useVerticalLinearLayout! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/24/2015 18:02'!
invalidate

	self scrollTo: self visibleIndex! !

!GLMScrollListBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 1/25/2015 01:29'!
isFirstAdded

	^ (self getIndex: self band firstSubbrick) = 1! !

!GLMScrollListBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 1/25/2015 02:56'!
isFullyVisible
	self band hasSubbricks ifFalse: [ ^ true ].
	^ self isLastAdded & self isFirstAdded & super isFullyVisible! !

!GLMScrollListBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 1/25/2015 01:29'!
isLastAdded

	^ (self getIndex: self band lastSubbrick) = self adaptor count! !

!GLMScrollListBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 1/25/2015 02:14'!
moveAllSubbricksBy: anInteger

	self band subbricks do: [ :each | each translateY: anInteger ].
	self band translateY: anInteger negated! !

!GLMScrollListBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 02:18'!
newBand
	^ super newBand height: [ :bandBrick |
		bandBrick subbricks isEmpty
			ifTrue: [ 0 ]
			ifFalse: [ bandBrick lastSubbrick brickBounds bottom ] ].! !

!GLMScrollListBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 11:53'!
newVerticalScrollbar

	^ GLMApproximateScrollbarBrick new! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/25/2015 02:49'!
preventOverscrolling

	self band hasSubbricks ifFalse: [ ^ self ].

	self isFirstAdded & self isFirstVisible ifTrue: [
			(self topOffset > 0) ifTrue: [
				self moveAllSubbricksBy: self topOffset negated.
				self moveBandTop.
				^ self update ] ].
	
	self isTopOverscrolled
		ifTrue: [ self moveBandTop. ^ self update ].
	self isBottomOverscrolled & (self isFullyVisible not)
		ifTrue: [ self moveBandBottom. ^ self update ]! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 10:52'!
retrieveLast: aCollection

	^ aCollection isEmpty
		ifTrue: [ nil ]
		ifFalse: [ aCollection removeLast ]! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/29/2015 02:13'!
scrollDown: anInteger
	
	self band translateY: (
		self isLastAdded
			ifTrue: [ anInteger min: (self band brickBounds bottom - self height) ]
			ifFalse: [ anInteger ]) negated! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/29/2015 14:56'!
scrollPageDown
	
	self
		scrollDown: self calculateMaxVelocity;
		update;
		changed! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/29/2015 14:56'!
scrollPageUp
	
	self
		scrollUp: self calculateMaxVelocity;
		update;
		changed! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/25/2015 20:13'!
scrollTo: anInteger
	|brick index|
	self band removeAllBricks.
	self moveBandTop.
	visibleIndex := nil.
	
	self adaptor count > 0 ifTrue: [
		index := (anInteger max: 1) min: self adaptor count.
		brick := self getMorphAt: index recycled: nil.
		brick 	withWidth: self band width.
		brick 	doLayout.
	
		brick brickBounds: ((0@(0 max: ((self height - brick height) / 2))) extent: brick extent).
		self band addBrickBack: brick ].
	
	self update.
	self changed
	
	
	
	! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/24/2015 18:07'!
scrollToBottom

	self scrollTo: self adaptor count! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/24/2015 18:07'!
scrollToTop

	self scrollTo: 1! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/25/2015 02:27'!
scrollUp: anInteger
	
	self band translateY: (
		self isFirstAdded
			ifTrue: [ anInteger min: (self topOffset - self bandTopOffset) ]
			ifFalse: [ anInteger ])! !

!GLMScrollListBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 2/6/2015 11:27'!
setBoundsOf: aMorph after: afterMorph
	
	aMorph
		withWidth: self band width;
		brickBounds: (afterMorph brickBounds bottomLeft extent: aMorph extent)! !

!GLMScrollListBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 2/6/2015 11:27'!
setBoundsOf: aMorph before: beforeMorph
	|origin corner|
	
	aMorph withWidth: self band width.
	
	corner := beforeMorph brickBounds topRight.
	origin  := beforeMorph brickBounds topLeft - (0@aMorph height).
	
	aMorph brickBounds: (origin corner: corner)! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/24/2015 15:15'!
setIndex: anInteger in: aBrick 

	aBrick setProperty: #brickScrollListIndex toValue: anInteger! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 02:24'!
topOffset

	^ self band firstSubbrick brickBounds top! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/26/2015 14:31'!
update

	self updateVisible.
	self band updateHeight.
	self preventOverscrolling.
	self verticalScrollbar updatePosition.! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 1/28/2015 16:13'!
updateVisible
	|invisible|
	
	self adaptor ifNil: [ ^ self ].
	self adaptor count = 0 ifTrue: [ ^ self ].
	
	invisible := self gatherInvisibleItems.
	invisible = self band subbricks & invisible isEmpty not ifTrue: [ ^ self ].
	
	self updateVisibleTop: invisible.
	self updateVisibleBottom: invisible.
	
	invisible do: [ :each | self band removeBrick: each ].
	
	visibleIndex := self getIndex: self band firstSubbrick ! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 12/10/2014 20:07'!
updateVisibleBottom: invisibleBricks
	|after|
	
	after := self band lastSubbrick.
	[ after isNotNil and: [ (self isPartiallyVisible: after) and: [ (self getIndex: after) < self adaptor count ] ] ] whileTrue: [
		after := self
			addItemMorph: (
				self
					getMorphAt: (self getIndex: after) + 1
					recycled: (self getAndRemoveInvisibleMorph: invisibleBricks))
			after: after ].! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 1/24/2015 15:40'!
updateVisibleTop: invisibleBricks
	|before|
	
	before := self band hasSubbricks not
		ifFalse: [ self band firstSubbrick]
		ifTrue: [ self band addBrickBack: (self getMorphAt: self visibleIndex recycled: (self getAndRemoveInvisibleMorph: invisibleBricks)) ].
		
	[ before isNotNil and: [ (self isPartiallyVisible: before) and: [ (self getIndex: before) > 1 ] ] ] whileTrue: [
		before := self
			addItemMorph: (
				self
					getMorphAt: (self getIndex: before) - 1
					recycled: (self getAndRemoveInvisibleMorph: invisibleBricks))
			before: before  ]
	! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/24/2015 15:06'!
visibleIndex

	^ visibleIndex ifNil: [ visibleIndex := 1 ]! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:11'!
defaultMaxVelocity
	^ self defaultScrollVelocity * 4! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:11'!
defaultScrollAcceleration
	^ 2! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:13'!
defaultScrollTimeReset
	^ 350! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/27/2014 17:17'!
defaultScrollTurboTime

	^ 30! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 13:24'!
defaultScrollVelocity
	^ 15! !

!GLMScrollPaneBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/8/2015 15:01'!
"protocol: examples"
example
	|foundation scrollPane|
	
	scrollPane := self new.
	
	foundation := GLMFoundationBrick new.
	foundation brickRoot: scrollPane.
	
	1 to: 20 do: [ :index |
		scrollPane addBrickBack: (GLMBrick new
			color: Color random;
			hSpaceFill;
			height: 50).
	].
	
	foundation extent: 200@200.
	
	foundation openInWindow! !

!GLMScrollPaneBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 22:18'!
"protocol: examples"
exampleLarge
	|foundation scrollPane|
	
	scrollPane := self new.
	
	foundation := GLMFoundationBrick new.
	foundation brickRoot: scrollPane.
	
	1 to: 1000 do: [ :index |
		scrollPane addBrickBack: (GLMBrick new
			color: Color random;
			hSpaceFill;
			height: 50).
	].
	
	foundation extent: 400@300.
	
	foundation openInWindow! !

!GLMScrollPaneBrick methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/12/2015 11:40'!
addAllBricks: aCollection
	self band addAllBricks: aCollection.
	self verticalScrollbar ifNotNil: [ :b | b updatePosition ]! !

!GLMScrollPaneBrick methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 1/25/2015 02:51'!
addBrick: aBrick before: anotherBrick
	self band addBrick: aBrick before: anotherBrick! !

!GLMScrollPaneBrick methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 2/10/2015 15:16'!
addBrickBack: aBrick
	self band addBrickBack: aBrick.
	
	self verticalScrollbar ifNotNil: [ :b | b updatePosition ]! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-accessing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
allowedBounds

	^ self globalBounds! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-brick-accessing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
band

	^ band! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-brick-accessing' stamp: 'AliakseiSyrel 2/3/2015 23:33'!
band: aBrick

	band := aBrick.
	self band hSpaceFill.
	super addBrickBack: self band.! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-accessing' stamp: 'AliakseiSyrel 1/25/2015 03:10'!
bandTopOffset

	^ self band brickBounds top! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-calculations' stamp: 'AliakseiSyrel 1/26/2015 14:50'!
calculateMaxVelocity
	"max velocity must depend from the height of the band"
	^ (self band height / 15) max: self class defaultMaxVelocity! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-calculations' stamp: 'AliakseiSyrel 1/26/2015 15:15'!
calculateVelocity: event
	|delta|
	delta := event timeStamp - lastScrollTimeStamp.
		
	self velocity: (delta > self class defaultScrollTimeReset
		ifTrue: [ self class defaultScrollVelocity ]
		ifFalse: [ (self velocity + self class defaultScrollAcceleration * (delta <= self class defaultScrollTurboTime ifTrue: [ 2 ] ifFalse: [ 1 ] )) min: self calculateMaxVelocity ]).
		
	lastScrollTimeStamp := event timeStamp.
	
	^ self velocity ceiling! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-events-mouse' stamp: 'AliakseiSyrel 1/26/2015 14:50'!
handleListenEvent: anEvent
	"checking if it's keyboard event (mouse wheel is keyboard event on windows o_O (wtf?)"
	anEvent type = #keystroke ifTrue: [
		"checking if mouse is inside me"
		((self boundsInWorld containsPoint: anEvent position)) ifTrue: [
			"actuall scrolling"
			self scrollByKeyboard: anEvent ] ]! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-events-mouse' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
handlesMouseWheel: evt
	^ true! !

!GLMScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 18:19'!
initialize
	super initialize.
	
	lastScrollTimeStamp := 0.

	self useVerticalLinearLayout.
	self band: self newBand.
	self verticalScrollbar: self newVerticalScrollbar.	
	"initializes listener for mouse wheel scroll on windows vm"
	self initializeListeners! !

!GLMScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
initializeListeners

	"using the most general event subscribtion for all events spawned by the hand"
	self activeHand addEventListener: self.! !

!GLMScrollPaneBrick methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 2/10/2015 15:16'!
invalidateLayout
	super invalidateLayout.
	
	self band translateY: self scrollPositionTop.
	self verticalScrollbar ifNotNil: [ :b | b updatePosition ]! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 1/25/2015 03:07'!
isBottomOverscrolled

	^ self band brickBounds bottom < self height! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 1/25/2015 01:55'!
isFirstVisible

	self band hasSubbricks ifFalse: [ ^ true ].
	^ self isVisible: self band firstSubbrick! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 1/25/2015 01:54'!
isFullyVisible

	^ self isFirstVisible & self isLastVisible! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
isKeyboardScrollEvent: anEvent

	(anEvent controlKeyPressed | anEvent commandKeyPressed) ifFalse: [^ false ].
	anEvent keyValue = 30 ifTrue: [ ^ true ].
	anEvent keyValue = 31 ifTrue: [ ^ true ].
	^ false! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 1/25/2015 01:55'!
isLastVisible

	self band hasSubbricks ifFalse: [ ^ true ].
	^ self isVisible: self band lastSubbrick! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 12/5/2014 23:10'!
isPartiallyVisible: aBrick
	|myBounds testingBounds|
	"need to normalize bounds to take only y coordinate into account"
	
	myBounds := (self allowedBounds withWidth: 1) translateBy: (self allowedBounds origin negated x@0).
	testingBounds :=  (aBrick globalBounds withWidth: 1) translateBy: (aBrick globalBounds origin negated x@0).
	
	^ myBounds intersects: testingBounds! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 1/25/2015 03:10'!
isTopOverscrolled

	^ self bandTopOffset > 0! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-testing' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
isVisible: aBrick
	|myBounds testingBounds|
	"need to normalize bounds to take only y coordinate into account"
	
	myBounds := (self allowedBounds withWidth: 0) translateBy: (self allowedBounds origin negated x@0).
	testingBounds :=  (aBrick globalBounds withWidth: 0) translateBy: (aBrick globalBounds origin negated x@0).
	
	^ myBounds containsRect: testingBounds! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-events-mouse' stamp: 'AliakseiSyrel 12/20/2014 15:51'!
mouseWheel: event

	self scrollBy: (self calculateVelocity: event) direction: event direction.! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-transformations' stamp: 'AliakseiSyrel 1/25/2015 03:06'!
moveBandBottom

	self band translateY: (self height - self band brickBounds bottom)! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-transformations' stamp: 'AliakseiSyrel 1/25/2015 03:11'!
moveBandTop

	self band translateY: self bandTopOffset negated! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-brick-creation' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
newBand

	^ GLMBandBrick new! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-brick-creation' stamp: 'AliakseiSyrel 1/26/2015 14:50'!
newVerticalScrollbar

	^ GLMScrollbarBrick new! !

!GLMScrollPaneBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 1/26/2015 15:20'!
onThemerChanged
	super onThemerChanged.
	
	self updateStyle! !

!GLMScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
outOfWorld: aWorld
	super outOfWorld: aWorld.
	
	self unsubscribeListeners! !

!GLMScrollPaneBrick methodsFor: 'private-scrolling' stamp: 'AliakseiSyrel 1/25/2015 20:14'!
privateScrollPosition: anInteger

	scrollPosition := anInteger.
	self announcer announce: GLMBrickScrollPositionChanged new! !

!GLMScrollPaneBrick methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 1/25/2015 02:51'!
removeAllBricks
	
	self band removeAllBricks.
	self scrollToTop! !

!GLMScrollPaneBrick methodsFor: 'brick-structure-adding/removing' stamp: 'AliakseiSyrel 1/25/2015 02:51'!
removeBrick: aBrick
	self band removeBrick: aBrick! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/25/2015 20:13'!
scrollBy: anInteger direction: aSymbol

	self isFullyVisible ifTrue: [ ^ self ].
	
	aSymbol = #up ifTrue: [ self scrollUp: anInteger ].
	aSymbol = #down ifTrue: [ self scrollDown: anInteger ].
	
	self update.
	self changed! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/29/2015 15:30'!
scrollByKeyboard: anEvent
	|direction|
	
	(self isKeyboardScrollEvent: anEvent) ifFalse: [^ self ].
	self velocity: (self calculateVelocity: anEvent).
	
	"keycode 30 is Event direction = #up"
	anEvent keyValue = 30 ifTrue: [ direction := #up ].
	"keycode 31 is Event direction = #down"
	anEvent keyValue = 31 ifTrue: [ direction := #down ].
	self scrollBy: velocity direction: direction! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/25/2015 03:09'!
scrollDown: anInteger
	
	self band translateY: anInteger negated.
	self isBottomOverscrolled ifTrue: [ self moveBandBottom ]! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/29/2015 14:54'!
scrollPageDown

	self
		scrollDown: self height;
		update;
		changed! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/29/2015 15:01'!
scrollPageUp

	self
		scrollUp: self height;
		update;
		changed! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-accessing' stamp: 'AliakseiSyrel 1/21/2015 13:25'!
scrollPositionBottom

	^ self scrollPositionTop + self innerBounds height! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-accessing' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
scrollPositionTop

	^ scrollPosition ifNil: [ scrollPosition := 0 ]! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/27/2015 10:24'!
scrollTo: aBrick
	|delta|
	"if already visible no need to scroll"

	(self isVisible: aBrick) ifTrue: [ ^ self ].
	
	delta := ((self allowedBounds top - band globalBounds top) - (aBrick globalBounds top - band globalBounds top)).
	delta < 0 ifTrue: [ delta := delta + self allowedBounds height - aBrick height ].
		
	self band translateY: delta.
	self isBottomOverscrolled ifTrue: [ self moveBandBottom ].
	self isTopOverscrolled ifTrue: [ self moveBandTop ].
	
	self update.
	self changed.
	
	! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/22/2015 21:00'!
scrollToBottom

	self band hasSubbricks ifFalse: [ ^ self ].
	self scrollTo: self band lastSubbrick! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 12/20/2014 15:52'!
scrollToTop

	self scrollBy: self scrollPositionTop negated direction: #up! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-scrolling' stamp: 'AliakseiSyrel 1/25/2015 03:12'!
scrollUp: anInteger

	self band translateY: anInteger.
	self isTopOverscrolled ifTrue: [ self moveBandTop ]! !

!GLMScrollPaneBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/29/2015 17:39'!
scrollpaneBackgroundColor

	^ self valueOfProperty: #brickScrollpaneBackgroundColor ifAbsent: [ self themer scrollpaneBackgroundColor ]! !

!GLMScrollPaneBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 15:19'!
scrollpaneBackgroundColor: aColor

	self setProperty: #brickScrollpaneBackgroundColor toValue: aColor.
	self updateStyle! !

!GLMScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
unsubscribeListeners

	self activeHand removeEventListener: self! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-updating' stamp: 'AliakseiSyrel 1/26/2015 14:30'!
update

	self scrollDown: 0.
	self scrollUp: 0.
	self verticalScrollbar updatePosition.
	self privateScrollPosition: self band brickBounds top.! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-updating' stamp: 'AliakseiSyrel 1/26/2015 15:20'!
updateStyle

	self color: self scrollpaneBackgroundColor! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-accessing' stamp: 'AliakseiSyrel 1/26/2015 15:14'!
velocity

	^ velocity ifNil: [ velocity := self class defaultScrollVelocity ]! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-accessing' stamp: 'AliakseiSyrel 1/26/2015 15:14'!
velocity: anInteger

	velocity := anInteger! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-brick-accessing' stamp: 'AliakseiSyrel 12/5/2014 06:54'!
verticalScrollbar

	^ verticalScrollbar! !

!GLMScrollPaneBrick methodsFor: 'scrollpane-brick-accessing' stamp: 'AliakseiSyrel 2/10/2015 15:12'!
verticalScrollbar: aBrick

	verticalScrollbar := aBrick.
	verticalScrollbar scrollPane: self.
	verticalScrollbar height: [ self height ].
	verticalScrollbar layout heightDependency: self.
	super addBrickBack: verticalScrollbar! !

GLMScrollPaneBrick subclass: #GLMStackedScrollPaneBrick
	instanceVariableNames: 'allowedBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!

!GLMStackedScrollPaneBrick commentStamp: 'AliakseiSyrel 11/27/2014 23:31' prior: 0!
A GLMStackedScrollPaneBrick is a more complicated scrollpane, with scrollbars and stacking mechanism of subbricks that have #stack floating parameter
!

!GLMStackedScrollPaneBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 23:30'!
example

	super example! !

!GLMStackedScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 20:47'!
allowedBounds

	^ allowedBounds ifNil: [ allowedBounds := self globalBounds ]! !

!GLMStackedScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 20:47'!
allowedBounds: aRectangle

	allowedBounds := aRectangle! !

!GLMStackedScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 17:43'!
initialize
	super initialize.
	
	self band useVerticalLinearLayout! !

!GLMStackedScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/24/2015 18:02'!
invalidate

	! !

!GLMStackedScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/3/2015 21:39'!
update
	super update.
	
	"we need to update band's layout to support stacking"
	"self allowedBounds: self band layoutChildren."! !

GLMBrick subclass: #GLMScrollbarBrick
	instanceVariableNames: 'scrollPane bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!

!GLMScrollbarBrick commentStamp: 'AliakseiSyrel 11/19/2014 20:32' prior: 0!
A GLMScrollbarBrick is vertical scollbar for a scrollpane. User can't interact with it

Instance Variables
	bar:		<Object>
	scrollPane:		<Object>

bar
	- xxxxx

scrollPane
	- xxxxx
!

GLMScrollbarBrick subclass: #GLMApproximateScrollbarBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets-Scrollpane'!

!GLMApproximateScrollbarBrick commentStamp: 'AliakseiSyrel 12/6/2014 20:15' prior: 0!
A GLMApproximateScrollbarBrick can be used only with GLMScrollListBrick or with other lists that uses adaptors.

Approximates the height of band depending on average height of all visible items.
!

!GLMApproximateScrollbarBrick methodsFor: 'scrollbar-calculations' stamp: 'AliakseiSyrel 12/6/2014 20:14'!
approximateBandHeight
	|visible averageItemHeight|
	
	visible := self scrollPane band submorphs select: [ :each | self scrollPane isPartiallyVisible: each ].
	visible isEmpty ifTrue: [ ^ 0 ].
	
	averageItemHeight := (visible inject: 0 into: [ :visibleHeight :each | visibleHeight + each height ]) / visible size.
	^ self scrollPane adaptor count * averageItemHeight.! !

!GLMApproximateScrollbarBrick methodsFor: 'scrollbar-calculations' stamp: 'AliakseiSyrel 1/29/2015 03:24'!
calculateScrollbarHeight
	|bandHeight firstIndex lastIndex |
	bandHeight := self approximateBandHeight.
	bandHeight = 0 ifTrue: [ ^ 0 ].
	self scrollPane isFullyVisible ifTrue: [ ^ 0 ].
	
	firstIndex := self scrollPane getIndex: (self scrollPane band firstSubbrick).
	lastIndex := self scrollPane getIndex: (self scrollPane band lastSubbrick).
	
	^ ((lastIndex - firstIndex + 1) / self scrollPane adaptor count * self height) ceiling.
	! !

!GLMApproximateScrollbarBrick methodsFor: 'scrollbar-calculations' stamp: 'AliakseiSyrel 1/24/2015 18:19'!
calculateScrollbarTopOffset
	|bandHeight firstIndex lastIndex|
	bandHeight := self approximateBandHeight.
	bandHeight = 0 ifTrue: [ ^ 0 ].
	
	firstIndex := self scrollPane getIndex: (self scrollPane band firstSubbrick).
	lastIndex := self scrollPane getIndex: (self scrollPane band lastSubbrick).
	
	^ ((firstIndex-1) / self scrollPane adaptor count * self height) floor.! !

!GLMScrollbarBrick methodsFor: 'scrollbar-brick-accessing' stamp: 'AliakseiSyrel 11/19/2014 20:11'!
bar

	^ bar! !

!GLMScrollbarBrick methodsFor: 'scrollbar-brick-accessing' stamp: 'AliakseiSyrel 1/26/2015 13:27'!
bar: aBrick

	bar := aBrick.
	self addBrickBack: aBrick! !

!GLMScrollbarBrick methodsFor: 'scrollbar-calculations' stamp: 'AliakseiSyrel 12/6/2014 11:44'!
calculateScrollbarHeight

	^ (((self scrollPane height) / (self scrollPane band height)) * self height) ceiling.! !

!GLMScrollbarBrick methodsFor: 'scrollbar-calculations' stamp: 'AliakseiSyrel 12/6/2014 11:45'!
calculateScrollbarTopOffset

	^ (((self height) / (self scrollPane band height)) * (self scrollPane band brickBounds top abs)) floor.! !

!GLMScrollbarBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 18:18'!
initialize
	super initialize.
	
	self
		useVerticalLinearLayout;
		bar: self newBar.! !

!GLMScrollbarBrick methodsFor: 'scrollbar-brick-creation' stamp: 'AliakseiSyrel 11/19/2014 20:16'!
newBar

	^ GLMBrick new! !

!GLMScrollbarBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 1/26/2015 13:54'!
onThemerChanged
	super onThemerChanged.

	self updateStyle! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/29/2015 17:39'!
scrollBarColor

	^ self valueOfProperty: #brickScrollbarColor ifAbsent: [ self themer scrollbarColor ]! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 13:30'!
scrollBarColor: aColor

	self setProperty: #brickScrollbarColor toValue: aColor.
	self updateStyle! !

!GLMScrollbarBrick methodsFor: 'scrollbar-brick-accessing' stamp: 'AliakseiSyrel 1/26/2015 14:33'!
scrollPane

	^ scrollPane! !

!GLMScrollbarBrick methodsFor: 'scrollbar-brick-accessing' stamp: 'AliakseiSyrel 1/26/2015 14:33'!
scrollPane: anObject

	scrollPane := anObject.
	self updatePosition.! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/29/2015 17:39'!
scrollbarCornerRadius

	^ self valueOfProperty: #brickScrollbarCornerRadius ifAbsent: [ self themer scrollbarCornerRadius ]
	! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 14:29'!
scrollbarCornerRadius: anInteger

	self setProperty: #brickScrollbarCornerRadius toValue: anInteger.
	self updateStyle! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/29/2015 17:39'!
scrollbarOffset

	^ self valueOfProperty: #brickScrollbarOffset ifAbsent: [ self themer scrollbarOffset ]! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 13:30'!
scrollbarOffset: anInteger

	self setProperty: #brickScrollbarOffset toValue: anInteger.
	self updateStyle! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/29/2015 17:39'!
scrollbarPosition

	^ self valueOfProperty: #brickScrollbarPosition ifAbsent: [ self themer scrollbarPosition ]! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 13:30'!
scrollbarPosition: aSymbol

	self setProperty: #brickScrollbarPosition toValue: aSymbol.
	self updateStyle! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/29/2015 17:39'!
scrollbarWidth

	^ self valueOfProperty: #brickScrollbarWidth ifAbsent: [ self themer scrollbarWidth ]! !

!GLMScrollbarBrick methodsFor: 'brick-properties' stamp: 'AliakseiSyrel 1/26/2015 13:29'!
scrollbarWidth: anInteger

	self setProperty: #brickScrollbarWidth toValue: anInteger.
	self updateStyle! !

!GLMScrollbarBrick methodsFor: 'scrollbar-updating' stamp: 'AliakseiSyrel 2/10/2015 15:13'!
updatePosition
	|height top width|
	self scrollPane ifNil: [ ^ self ].
	self scrollPane band height = 0 ifTrue: [
		bar brickBounds: ((0@0) extent: 0@0).
		^ self changed.
	].
	
	height := self calculateScrollbarHeight.
	top := self calculateScrollbarTopOffset.
	
	width := (height >= self height)
		ifTrue: [ 0 ]
		ifFalse: [ self width ].
	
	bar brickBounds: ((0@top) extent: width@height).
	
	self changed! !

!GLMScrollbarBrick methodsFor: 'scrollbar-updating' stamp: 'AliakseiSyrel 1/26/2015 13:53'!
updateStyle

	self bar color: self scrollBarColor.
	self layout floating: self scrollbarPosition.
	self width: self scrollbarWidth.
	
	self layout floating = #right ifTrue: [ self marginRight: self scrollbarOffset ].
	self layout floating = #bottom ifTrue: [ self marginBottom: self scrollbarOffset ].
	self layout floating = #left ifTrue: [ self marginLeft: self scrollbarOffset ].
	self layout floating = #top ifTrue: [ self marginTop: self scrollbarOffset ]! !

!GLMBrickedMorph methodsFor: 'layout' stamp: 'AliakseiSyrel 1/7/2015 23:16'!
adjustLayoutBounds
	"no need in it"! !

!GLMBrickedMorph methodsFor: 'drawing' stamp: 'AliakseiSyrel 1/7/2015 23:18'!
clippingBounds

	^ self fullBounds! !

!GLMBrickedMorph methodsFor: 'layout' stamp: 'AliakseiSyrel 1/7/2015 23:16'!
computeBounds
	"nothing to compute, everything is already computed"! !

!GLMBrickedMorph methodsFor: 'layout' stamp: 'AliakseiSyrel 1/7/2015 23:16'!
computeFullBounds
	"nothing to compute, everything is already computed"! !

!GLMBrickedMorph methodsFor: 'layout' stamp: 'AliakseiSyrel 1/7/2015 23:16'!
doLayoutIn: layoutBounds
	"we remove morphic layouting mechanism"! !

!GLMBrickedMorph methodsFor: 'layout' stamp: 'AliakseiSyrel 1/7/2015 23:17'!
layoutBounds: aRectangle
	"I'm not a morph anymore"! !

!GLMBrickedMorph methodsFor: 'layout' stamp: 'AliakseiSyrel 1/7/2015 23:18'!
layoutChanged

	"empty"! !

!GLMBrickedMorph methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/7/2015 23:18'!
outerBounds
	^ self fullBounds! !

!GLMBrickedMorph methodsFor: 'layout' stamp: 'AliakseiSyrel 1/7/2015 23:19'!
privateFullBounds
	^ self fullBounds! !

!GLMBrickedMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/7/2015 23:21'!
privateInvalidateMorph: aMorph
	"empty"! !

Morph subclass: #GLMFoundationBrick
	instanceVariableNames: 'brickRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Morphic'!

!GLMFoundationBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:32' prior: 0!
A GLMFoundationBrick is connection layer between brick widgets and morphic.

See GLMBrick class comment for more info.

Instance Variables
	brickRoot:		<Object>

brickRoot
	- xxxxx
!

!GLMFoundationBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 12/2/2014 19:02'!
exampleLarge
	|foundation scrollPane|
	
	scrollPane := GLMScrollPaneBrick new.
	
	foundation := self new.
	foundation brickRoot: scrollPane.
	
	1 to: 10000 do: [ :index |
		scrollPane addBrickBack: (GLMBrick new
			color: Color random;
			extent: 200@50).
	].
	
	foundation extent: 400@300.
	
	foundation openInWindow! !

!GLMFoundationBrick class methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/20/2014 20:36'!
root: aBrick

	^ self new brickRoot: aBrick! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:48'!
addAllBricks: aCollection

	aCollection do: [ :each | self addBrickBack: each ]! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 10:17'!
addBrickBack: aBrick

	self brickRoot addBrickBack: aBrick.! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:21'!
brickRoot

	^ brickRoot! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 21:10'!
brickRoot: aBrick

	self brickRoot ifNotNil: [
		self removeMorph: self brickRoot.
		brickRoot := nil.
	].
	
	brickRoot := aBrick.
	self addMorphBack: brickRoot.
	
	! !

!GLMFoundationBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/30/2015 16:48'!
brickThemerChanged

	self brickRoot themerChanged! !

!GLMFoundationBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 2/6/2015 11:08'!
doLayout

	self brickRoot doLayoutForce.! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/6/2015 11:05'!
extent: aPoint
	|left top right bottom|
	
	super extent: aPoint.
	
	left := self brickRoot marginLeft.
	top := self brickRoot marginTop.
	
	right := self extent x - self brickRoot marginRight.
	bottom := self extent y - self brickRoot marginBottom.
	
	self brickRoot width: right - left.
	self brickRoot height: bottom - top.
	self brickRoot wrappedBounds bounds: (left@top corner: (right@bottom)).
	
	self brickRoot doLayoutForce.
	self brickRoot onLayouted! !

!GLMFoundationBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/17/2014 23:47'!
fullDrawOn: aCanvas
	"preventing from drawing outside of me"
	super fullDrawOn: (aCanvas copyClipRect: self fullBounds).! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/3/2014 18:43'!
globalBounds

	^ self bounds! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/20/2015 21:10'!
globalBoundsTranslateFactor

	^ self globalBounds origin! !

!GLMFoundationBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 17:40'!
initialize
	super initialize.
	
	self
		beTransparent;
		brickRoot: GLMBrick new! !

!GLMFoundationBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/11/2014 15:38'!
isFocused

	^ false! !

!GLMFoundationBrick methodsFor: 'initialize' stamp: 'AliakseiSyrel 1/29/2015 00:58'!
outOfWorld: aWorld
	super outOfWorld: aWorld.
	
	self brickRoot onRemovedFrom: self! !

!GLMFoundationBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/24/2014 13:04'!
privateExtent: aPoint

	super extent: aPoint.! !

!GLMFoundationBrick methodsFor: 'private' stamp: 'AliakseiSyrel 1/26/2015 12:38'!
privateThemer

	^ self valueOfProperty: #brickThemer ifAbsentPut: [ nil ]! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
removeAllBricks

	self brickRoot removeAllBricks! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 1/20/2015 00:07'!
removeBrick: aBrick

	self brickRoot removeBrick: aBrick! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:29'!
themer

	^ self privateThemer
		ifNotNil: [ self privateThemer ]
		ifNil: [ self owner isNotNil
			ifTrue: [ self owner isBrick ifTrue: [ self owner themer ] ifFalse: [ super brickThemer ] ]
			ifFalse: [ self theme brickThemer ] ]! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/26/2015 13:01'!
themer: aThemer

	self setProperty: #brickThemer toValue: aThemer.
	self brickRoot themerChanged! !

GLMFoundationBrick subclass: #GLMTabSelectorBrick
	instanceVariableNames: 'selectedIndex visibleTabRange font tabs controls wrapScrolling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Morphic'!

!GLMTabSelectorBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:33' prior: 0!
A GLMTabSelectorBrick is a simplified TabSelectorMorph with support of smart tab resizing.
New implementation doesn't have any scrollbars or scroll arrows.

Instance Variables
	controls:		<Object>
	font:		<Object>
	selectedIndex:		<Object>
	tabs:		<Object>
	visibleTabRange:		<Object>
	wrapScrolling:		<Object>

controls
	- xxxxx

font
	- xxxxx

selectedIndex
	- xxxxx

tabs
	- xxxxx

visibleTabRange
	- xxxxx

wrapScrolling
	- xxxxx
!

!GLMTabSelectorBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
addTab: aStringOrMorph
	"Add a new tab with the given text."
	
	self tabs add: (self newLabelMorph: aStringOrMorph).
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
addTab: aStringOrMorph selected: selectedStringOrMorph
	"Add a new tab with the given text or morph and alternate for when selected."
	
	self tabs add: (self newLabelMorph: aStringOrMorph selected: selectedStringOrMorph).
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'rounding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
cornerStyle: aSymbol
	"Pass to tabs also."

	super cornerStyle: aSymbol.
	self tabs do: [:t | t cornerStyle: aSymbol]! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
font
	"Answer the label font"

	^font! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
font: aFont
	"Set the label font"

	font == aFont ifTrue: [^self].
	font := aFont.
	self updateFont! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!GLMTabSelectorBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 10:40'!
initialize
	"Initialize the receiver."

	super initialize.
	selectedIndex := 0.
	self
		tabs: OrderedCollection new;
		roundedCorners: #(1 4);
		borderWidth: 0.! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
keyStroke: event 
	"Process keys navigation and space to toggle."

	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character arrowLeft
		ifTrue: [self selectPreviousTab].
	event keyCharacter = Character arrowRight
		ifTrue: [self selectNextTab]! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."
	super keyboardFocusChange: aBoolean.
	self focusChanged! !

!GLMTabSelectorBrick methodsFor: 'layout' stamp: 'AliakseiSyrel 10/16/2014 17:31'!
minHeight
	^ self theme buttonMinHeight! !

!GLMTabSelectorBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/3/2015 20:18'!
newLabelMorph: aStringOrMorph
	"Answer a new label morph with the given label text."

	^GLMTabLabelBrick new
		roundedCorners: #(1 4);
		cornerStyle: self cornerStyle;
		label: aStringOrMorph;
		font: self font;
		on: #mouseDown send: #tabClicked:with: to: self;
		tabSelector: self;
		vSpaceFill! !

!GLMTabSelectorBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/3/2015 20:18'!
newLabelMorph: aStringOrMorph selected: selectedStringOrMorph
	"Answer a new label morph with the given label text or morph and
	alternate when selected."

	^GLMTabLabelBrick new
		roundedCorners: #(1 4);
		cornerStyle: self cornerStyle;
		label: aStringOrMorph selected: selectedStringOrMorph;
		font: self font;
		on: #mouseDown send: #tabClicked:with: to: self;
		tabSelector: self;
		vSpaceFill! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:39'!
relabelTab: aTab with: aStringOrMorph
	"Relabel the tab update tab layout."

	aTab label: aStringOrMorph.
	aTab owner ifNotNil: [
		self updateTabs ]! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
removeTabIndex: anInteger
	"Remove the tab at the given index and
	adjust any selected (next or first if was last)."
	
	self tabs removeAt: anInteger.
	self selectedIndex: 0.
	self tabs ifNotEmpty: [
		self selectedIndex: self selectedIndex - 1 \\ self tabs size + 1]
		! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectNextTab
	"Select the next tab, or the first if none selected."
	
	self selectedIndex: self selectedIndex \\ self tabs size + 1! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectPreviousTab
	"Select the previous tab, or the last if none selected."
	
	self selectedIndex: (self selectedIndex < 2
		ifTrue: [self tabs size]
		ifFalse: [self selectedIndex - 1])! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectedIndex
	"Answer the value of selectedIndex"

	^ selectedIndex! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:41'!
selectedIndex: index
	"Set the value of selectedIndex"

	|oldIndex|
	selectedIndex == index ifTrue: [^self].
	oldIndex := selectedIndex.
	selectedIndex := (index min: self tabs size).
	self updateTabs.
	self changed: #selectedIndex with: oldIndex! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectedTab
	"Answer the selected tab."
	
	^self selectedIndex = 0
		ifFalse: [self tabs at: self selectedIndex ifAbsent: [nil]]! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabClicked: evt with: aMorph 
	"A tab has been clicked."
	
	self selectedIndex: (self tabs indexOf: aMorph)! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabs

	^ tabs! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabs: anObject

	tabs := anObject! !

!GLMTabSelectorBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
updateFont
	"Update the label font."

	self tabs do: [:t | t font: self font].
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/3/2015 20:22'!
updateTabs
	"Update the submorphs based on visible tabs."

	|selectedTab|
	self removeAllBricks.
	self tabs ifEmpty: [^self].
	selectedTab := self selectedTab.
	self tabs do: [:t |
		t selected: (t == selectedTab).
		t hSpaceFill: 100 / self tabs size ].
	self
		addAllBricks: self tabs;
		adoptPaneColor.
	
	self brickRoot doLayoutForce.! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/11/2015 15:18'!
asBrick
	
	^ GLMMorphBrick on: self! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/20/2015 22:58'!
brickDoubleLink

	^ self valueOfProperty: #brickDoubleLink ifAbsentPut: [ nil ]! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/20/2015 22:58'!
brickDoubleLink: aDoubleLink

	self setProperty: #brickDoubleLink toValue: aDoubleLink! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/30/2015 16:29'!
brickThemer
	^ (self nearestOwnerThat: [ :each | (each isKindOf: GLMFoundationBrick) | (each isKindOf: GLMBrick) ])
		ifNotNil: [ :brick | brick themer ]
		ifNil: [ self theme brickThemer ]! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/30/2015 16:47'!
brickThemerChanged

	self submorphs do: #brickThemerChanged! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 2/11/2015 12:56'!
brickTransparentImageForm
	|background form|
	background := self color.
	self color: Color transparent.
	form := self imageForm.
	self color: background.
	^ form! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'TudorGirba 12/5/2014 06:41'!
exportAsPNGSilently
	| fName time |
	time := (DateAndTime now asString copyReplaceAll: ':' with: '-') copyReplaceAll: '.' with: '-'.
	fName := self externalName, time , '.png'.
	PNGReadWriter putForm: self imageForm onFileNamed: fName! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 10/17/2014 15:28'!
isBrick

	^ false! !

!CompiledMethod methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 22:13'!
phlowValue: anObject withEnoughArguments: aCollection

	^ anObject withArgs: aCollection executeMethod: self! !

LayoutPolicy subclass: #GLMLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

GLMLinearLayout subclass: #GLMHorizontalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

GLMHorizontalLinearLayout class
	instanceVariableNames: 'uniqueInstance'!

GLMHorizontalLinearLayout class
	instanceVariableNames: 'uniqueInstance'!

!GLMHorizontalLinearLayout class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 11:15'!
example
	<example>
	| brick brick1 brick2 |
	brick := GLMBrick new
		color: Color blue;
		layout: self new;
		hShrinkWrap;
		height: 200.
		
	brick1 := GLMBrick new
		color: Color red;
		layout: self new;
		width: 100;
		vSpaceFill.
		
	brick2 := GLMBrick new
		color: Color green;
		layout: self new;
		width: 150;
		height: 50.
		
	brick
		addBrickBack: brick1;
		addBrickBack: brick2.
		
	brick asBrickedMorph
		color: Color white;
		openInWindow! !

!GLMHorizontalLinearLayout class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 11:27'!
example2
	<example>
	| brick brick1 brick2 brick3|
	brick := GLMBrick new
		color: Color blue;
		layout: self new;
		width: 400;
		height: 300.
		
	brick1 := GLMBrick new
		color: Color red;
		layout: self new;
		hSpaceFill: 75;
		vSpaceFill: 25.
	
	brick2 := GLMBrick new
		color: Color green;
		layout: self new;
		hSpaceFill: 25;
		vSpaceFill: 75.
	
	brick3 := GLMBrick new
		color: Color yellow;
		layout: self new;
		width: 50;
		height: 50.
	
	brick
		addBrickBack: brick1;
		addBrickBack: brick2;
		addBrickBack: brick3.
		
	brick asBrickedMorph
		color: Color white;
		openInWindow! !

!GLMHorizontalLinearLayout class methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/3/2015 10:36'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GLMHorizontalLinearLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/4/2015 13:19'!
align: aBrick in: parentBrick anchorPoint: aPoint
	|align|
	align := aBrick layout vAlign.
	
	align = #none ifTrue: [ ^ self ].
	align = #left ifTrue: [ ^ self ].
	align = #center ifTrue: [
		^ aBrick translateX: ((parentBrick innerBounds width - aBrick outerBounds width) / 2) asInteger ].
	align = #right ifTrue: [ ^ self ].! !

!GLMHorizontalLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/8/2015 18:50'!
heightChildrenDependency: aBrick
	"returns the height of aBrick when it depends on children"
	"in case of horizontal linear layout it is the height of the highest subbrick + corresponding paddings"
	^ aBrick paddingTop + aBrick paddingBottom + (((self nonFloatSubbricks: aBrick) detectMax: [ :each | each outerBounds height ])
		ifNil: [ 0 ]
		ifNotNil: [ :m | m outerBounds height ])! !

!GLMHorizontalLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/3/2015 10:06'!
heightParentDependency: aBrick
	"if aBrick depends on parent we calculate it as a percentage of the parent"
	aBrick owner ifNil: [ Exception signal: 'My height depends on parent, but it is nil' ].
	^ (aBrick owner wrappedBounds innerBounds height * aBrick layout vPercent / 100) ceiling! !

!GLMHorizontalLinearLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/8/2015 17:28'!
layout: aBrick in: newBounds

	self
		layout: aBrick
		in: newBounds
		inject: aBrick paddingLeft @ aBrick paddingTop
		into: [ :origin :each |
			each wrappedBounds outerOrigin: origin.
			each wrappedBounds outerBounds width@0 ]! !

!GLMHorizontalLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/8/2015 18:51'!
widthChildrenDependency: aBrick
	"returns the width of aBrick when it depends on children"
	^ aBrick paddingLeft + aBrick paddingRight + ((self nonFloatSubbricks: aBrick) detectSum: [ :each | each outerBounds width ])! !

!GLMHorizontalLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/9/2015 23:54'!
widthParentDependency: aBrick
	|allowedWidth|
	aBrick owner ifNil: [ Exception signal: 'My width depends on parent, but it is nil' ].
	allowedWidth := aBrick owner subbricks inject: aBrick owner wrappedBounds innerBounds width into: [ :width :each |
		each wrappedBounds isWidthClean ifTrue: [
			(each isWidthDependsOnParent not | (self hasWidthRestrictions: each))
				ifTrue: [ width - each wrappedBounds outerBounds width ]
				ifFalse: [ width ] ]
			ifFalse: [ width ] ].
	^ (allowedWidth * aBrick layout hPercent / 100) ceiling! !

!GLMLinearLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/4/2015 13:12'!
align: aBrick in: parentBrick anchorPoint: aPoint

	^ self subclassResponsibility! !

!GLMLinearLayout methodsFor: 'floating' stamp: 'AliakseiSyrel 2/8/2015 17:13'!
floatingMethodFor: aSymbol

	^ ('layoutFloating', (aSymbol capitalized), ':in:') asSymbol! !

!GLMLinearLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/9/2015 22:47'!
hasHeightRestrictions: aBrick

	^ aBrick layout hasMinHeight | aBrick layout hasMaxHeight! !

!GLMLinearLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/9/2015 22:48'!
hasWidthRestrictions: aBrick

	^ aBrick layout hasMinWidth | aBrick layout hasMaxWidth! !

!GLMLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/3/2015 09:28'!
heightChildrenDependency: aBrick

	^ self subclassResponsibility! !

!GLMLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/3/2015 18:10'!
heightMyselfDependency: aBrick
	"when height depends only from aBrick just return its cutom height"
	
	^ aBrick customHeight! !

!GLMLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/3/2015 10:09'!
heightParentDependency: aBrick

	^ self subclassResponsibility! !

!GLMLinearLayout methodsFor: 'floating' stamp: 'AliakseiSyrel 2/8/2015 17:22'!
isFloating: aBrick
	
	aBrick layoutProperties floating = #none ifTrue: [ ^ false ].
	
	^ self respondsTo: (self floatingMethodFor: aBrick layoutProperties floating)! !

!GLMLinearLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/3/2015 09:23'!
layout: aBrick in: newBounds

	^ self subclassResponsibility! !

!GLMLinearLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/8/2015 18:22'!
layout: aBrick in: aRectangle inject: anInteger into: aBlock

	aBrick subbricks inject: anInteger into:[ :origin :each | |result|
		result := origin + ((self isFloating: each)
			ifFalse: [ aBlock cull: origin cull: each ]
			ifTrue: [ self layoutFloating: each in: aRectangle ]).
		"applying aligning: #none, #left, #center, #right"
		self align: each in: aBrick anchorPoint: origin.
		each onLayouted.
		result ].! !

!GLMLinearLayout methodsFor: 'floating' stamp: 'AliakseiSyrel 2/8/2015 17:14'!
layoutFloating: aBrick in: newBounds
	"must return an integer that will be added to the offset, if necessary"
	
	|float symbol|
	float := aBrick layoutProperties floating.
	symbol := self floatingMethodFor: float.
	
	^ (self respondsTo: symbol)
		ifTrue: [ self perform: symbol with: aBrick with: newBounds ]
		ifFalse: [ 0 ]! !

!GLMLinearLayout methodsFor: 'floating' stamp: 'AliakseiSyrel 2/8/2015 18:38'!
layoutFloatingLeft: aBrick in: newBounds
	| left top |
	
	left := aBrick marginLeft.
	top := aBrick marginTop.
	
	aBrick brickBounds: (left@top extent: aBrick extent).
	
	^ 0! !

!GLMLinearLayout methodsFor: 'floating' stamp: 'AliakseiSyrel 2/8/2015 19:43'!
layoutFloatingRight: aBrick in: newBounds
	| left top |
	
	left := aBrick owner width - aBrick width - aBrick marginRight.
	top := aBrick marginTop.
	
	aBrick brickBounds: (left@top extent: aBrick extent).
	
	^ 0! !

!GLMLinearLayout methodsFor: 'enumerating' stamp: 'AliakseiSyrel 2/8/2015 18:51'!
nonFloatSubbricks: aBrick

	^ aBrick subbricks select: [ :each | each layout floating = #none ]! !

!GLMLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/9/2015 22:54'!
normalizeHeight: anInteger of: aBrick

	^ (anInteger max: (aBrick layout minHeight brickValue: aBrick))
		min: (aBrick layout maxHeight brickValue: aBrick)! !

!GLMLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/9/2015 22:54'!
normalizeWidth: anInteger of: aBrick

	^ (anInteger max: (aBrick layout minWidth brickValue: aBrick))
		min: (aBrick layout maxWidth brickValue: aBrick)! !

!GLMLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/9/2015 22:56'!
updateHeight: aBrick
	"this method should be called only when height of aBrick is dirty"
	aBrick wrappedBounds isHeightClean ifTrue: [ Exception signal: 'Clean height can''t be updated!!' ].
	"when my height depends on children I set it to be able to fit the highest subbrick"
	aBrick isHeightDependsOnChildren ifTrue: [ aBrick wrappedBounds height: (self normalizeHeight: (self heightChildrenDependency: aBrick) of: aBrick) ].
	"when my height depends only from myself I can directly set it"
	aBrick isHeightDependsOnMyself ifTrue: [ aBrick wrappedBounds height: (self normalizeHeight: (self heightMyselfDependency: aBrick) of: aBrick) ].
	"when my height depends only from my parent"
	aBrick isHeightDependsOnParent ifTrue: [ aBrick wrappedBounds outerHeight: (self normalizeHeight: (self heightParentDependency: aBrick) of: aBrick) ].
	
	
	! !

!GLMLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/9/2015 22:56'!
updateWidth: aBrick
	"aBrick is a Brick that uses me as current layout"
	"this method should be called only when width of aBrick is dirty"
	aBrick wrappedBounds isWidthClean ifTrue: [ Exception signal: 'Clean width can''t be updated!!' ].
	"when my width depends on children I set it to be able to fit all subbricks"
	aBrick isWidthDependsOnChildren ifTrue: [ aBrick wrappedBounds width: (self normalizeWidth: (self widthChildrenDependency: aBrick) of: aBrick) ].
	"when my width depends only from myself I can directly set it"
	aBrick isWidthDependsOnMyself ifTrue: [ aBrick wrappedBounds width: (self normalizeWidth: (self widthMyselfDependency: aBrick) of: aBrick) ].
	"when my width depends only from my parent"
	aBrick isWidthDependsOnParent ifTrue: [ aBrick wrappedBounds outerWidth: (self normalizeWidth: (self widthParentDependency: aBrick) of: aBrick) ].
	
	
	! !

!GLMLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/3/2015 09:28'!
widthChildrenDependency: aBrick

	^ self subclassResponsibility! !

!GLMLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/3/2015 18:15'!
widthMyselfDependency: aBrick

	^ aBrick customWidth! !

!GLMLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/3/2015 10:09'!
widthParentDependency: aBrick
	
	^ self subclassResponsibility! !

GLMLinearLayout subclass: #GLMVerticalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

GLMVerticalLinearLayout class
	instanceVariableNames: 'uniqueInstance'!

GLMVerticalLinearLayout class
	instanceVariableNames: 'uniqueInstance'!

!GLMVerticalLinearLayout class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 11:03'!
example
	<example>
	| brick brick1 brick2 |
	brick := GLMBrick new
		color: Color blue;
		layout: self new;
		hShrinkWrap;
		height: 200.
		
		
	brick1 := GLMBrick new
		color: Color red;
		layout: self new;
		width: 100;
		vSpaceFill.
		
	brick2 := GLMBrick new
		color: Color green;
		layout: self new;
		width: 150;
		height: 50.
		
	brick
		addBrickBack: brick1;
		addBrickBack: brick2.
		
	brick asBrickedMorph
		color: Color white;
		openInWindow! !

!GLMVerticalLinearLayout class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 11:03'!
example2
	<example>
	| brick brick1 brick2 brick3|
	brick := GLMBrick new
		color: Color blue;
		layout: self new;
		width: 400;
		height: 300.
		
	brick1 := GLMBrick new
		color: Color red;
		layout: self new;
		hSpaceFill: 75;
		vSpaceFill: 25.
	
	brick2 := GLMBrick new
		color: Color green;
		layout: self new;
		hSpaceFill: 25;
		vSpaceFill: 75.
	
	brick3 := GLMBrick new
		color: Color yellow;
		layout: self new;
		width: 50;
		height: 50.
	
	brick
		addBrickBack: brick1;
		addBrickBack: brick2;
		addBrickBack: brick3.
		
	brick asBrickedMorph
		color: Color white;
		openInWindow! !

!GLMVerticalLinearLayout class methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/4/2015 13:20'!
reset
	"
	self reset
	"
	uniqueInstance := nil! !

!GLMVerticalLinearLayout class methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/3/2015 10:36'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GLMVerticalLinearLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/12/2015 12:37'!
align: aBrick in: parentBrick anchorPoint: aPoint
	|align|
	align := aBrick layout hAlign.
	
	align = #none ifTrue: [ ^ self ].
	align = #left ifTrue: [ ^ self ].
	align = #center ifTrue: [
		^ aBrick translateX: ((parentBrick innerBounds width - aBrick outerBounds width) / 2) asInteger ].
	align = #right ifTrue: [
		^ aBrick translateX: ((parentBrick innerBounds width - aBrick outerBounds width)) asInteger ].! !

!GLMVerticalLinearLayout methodsFor: 'height' stamp: 'AliakseiSyrel 2/8/2015 18:50'!
heightChildrenDependency: aBrick
	"returns the height of aBrick when it depends on children"
	^ aBrick paddingTop + aBrick paddingBottom + ((self nonFloatSubbricks: aBrick) detectSum: [ :each | each outerBounds height ])! !

!GLMVerticalLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/9/2015 23:53'!
heightParentDependency: aBrick
	| allowedHeight |
	aBrick owner ifNil: [ Exception signal: 'My height depends on parent, but it is nil' ].
	allowedHeight := aBrick owner subbricks inject: aBrick owner wrappedBounds innerBounds height into: [ :height :each |
		each wrappedBounds isHeightClean ifTrue: [
			(each isHeightDependsOnParent not | (self hasHeightRestrictions: each))
				ifTrue: [ height - each wrappedBounds outerBounds height ]
				ifFalse: [ height ] ]
			ifFalse: [ height ] ].
	^ (allowedHeight * aBrick layout vPercent / 100) ceiling! !

!GLMVerticalLinearLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/8/2015 17:28'!
layout: aBrick in: newBounds

	self
		layout: aBrick
		in: newBounds
		inject: aBrick paddingLeft @ aBrick paddingTop
		into: [ :origin :each |
			each wrappedBounds outerOrigin: origin.
			0@each wrappedBounds outerBounds height ]! !

!GLMVerticalLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/8/2015 18:50'!
widthChildrenDependency: aBrick
	"returns the height of aBrick when it depends on children"
	"in case of horizontal linear layout it is the height of the highest subbrick + corresponding paddings"
	^ aBrick paddingLeft + aBrick paddingRight + (((self nonFloatSubbricks: aBrick) detectMax: [ :each | each outerBounds width ])
		ifNil: [ 0 ]
		ifNotNil: [ :m | m outerBounds width ])! !

!GLMVerticalLinearLayout methodsFor: 'width' stamp: 'AliakseiSyrel 2/3/2015 10:01'!
widthParentDependency: aBrick
	
	aBrick owner ifNil: [ Exception signal: 'My width depends on parent, but it is nil' ].
	^ (aBrick owner wrappedBounds innerBounds width * aBrick layout hPercent / 100) ceiling! !

!AbstractLayout methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 13:14'!
slotsDictionary

	^ Dictionary new! !

!UndefinedObject methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 21:15'!
phlowValue: anObject

	^ anObject! !

!UndefinedObject methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 21:38'!
phlowValue: anObject value: otherObject

	^ anObject! !

!UndefinedObject methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 22:04'!
phlowValue: anObject withEnoughArguments: aCollection

	^ aCollection first! !

!String methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 2/12/2015 17:52'!
asBrick

	^ GLMLabelBrick new
		text: self asString;
		height: [ :b | b approximateHeight ]! !

!BlockClosure methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/20/2015 17:25'!
brickValue: aBrick

	^ self cull: aBrick! !

!BlockClosure methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 21:43'!
phlowValue: anObject

	^ self cull: anObject! !

!BlockClosure methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 21:34'!
phlowValue: anObject value: otherObject

	^ self cull: anObject cull: otherObject! !

!BlockClosure methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 21:45'!
phlowValue: anObject withEnoughArguments: aCollection

	^ self valueWithEnoughArguments:  aCollection! !

!Slot methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 21:40'!
phlowValue: anObject
	
	^ anObject! !

!Slot methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 21:40'!
phlowValue: anObject value: otherObject
	
	^ self write: otherObject to: anObject! !

!Symbol methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/20/2015 17:26'!
brickValue: aBrick

	^ self cull: aBrick! !

!Symbol methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 22:32'!
phlowValue: anObject

	^ self cull: anObject! !

!Symbol methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 21:43'!
phlowValue: anObject value: otherObject

	^ anObject perform: self withEnoughArguments: { otherObject }! !

!Symbol methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 21:44'!
phlowValue: anObject withEnoughArguments: aCollection

	^ anObject perform: self withEnoughArguments: aCollection! !

!LayoutClassScope methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 22:24'!
slotsDictionary
	| result |
	result := Dictionary new.
	self allSlotsDo: [ :slot |  result at: slot name put: slot].
	^ result! !

!Text methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 2/12/2015 17:53'!
asBrick

	^ self asString asBrick! !

Announcement subclass: #GLMBrickAnnouncement
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickAnnouncement commentStamp: 'AliakseiSyrel 10/17/2014 10:11' prior: 0!
A GLMBrickAnnouncement is default announcement used for any purpose by bricks.

Instance Variables
	data:		<Object>

data
	- xxxxx
!

!GLMBrickAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data
	^ data! !

!GLMBrickAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data: anObject
	data := anObject! !

GLMBrickAnnouncement subclass: #GLMBrickDataChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickDataChanged commentStamp: 'AliakseiSyrel 10/17/2014 10:11' prior: 0!
A GLMBrickDataChanged is fired when GLMBrick>>data is changed
!

GLMBrickAnnouncement subclass: #GLMBrickLayoutEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

GLMBrickLayoutEvent subclass: #GLMBrickLayoutStacked
	instanceVariableNames: 'index position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:34'!
index
	^ index! !

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:34'!
index: anObject
	index := anObject! !

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:35'!
position
	^ position! !

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:35'!
position: anObject
	position := anObject! !

GLMBrickAnnouncement subclass: #GLMBrickScrollPositionChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!Pharo3DarkTheme methodsFor: '*Glamour-Morphic-Brick' stamp: 'MarkRizun 2/3/2015 14:32'!
brickThemer

	^ GLMBrickDarkThemer new! !

!Color class methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 11/29/2014 17:39'!
colorFromRGBInteger: anInteger
	|red green blue|
	
	blue := (anInteger >> 16) & 16r0ff.
	green := (anInteger >> 8) & 16r0ff.
	red := anInteger & 16r0ff.	
	
	^ self r: red g: green b: blue range: 255.
! !

!Color methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 11/29/2014 17:27'!
asRGBInteger

	^(self red * 255) asInteger + ((self green * 255) asInteger << 8) + ((self blue * 255) asInteger << 16)! !

!PointerLayout methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 13:15'!
slotsDictionary
	
	^ slotScope slotsDictionary! !

TableLayoutProperties subclass: #GLMBrickLayoutProperties
	instanceVariableNames: 'floating hAlign heightDependencies horizontalPercent maxHeight maxWidth minHeight vAlign verticalPercent widthDependencies zIndex minWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickLayoutProperties commentStamp: 'AliakseiSyrel 10/17/2014 10:13' prior: 0!
A GLMBrickLayoutProperties is  a holder class of layout properties used by layout policy

Instance Variables
	horizontalPercent:		<Object>
	marginBottom:		<Object>
	marginLeft:		<Object>
	marginRight:		<Object>
	marginTop:		<Object>
	maxHeightBlock:		<Object>
	maxWidthBlock:		<Object>
	minHeight:		<Object>
	minWidth:		<Object>
	paddingBottom:		<Object>
	paddingLeft:		<Object>
	paddingRight:		<Object>
	paddingTop:		<Object>
	verticalPercent:		<Object>

horizontalPercent
	- xxxxx

marginBottom
	- xxxxx

marginLeft
	- xxxxx

marginRight
	- xxxxx

marginTop
	- xxxxx

maxHeightBlock
	- xxxxx

maxWidthBlock
	- xxxxx

minHeight
	- xxxxx

minWidth
	- xxxxx

paddingBottom
	- xxxxx

paddingLeft
	- xxxxx

paddingRight
	- xxxxx

paddingTop
	- xxxxx

verticalPercent
	- xxxxx
!

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 00:21'!
floating

	^ floating ifNil: [ floating := #none ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 11/19/2014 19:47'!
floating: aSymbol
	floating := aSymbol! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 00:21'!
hAlign

	^ hAlign ifNil: [ hAlign := #none ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/4/2015 13:09'!
hAlign: aSymbol

	hAlign := aSymbol! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/10/2015 00:20'!
hPercent

	^ horizontalPercent ifNil: [ horizontalPercent := 0 ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/10/2015 00:18'!
hPercent: anInteger

	horizontalPercent := anInteger! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/3/2015 10:40'!
hShrinkWrap
	"my width will change to fit children"
	self hResizing: #shrinkWrap! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/3/2015 10:42'!
hSpaceFill
	"my width will change to fill 100% of my parent"
	self hPercent: 100.
	self hResizing: #spaceFill! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/3/2015 10:42'!
hSpaceFill: anInteger
	"my width will change to fill anInteger percents of my parent"
	self hPercent: anInteger.
	self hResizing: #spaceFill! !

!GLMBrickLayoutProperties methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 22:39'!
hasMaxHeight

	^ (self maxHeight isNumber ifTrue: [ self maxHeight isInfinite ] ifFalse: [ false ]) not! !

!GLMBrickLayoutProperties methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 22:40'!
hasMaxWidth

	^ (self maxWidth isNumber ifTrue: [ self maxWidth isInfinite ] ifFalse: [ false ]) not! !

!GLMBrickLayoutProperties methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 22:40'!
hasMinHeight

	^ (self minHeight isNumber ifTrue: [ self minHeight <= 0 ] ifFalse: [ false ]) not! !

!GLMBrickLayoutProperties methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 22:40'!
hasMinWidth

	^ (self minWidth isNumber ifTrue: [ self minWidth <= 0 ] ifFalse: [ false ]) not! !

!GLMBrickLayoutProperties methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 16:43'!
heightDependencies

	^ heightDependencies ifNil: [ heightDependencies := OrderedCollection new ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting-advanced' stamp: 'AliakseiSyrel 2/3/2015 16:43'!
heightDependency: anObject

	self heightDependencies add: anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/9/2015 22:14'!
maxHeight

	^ maxHeight ifNil: [ maxHeight := Float infinity ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/9/2015 22:12'!
maxHeight: anObject

	maxHeight := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/9/2015 22:14'!
maxWidth

	^ maxWidth ifNil: [ maxWidth := Float infinity ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/9/2015 22:12'!
maxWidth: anObject

	maxWidth := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/9/2015 22:15'!
minHeight

	^ minHeight ifNil: [ minHeight := 0 ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/9/2015 22:12'!
minHeight: anObject
	
	minHeight := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/9/2015 22:15'!
minWidth

	^ minWidth ifNil: [ minWidth := 0 ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/9/2015 23:08'!
minWidth: anObject
	minWidth := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 00:22'!
vAlign

	^ vAlign ifNil: [ vAlign := #none ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/4/2015 13:09'!
vAlign: aSymbol

	vAlign := aSymbol! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/10/2015 00:20'!
vPercent

	^ verticalPercent ifNil: [ verticalPercent := 0 ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/10/2015 00:15'!
vPercent: anInteger

	verticalPercent := anInteger! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/3/2015 10:51'!
vShrinkWrap

	self vResizing: #shrinkWrap! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/3/2015 10:52'!
vSpaceFill
	"my height will change to fill 100% of my parent"
	self vPercent: 100.
	self vResizing: #spaceFill! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 2/3/2015 10:52'!
vSpaceFill: anInteger
	"my height will change to fill anInteger percents of my parent"
	self vPercent: anInteger.
	self vResizing: #spaceFill! !

!GLMBrickLayoutProperties methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 16:42'!
widthDependencies

	^ widthDependencies ifNil: [ widthDependencies := OrderedCollection new ]	! !

!GLMBrickLayoutProperties methodsFor: 'scripting-advanced' stamp: 'AliakseiSyrel 2/3/2015 16:43'!
widthDependency: anObject

	self widthDependencies add: anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/10/2015 00:21'!
zIndex

	^ zIndex ifNil: [ zIndex := 1 ]! !

!GLMBrickLayoutProperties methodsFor: 'scripting' stamp: 'AliakseiSyrel 11/27/2014 20:49'!
zIndex: anObject
	zIndex := anObject! !

IndexedSlot subclass: #GLMPhlowSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowSlot methodsFor: 'meta-object-protocol' stamp: 'AliakseiSyrel 1/23/2015 21:32'!
write: aValue to: anObject
	|result|
	result := anObject instVarAt: index put: aValue.
	anObject onSlotChanged: self.
	^ result! !

!ClassDescription methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 13:17'!
slotsDictionary

	^self layout slotsDictionary! !

Object subclass: #GLMBrickAbstractAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Model'!

!GLMBrickAbstractAdaptor commentStamp: 'AliakseiSyrel 12/6/2014 20:15' prior: 0!
A GLMBrickAbstractAdaptor is an interface for all adaptors to be used with brick lazy widgets!

!GLMBrickAbstractAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 18:50'!
count

	self subclassResponsibility! !

!GLMBrickAbstractAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 18:53'!
morphAt: anInteger convert: aMorph

	self subclassResponsibility! !

GLMBrickAbstractAdaptor subclass: #GLMBrickListAdaptor
	instanceVariableNames: 'origin countLogic morphLogic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Model'!

!GLMBrickListAdaptor commentStamp: 'AliakseiSyrel 12/6/2014 20:15' prior: 0!
A GLMBrickListAdaptor is scriptable implementation of adaptor that is mostly used with list scroll brick

Instance Variables
	countLogic:		<Object>
	morphLogic:		<Object>
	origin:		<Object>

countLogic
	- xxxxx

morphLogic
	- xxxxx

origin
	- xxxxx
!

!GLMBrickListAdaptor class methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 19:53'!
on: anObject

	^ self new on: anObject! !

!GLMBrickListAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 19:49'!
count

	^ countLogic
		ifNil: [ origin size ]
		ifNotNil: [ countLogic cull: origin ] ! !

!GLMBrickListAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 20:03'!
morphAt: anInteger convert: aMorph

	^ morphLogic
		ifNil: [ (origin at: anInteger) asMorph ]
		ifNotNil: [
			morphLogic isSymbol
				ifTrue: [ origin perform: morphLogic withEnoughArguments: { anInteger . aMorph }  ]
				ifFalse: [ morphLogic cull: anInteger cull: aMorph ] ]! !

!GLMBrickListAdaptor methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 19:59'!
morphAtLogic: aBlockWithTwoParameters

	morphLogic := aBlockWithTwoParameters! !

!GLMBrickListAdaptor methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 20:00'!
on: anObject

	origin := anObject! !

!GLMBrickListAdaptor methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/11/2015 15:23'!
origin

	^ origin! !

!GLMBrickListAdaptor methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 19:59'!
sizeLogic: aBlockWithNoParameters

	countLogic := aBlockWithNoParameters! !

Object subclass: #GLMBrickBorder
	instanceVariableNames: 'width color'
	classVariableNames: 'Bottom Left Right Top'
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Utils'!

!GLMBrickBorder class methodsFor: 'class initialization' stamp: 'AliakseiSyrel 2/11/2015 11:28'!
initialize
	super initialize.
	
	Top := 1.
	Right := 2.
	Bottom := 3.
	Left := 4! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:29'!
color

	^ color ifNil: [ color := Array braceWith: Color transparent with: Color transparent with: Color transparent with: Color transparent ]! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:36'!
color: colors
	"The colors property may have from one to four values:
	
	color: { Color red . Color blue . Color green . Color yellow }
		top color is red
		right color is blue
		bottom color is green
		left color is yellow
		
	color: { Color red . Color blue . Color green }
		top color is red
		right and left colors are blue
		bottom color is green
		
	color: { Color red . Color blue }
		top and bottom colors are red
		right and left colors are blue
		
	color: { Color red }
		all four colors are red
		
	color: Color red
		all four colors are red"
	
	colors ifNil: [ ^ self color: #(0) ].
	
	colors isCollection ifTrue: [
		colors isEmpty ifTrue: [ ^ self color: #(0) ].
		self
			colorTop: (colors at: 1);
			colorRight: (colors at: 1);
			colorBottom: (colors at: 1);
			colorLeft: (colors at: 1).
		colors size > 1 ifTrue: [
			self
				colorRight: (colors at: 2);
				colorLeft: (colors at: 2) ].
		colors size > 2 ifTrue: [
			self colorBottom: (colors at: 3) ].
		colors size > 3 ifTrue: [
			self colorLeft: (colors at: 4) ] ]
	ifFalse: [ ^ self color: { colors } ].! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:53'!
colorBottom

	^ self color at: Bottom! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:29'!
colorBottom: aColor

	self color at: Bottom put: aColor! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:53'!
colorLeft

	^ self color at: Left! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:38'!
colorLeft: aColor
	"aColor may be any object, it will be called with brickValue: aBrick"
	self color at: Left put: aColor! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:53'!
colorRight

	^ self color at: Right! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:29'!
colorRight: aColor

	self color at: Right put: aColor! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:53'!
colorTop

	^ self color at: Top! !

!GLMBrickBorder methodsFor: 'color' stamp: 'AliakseiSyrel 2/11/2015 11:29'!
colorTop: aColor

	self color at: Top put: aColor! !

!GLMBrickBorder methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/11/2015 12:15'!
renderBorderOf: aBrick on: aCanvas
	|canvas widthLeft widthRight widthTop widthBottom colorLeft colorRight colorTop colorBottom|
	
	canvas := aCanvas asBalloonCanvas.
	
	widthLeft := self widthLeft brickValue: aBrick.
	widthRight := self widthRight brickValue: aBrick.
	widthTop := self widthTop brickValue: aBrick.
	widthBottom := self widthBottom brickValue: aBrick.
	
	colorLeft := self colorLeft brickValue: aBrick.
	colorRight := self colorRight brickValue: aBrick.
	colorTop := self colorTop brickValue: aBrick.
	colorBottom := self colorBottom brickValue: aBrick.
	
	canvas
		drawRectangle: (aBrick brickBounds origin extent: ((aBrick brickBounds width - widthRight) @ widthTop))
		color: colorTop borderWidth: 0 borderColor: Color transparent.
		
	canvas
		drawRectangle: ((aBrick brickBounds right - widthRight) @ aBrick brickBounds top corner: (aBrick brickBounds corner - (0@widthBottom)))
		color: colorRight borderWidth: 0 borderColor: Color transparent.
		
	canvas
		drawRectangle: ((aBrick brickBounds bottomLeft - (widthLeft negated @ widthBottom)) corner: aBrick brickBounds corner)
		color: colorBottom borderWidth: 0 borderColor: Color transparent.
		
	canvas
		drawRectangle: ((aBrick brickBounds origin + (0@widthTop)) corner: (aBrick brickBounds bottomLeft + (widthLeft@0)))
		color: colorLeft borderWidth: 0 borderColor: Color transparent.! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:29'!
width

	^ width ifNil: [ width := Array braceWith: 0 with: 0 with: 0 with: 0 ]! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:41'!
width: widths
	"The widths property can have from one to four values:
	
	width: #(25 50 75 100)
		top width is 25px
		right width is 50px
		bottom width is 75px
		left width is 100px
		
	width: #(25 50 75)
		top width is 25px
		right and left widths are 50px
		bottom width is 75px
		
	width: #(25 50)
		top and bottom widths are 25px
		right and left widths are 50px
		
	width: #(25)
		all four widths are 25px
		
	width: 25
		all four widths are 25px"
	
	widths ifNil: [ ^ self width: #(0) ].
	
	widths isCollection ifTrue: [
		widths isEmpty ifTrue: [ ^ self width: #(0) ].
		self
			widthTop: (widths at: 1);
			widthRight: (widths at: 1);
			widthBottom: (widths at: 1);
			widthLeft: (widths at: 1).
		widths size > 1 ifTrue: [
			self
				widthRight: (widths at: 2);
				widthLeft: (widths at: 2) ].
		widths size > 2 ifTrue: [
			self widthBottom: (widths at: 3) ].
		widths size > 3 ifTrue: [
			self widthLeft: (widths at: 4) ] ]
	ifFalse: [ ^ self width: {widths} ]! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:37'!
widthBottom

	^ self width at: Bottom! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:37'!
widthBottom: anInteger

	self width at: Bottom put: anInteger! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:37'!
widthLeft

	^ self width at: Left! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:39'!
widthLeft: anInteger

	self width at: Left put: anInteger! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:37'!
widthRight

	^ self width at: Right! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:39'!
widthRight: anInteger

	self width at: Right put: anInteger! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:37'!
widthTop

	^ self width at: Top! !

!GLMBrickBorder methodsFor: 'width' stamp: 'AliakseiSyrel 2/11/2015 11:39'!
widthTop: anInteger

	self width at: Top put: anInteger! !

Object subclass: #GLMBrickBounds
	instanceVariableNames: 'bounds innerBounds outerBounds widthState heightState margin padding'
	classVariableNames: 'Bottom Left Right Top'
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Utils'!

!GLMBrickBounds class methodsFor: 'class initialization' stamp: 'AliakseiSyrel 2/1/2015 22:12'!
initialize
	super initialize.
	
	Top := 1.
	Right := 2.
	Bottom := 3.
	Left := 4! !

!GLMBrickBounds methodsFor: 'accessing - bounds' stamp: 'AliakseiSyrel 2/1/2015 22:02'!
bounds

	^ self brickBounds! !

!GLMBrickBounds methodsFor: 'accessing - bounds' stamp: 'AliakseiSyrel 2/8/2015 12:42'!
bounds: aRectangle
	"changes bounds and marks width or height as dirty if it changes"
	self updateState: aRectangle.
	self brickBounds: aRectangle! !

!GLMBrickBounds methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 22:03'!
brickBounds
	"brickBounds give direct access to the bounds Rectangle"
	^ bounds ifNil: [ bounds := 0@0 corner: 50@50 ]

	! !

!GLMBrickBounds methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 22:30'!
brickBounds: aRectangle
	"brickBounds give direct access to the bounds Rectangle"
	bounds := aRectangle.
	self updateCache! !

!GLMBrickBounds methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/1/2015 22:52'!
extent

	^ self brickBounds extent! !

!GLMBrickBounds methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/1/2015 22:51'!
height: anInteger

	self brickBounds: (self brickBounds withHeight: anInteger)! !

!GLMBrickBounds methodsFor: 'accessing - bounds' stamp: 'AliakseiSyrel 2/3/2015 15:33'!
heightState

	^ heightState ifNil: [ heightState := #dirty ]! !

!GLMBrickBounds methodsFor: 'accessing - bounds' stamp: 'AliakseiSyrel 1/30/2015 09:08'!
heightState: aSymbol

	heightState := aSymbol! !

!GLMBrickBounds methodsFor: 'accessing - bounds' stamp: 'AliakseiSyrel 2/1/2015 22:26'!
innerBounds

	^ innerBounds ifNil: [ self updateCache. innerBounds ]! !

!GLMBrickBounds methodsFor: 'testing' stamp: 'AliakseiSyrel 1/30/2015 09:08'!
isHeightClean

	^ self heightState = #clean! !

!GLMBrickBounds methodsFor: 'testing' stamp: 'AliakseiSyrel 1/30/2015 09:08'!
isHeightDirty

	^ self heightState = #dirty! !

!GLMBrickBounds methodsFor: 'testing' stamp: 'AliakseiSyrel 1/30/2015 09:05'!
isWidthClean

	^ self widthState = #clean! !

!GLMBrickBounds methodsFor: 'testing' stamp: 'AliakseiSyrel 1/30/2015 09:05'!
isWidthDirty

	^ self widthState = #dirty! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:11'!
margin

	"top right bottom left"
	^ margin ifNil: [ margin := Array braceWith: 0 with: 0 with: 0 with: 0 ]
! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/5/2015 11:55'!
margin: margins
	"The margins property can have from one to four values:
	
	margin: #(25 50 75 100)
		top margin is 25px
		right margin is 50px
		bottom margin is 75px
		left margin is 100px
		
	margin: #(25 50 75)
		top margin is 25px
		right and left margins are 50px
		bottom margin is 75px
		
	margin: #(25 50)
		top and bottom margins are 25px
		right and left margins are 50px
		
	margin: #(25)
		all four margins are 25px
		
	margin: 25
		all four margins are 25px"
	
	margins ifNil: [ ^ self margin: #(0) ].
	
	margins isCollection ifTrue: [
		margins isEmpty ifTrue: [ ^ self margin: #(0) ].
		self
			marginTop: (margins at: 1);
			marginRight: (margins at: 1);
			marginBottom: (margins at: 1);
			marginLeft: (margins at: 1).
		margins size > 1 ifTrue: [
			self
				marginRight: (margins at: 2);
				marginLeft: (margins at: 2) ].
		margins size > 2 ifTrue: [
			self marginBottom: (margins at: 3) ].
		margins size > 3 ifTrue: [
			self marginLeft: (margins at: 4) ] ]
	ifFalse: [ ^ self margin: {margins} ].
	
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:23'!
marginBottom

	^ self margin at: Bottom! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/8/2015 20:09'!
marginBottom: anInteger

	self translateY: self marginBottom - anInteger.
	self margin at: Bottom put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:24'!
marginLeft

	^ self margin at: Left! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/8/2015 20:07'!
marginLeft: anInteger

	self translateX: anInteger - self marginLeft.
	self margin at: Left put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:24'!
marginRight

	^ self margin at: Right! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/8/2015 20:08'!
marginRight: anInteger

	self translateX: self marginRight - anInteger.
	self margin at: Right put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:24'!
marginTop

	^ self margin at: Top! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/8/2015 20:08'!
marginTop: anInteger

	self translateY: anInteger - self marginTop.
	self margin at: Top put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'marking' stamp: 'AliakseiSyrel 1/30/2015 09:08'!
markHeightClean

	self heightState: #clean! !

!GLMBrickBounds methodsFor: 'marking' stamp: 'AliakseiSyrel 1/30/2015 09:09'!
markHeightDirty

	self heightState: #dirty! !

!GLMBrickBounds methodsFor: 'marking' stamp: 'AliakseiSyrel 1/30/2015 09:06'!
markWidthClean

	self widthState: #clean! !

!GLMBrickBounds methodsFor: 'marking' stamp: 'AliakseiSyrel 1/30/2015 09:06'!
markWidthDirty

	self widthState: #dirty! !

!GLMBrickBounds methodsFor: 'accessing - bounds' stamp: 'AliakseiSyrel 2/1/2015 22:27'!
outerBounds

	^ outerBounds ifNil: [ self updateCache. outerBounds ]! !

!GLMBrickBounds methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/3/2015 10:08'!
outerHeight: anInteger

	self brickBounds: (self brickBounds withHeight: (anInteger - self marginTop - self marginBottom))! !

!GLMBrickBounds methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/6/2015 12:29'!
outerOrigin: aPoint
	
	self brickBounds: (aPoint + (self marginLeft @ self marginTop) extent: self extent )! !

!GLMBrickBounds methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/8/2015 16:06'!
outerWidth: anInteger

	self brickBounds: (self brickBounds withWidth: (anInteger - self marginLeft - self marginRight))! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:20'!
padding

	"top right bottom left"
	^ padding ifNil: [ padding := Array braceWith: 0 with: 0 with: 0 with: 0 ]
! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/5/2015 11:56'!
padding: paddings
	"The paddings property can have from one to four values:
	
	padding: #(25 50 75 100)
		top padding is 25px
		right padding is 50px
		bottom padding is 75px
		left padding is 100px
		
	padding: #(25 50 75)
		top padding is 25px
		right and left paddings are 50px
		bottom padding is 75px
		
	padding: #(25 50)
		top and bottom paddings are 25px
		right and left paddings are 50px
		
	padding: #(25)
		all four paddings are 25px
		
	padding: 25
		all four paddings are 25px"
	
	paddings ifNil: [ ^ self padding: #(0) ].
	
	paddings isCollection ifTrue: [
		paddings isEmpty ifTrue: [ ^ self padding: #(0) ].
		self
			paddingTop: (paddings at: Top);
			paddingRight: (paddings at: Top);
			paddingBottom: (paddings at: Top);
			paddingLeft: (paddings at: Top).
		paddings size > Top ifTrue: [
			self
				paddingRight: (paddings at: Right);
				paddingLeft: (paddings at: Right) ].
		paddings size > Right ifTrue: [
			self paddingBottom: (paddings at: Bottom) ].
		paddings size > Bottom ifTrue: [
			self paddingLeft: (paddings at: Left) ] ]
	ifFalse: [ ^ self padding: { paddings } ].
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:25'!
paddingBottom

	^ self padding at: Bottom! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/5/2015 11:56'!
paddingBottom: anInteger

	self padding at: Bottom put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:24'!
paddingLeft

	^ self padding at: Left! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/5/2015 11:56'!
paddingLeft: anInteger

	self padding at: Left put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:25'!
paddingRight

	^ self padding at: Right! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/5/2015 11:56'!
paddingRight: anInteger

	self padding at: Right put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/1/2015 22:25'!
paddingTop

	^ self padding at: Top! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/5/2015 11:56'!
paddingTop: anInteger

	self padding at: Top put: anInteger.
	self updateCache! !

!GLMBrickBounds methodsFor: 'transformations' stamp: 'AliakseiSyrel 2/8/2015 20:04'!
translateBy: aPoint

	self brickBounds: (self brickBounds translateBy: aPoint)! !

!GLMBrickBounds methodsFor: 'transformations' stamp: 'AliakseiSyrel 2/8/2015 20:05'!
translateX: anInteger

	self translateBy: anInteger@0! !

!GLMBrickBounds methodsFor: 'transformations' stamp: 'AliakseiSyrel 2/8/2015 20:05'!
translateY: anInteger

	self translateBy: 0@anInteger! !

!GLMBrickBounds methodsFor: 'private' stamp: 'AliakseiSyrel 2/8/2015 19:57'!
updateCache
	|left top right bottom |
	
	left := self brickBounds origin x.
	top := self brickBounds origin y.
	right := self brickBounds corner x.
	bottom := self brickBounds corner y.
	
	innerBounds := ((left + self paddingLeft)@(top + self paddingTop)) corner: ((right - self paddingRight)@(bottom - self paddingBottom)).
	outerBounds := ((left - self marginLeft)@(top - self marginTop)) corner: ((right + self marginRight)@(bottom + self marginBottom)).! !

!GLMBrickBounds methodsFor: 'private' stamp: 'AliakseiSyrel 2/8/2015 12:43'!
updateState: aRectangle

	self brickBounds width = aRectangle width ifFalse: [ self markWidthDirty ].
	self brickBounds height = aRectangle height ifFalse: [ self markHeightDirty ]! !

!GLMBrickBounds methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/1/2015 22:52'!
width: anInteger

	self brickBounds: (self brickBounds withWidth: anInteger)! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 2/3/2015 15:33'!
widthState

	^ widthState ifNil: [ widthState := #dirty ]! !

!GLMBrickBounds methodsFor: 'accessing - margin/padding' stamp: 'AliakseiSyrel 1/30/2015 09:07'!
widthState: aSymbol

	widthState := aSymbol! !

Object subclass: #GLMBrickHorizontalFillLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts-compatibility'!

Object subclass: #GLMBrickLayoutTraverser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Utils'!

GLMBrickLayoutTraverser subclass: #GLMBrickHeightTraverser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Utils'!

GLMBrickHeightTraverser class
	instanceVariableNames: 'uniqueInstance'!

GLMBrickHeightTraverser class
	instanceVariableNames: 'uniqueInstance'!

!GLMBrickHeightTraverser class methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/1/2015 21:06'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 16:47'!
customDependencies: aBrick

	^ aBrick layout heightDependencies! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:30'!
hasMaxDimensionRestriction: aBrick

	^ aBrick layout hasMaxHeight! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:30'!
hasMinDimensionRestriction: aBrick

	^ aBrick layout hasMinHeight! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:34'!
isClean: aBrick

	^ aBrick wrappedBounds isHeightClean! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:38'!
isDependsOnChildren: aBrick

	^ aBrick isHeightDependsOnChildren ! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:38'!
isDependsOnMyself: aBrick
	
	^ aBrick isHeightDependsOnMyself! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:46'!
isDependsOnOpposite: aBrick
	
	^ aBrick isHeightDependsOnWidth! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:39'!
isDependsOnParent: aBrick
	
	^ aBrick isHeightDependsOnParent! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:51'!
isOppositeClean: aBrick

	^ aBrick wrappedBounds isWidthClean! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:43'!
isOppositeDependsOn: aBrick

	^ aBrick isWidthDependsOnHeight
	! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:29'!
markClean: aBrick

	aBrick wrappedBounds markHeightClean
	! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 10:22'!
markDirty: aBrick

	aBrick wrappedBounds markHeightDirty! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:52'!
markOppositeDirty: aBrick

	aBrick wrappedBounds markWidthDirty! !

!GLMBrickHeightTraverser methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/1/2015 21:08'!
opposite

	^ GLMBrickWidthTraverser uniqueInstance! !

!GLMBrickHeightTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/8/2015 18:16'!
updateDimension: aBrick
	"my height is already calculated, maybe because my children triggered calculation"
	aBrick wrappedBounds isHeightClean ifTrue: [ ^ self ].
	
	(self dimensionPolicy: aBrick) updateHeight: aBrick! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 16:47'!
customDependencies: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/8/2015 18:17'!
dimensionPolicy: aBrick

	^ ((self isDependsOnParent: aBrick)
		ifTrue: [
			aBrick owner
				ifNil: [ aBrick ]
				ifNotNil: [ :owner |
					owner isBrick
						ifTrue: [ owner ]
						ifFalse: [ aBrick ] ] ]
		ifFalse: [ aBrick ])
		layoutPolicy! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 18:06'!
hasCustomDependencies: aBrick

	^ (self customDependencies: aBrick) isEmpty not! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:31'!
hasDimensionRestrictions: aBrick

	^ (self hasMinDimensionRestriction: aBrick) | (self hasMaxDimensionRestriction: aBrick)! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:30'!
hasMaxDimensionRestriction: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:30'!
hasMinDimensionRestriction: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:33'!
isClean: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:36'!
isDependsOnChildren: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:36'!
isDependsOnMyself: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:36'!
isDependsOnOpposite: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:37'!
isDependsOnParent: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:50'!
isOppositeClean: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:43'!
isOppositeDependsOn: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/12/2015 12:28'!
layoutAround: aBrick inContext: aContextBrick
	"want to layout non-Brick object? nice try, bro."
	aBrick isBrick ifFalse: [ ^ self ].
	"if my dimension is clean why do you want to layout me?"
	(self isClean: aBrick) ifTrue: [ ^ self ].
	self flag: 'find better place'.
	aBrick changed.
	"custom dependencies are very dangerous, as it's complicated
	to detect cycles fast"
	(self customDependencies: aBrick)
		do: [ :each | |b|
			[ b :=  each brickValue: aBrick ] on: Exception do: [ b := nil ] .
			b ifNotNil: [ self layoutAround: b inContext: aBrick ] ].
		
	"children and parent dependencies must be before myself,
	because custom dimension can theoretically depend on children or parent"
	(self isDependsOnChildren: aBrick) ifTrue: [
		self layoutChildrenDependency: aBrick ].
	
	(self isDependsOnParent: aBrick) ifTrue: [
		self layoutParentDependency: aBrick ].
	
	(self isDependsOnMyself: aBrick) ifTrue: [
		self layoutMyselftDependency: aBrick ].
	
	(self isDependsOnOpposite: aBrick) ifTrue: [
		self layoutOppositeDependency: aBrick ].
	
	(self isOppositeDependsOn: aBrick) ifTrue: [
		self opposite layoutAround: aBrick inContext: nil ].
	
	"and finally we position them"
	self layoutSubbricks: aBrick.
	
	self flag: 'refactor it'.
	(aBrick layout vAlign = #none) not | (aBrick layout hAlign = #none) not ifTrue: [
		aBrick owner ifNotNil: [ self layoutSubbricks: aBrick owner ] ].
! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/3/2015 23:43'!
layoutChildrenDependency: aBrick
	
	"we need to calculate sizes of all subbricks"
	self layoutChildrenOf: aBrick.
	"first we calculate corresponding dimension"
	self updateDimension: aBrick.
	"after everything is done we can mark dimension as clean"
	self markClean: aBrick.
	"because my dimension changed, maybe my owner would like to adapt"
	self layoutOwnerOf: aBrick! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/3/2015 17:39'!
layoutChildrenOf: aBrick

	(self prioritySortedSubbricks: aBrick) do: [ :each | self layoutAround: each inContext: aBrick ]! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/3/2015 23:43'!
layoutMyselftDependency: aBrick
	
	"immidiately set my dimension"
	self updateDimension: aBrick.
	self markClean: aBrick.
	self layoutChildrenOf: aBrick.
	self layoutOwnerOf: aBrick! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/1/2015 21:19'!
layoutOppositeDependency: aBrick

	self opposite layoutAround: aBrick inContext: nil.
	self flag: 'set my size depending from opposite dimension'.
	self markClean: aBrick.
	self layoutChildrenOf: aBrick.
	self layoutOwnerOf: aBrick! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/1/2015 20:27'!
layoutOwnerOf: aBrick

	aBrick owner ifNotNil: [ self layoutAround: aBrick owner inContext: aBrick ]! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/12/2015 18:14'!
layoutParentDependency: aBrick

	aBrick owner ifNil: [ ^ self markClean: aBrick. "Exception signal: 'Dimension depends on parent, but owner is nil'" ].
	(self isDependsOnChildren: aBrick owner) ifTrue: [ Error signal: 'Circle dependency detected!!' ].
	
	"because I depend on my parent, it should be layouted first"
	self layoutOwnerOf: aBrick.
	"then I can update my dimension"
	self updateDimension: aBrick.
	"everething is done I can mark dimension as clean"
	self markClean: aBrick.
	"and I can say my children to layout themselves, because I'm already clean"
	self layoutChildrenOf: aBrick! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 16:16'!
layoutSubbricks: aBrick

	aBrick isBrick ifFalse: [ ^ self ].
	aBrick invalidateLayout! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:29'!
markClean: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:48'!
markDirty: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/8/2015 14:06'!
markDirtyAround: aBrick inContext: aContextBrick
	aBrick isBrick ifFalse: [ ^ self ].
	aBrick = aContextBrick ifTrue: [ ^ self ].
	
	aBrick owner ifNotNil: [
		(aBrick owner = aContextBrick) not & aBrick owner isBrick ifTrue: [
			(self isClean: aBrick owner) ifTrue: [
				(self isDependsOnChildren: aBrick owner) ifTrue: [
					self markDirty: aBrick owner.
					self markDirtyAround: aBrick owner inContext: aBrick ].
			
				((self isDependsOnMyself: aBrick) | (self isDependsOnChildren: aBrick) | (self isDependsOnOpposite: aBrick))
					ifTrue: [ (aBrick owner subbricks anySatisfy: [ :each | self isDependsOnParent: each]) ifTrue: [
						self markDirty: aBrick owner.
						self markDirtyChildrenAround: aBrick owner inContext: aBrick ] ] ] ] ].
	
	aBrick subbricks do: [ :each |
		each = aContextBrick ifFalse: [
			each isBrick ifTrue: [
			(self isDependsOnParent: each) & (self isClean: each) ifTrue: [
				self markDirty: each.
				self markDirtyAround: each inContext: aBrick ] ] ] ].
	
	(self isOppositeDependsOn: aBrick) & (self isOppositeClean: aBrick) ifTrue: [
		self markOppositeDirty: aBrick.
		self opposite markDirtyAround: aBrick inContext: nil ].
	
	self markDirtyCustomDependency: aBrick inContext: aContextBrick.
	aBrick subbricks do: [ :each | self markDirtyCustomDependency: each inContext: aBrick ]
	
! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/8/2015 14:05'!
markDirtyChildrenAround: aBrick inContext: aContextBrick

	aBrick subbricks do: [ :each |
		each = aContextBrick ifFalse: [
			each isBrick ifTrue: [
			(self isClean: each) ifTrue: [
				self markDirty: each.
				self markDirtyAround: each inContext: aBrick ] ] ] ].! !

!GLMBrickLayoutTraverser methodsFor: 'traversing' stamp: 'AliakseiSyrel 2/8/2015 13:50'!
markDirtyCustomDependency: aBrick inContext: aContextBrick
	(aBrick isBrick) not | (aBrick = aContextBrick) ifTrue: [ ^ self ].
	
	(self hasCustomDependencies: aBrick) ifTrue: [
				self markDirty: aBrick.
				aBrick subbricks do: [ :each | each isBrick ifTrue: [
						self markDirty: each.
						self markDirtyAround: each inContext: aBrick ] ].
				
				(self customDependencies: aBrick) do: [ :each | |brick|
					[ brick := each brickValue: aBrick ] on: Exception do: [ brick := nil ].
					brick ifNotNil: [
						(brick = aContextBrick) not & (brick = aBrick) not & brick isBrick ifTrue: [
							(self isClean: brick) ifTrue: [
								self markDirty: brick.
								self markDirtyAround: brick inContext: aBrick ] ] ] ] ]! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:52'!
markOppositeDirty: aBrick

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/1/2015 20:24'!
opposite

	^ self subclassResponsibility! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:50'!
prioritySortedSubbricks: aBrick
	|sorted|
	sorted := OrderedCollection newFrom: aBrick subbricks.
	sorted sort: [ :first :second | (self isDependsOnParent: first) ifFalse: [ true ]
		 ifTrue: [ (self isDependsOnParent: second) ifFalse: [ false ]
			ifTrue: [ (self hasDimensionRestrictions: first) ifFalse: [ false ]
				ifTrue: [ (self hasDimensionRestrictions: second) ifFalse: [ true ]
					ifTrue: [ (self hasMinDimensionRestriction: first) ifFalse: [ false ]
						ifTrue: [ true ] ] ] ] ] ].
	^ sorted! !

!GLMBrickLayoutTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 23:36'!
updateDimension: aBrick

	^ self subclassResponsibility! !

GLMBrickLayoutTraverser subclass: #GLMBrickWidthTraverser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Utils'!

GLMBrickWidthTraverser class
	instanceVariableNames: 'uniqueInstance'!

GLMBrickWidthTraverser class
	instanceVariableNames: 'uniqueInstance'!

!GLMBrickWidthTraverser class methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/1/2015 21:07'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 16:47'!
customDependencies: aBrick

	^ aBrick layout widthDependencies! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:30'!
hasMaxDimensionRestriction: aBrick

	^ aBrick layout hasMaxWidth! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2015 23:31'!
hasMinDimensionRestriction: aBrick

	^ aBrick layout hasMinWidth! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:34'!
isClean: aBrick

	^ aBrick wrappedBounds isWidthClean! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:39'!
isDependsOnChildren: aBrick

	^ aBrick isWidthDependsOnChildren
	! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:39'!
isDependsOnMyself: aBrick

	^ aBrick isWidthDependsOnMyself
	! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:40'!
isDependsOnOpposite: aBrick

	^ aBrick isWidthDependsOnHeight	! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:40'!
isDependsOnParent: aBrick

	^ aBrick isWidthDependsOnParent
	! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:51'!
isOppositeClean: aBrick

	^ aBrick wrappedBounds isHeightClean! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:44'!
isOppositeDependsOn: aBrick

	^ aBrick isHeightDependsOnWidth
	! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:29'!
markClean: aBrick

	aBrick wrappedBounds markWidthClean
	! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:48'!
markDirty: aBrick

	aBrick wrappedBounds markWidthDirty
	! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:53'!
markOppositeDirty: aBrick

	aBrick wrappedBounds markHeightDirty! !

!GLMBrickWidthTraverser methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/1/2015 21:08'!
opposite

	^ GLMBrickHeightTraverser uniqueInstance! !

!GLMBrickWidthTraverser methodsFor: 'private' stamp: 'AliakseiSyrel 2/8/2015 18:17'!
updateDimension: aBrick

	"my height is already calculated, maybe because it children triggered calculation"
	aBrick wrappedBounds isWidthClean ifTrue: [ ^ self ].
	(self dimensionPolicy: aBrick)  updateWidth: aBrick! !

Object subclass: #GLMBrickLayouter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Utils'!

GLMBrickLayouter class
	instanceVariableNames: 'uniqueInstance'!

!GLMBrickLayouter commentStamp: 'AliakseiSyrel 1/28/2015 13:09' prior: 0!
A GLMBrickLayouter is Brick's brand new layout system.
It builds a graph where each Brick corresponds two nodes: WidthNode and HeightNode.  Each node can have 4 states:

1 - depends on parent
2 - depends on children
3 - depends on itself
4 - depends on opposite node.

Layouter traverses graph from root WidthNode. Depending on state it behaves differently:

1) If layouter meets node with state 1 it checks if its parent already positioned and its height or width calculated. Otherwise it returns to such node later as soon as it finished with parent. If node with state 1 has parent with state 2 a LayoutCycleException must be reaised.

2) If layouter meets node with state 2 it must skip it and continues traversing all children until all of them are not positioned. As soon as it happens it returns back to skipped node. In case any of children of node with state 2 has state 1 a LayoutCycleException must be reaised.

3) If layouter meets node with state 3 it immidiately calculates corresponding value and applies it. Then it checks if there is an unvisited child node. If yes moves to it, otherwise returns to parent node.

4) If layouter meets node with state 4 it swaps its working node to opposite and continues traversing. For WidthNode opposing node is HeightNode and for HeightNode it is WidthNode.  If both nodes have state 4 a LayoutCycleException must be raised.

Instance Variables
	rootHeightNode:		<Object>
	rootWidthNode:		<Object>

rootHeightNode
	- xxxxx

rootWidthNode
	- xxxxx
!

GLMBrickLayouter class
	instanceVariableNames: 'uniqueInstance'!

!GLMBrickLayouter class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/3/2015 18:23'!
example

	|bricks|
	
	bricks := OrderedCollection new.
	1 to: 13 do: [ :i | bricks add: GLMBrick new ].
	
	(bricks at: 1) 
		width: 100;
		height: 100.
		
	(bricks at: 2)
		hResizing: #spaceFill;
		height: 20.
		
	(bricks at: 3)
		hResizing: #spaceFill;
		vResizing: #opposite.
		
	(bricks at: 4)
		hResizing: #spaceFill;
		vResizing: #spaceFill.
		
	(bricks at: 1)
		addBrickBack: (bricks at: 2);
		addBrickBack: (bricks at: 3);
		addBrickBack: (bricks at: 4).
		
	(bricks at: 5)
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	
	(bricks at: 6)
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	(bricks at: 7)
		width: 50;
		vResizing: #opposite.
		
	(bricks at: 8)
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
		
	(bricks at: 9)
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	(bricks at: 10)
		hResizing: #spaceFill;
		vResizing: #spaceFill.
		
	(bricks at: 11)
		hResizing: #spaceFill;
		height: 20.
		
	(bricks at: 12)
		hResizing: #spaceFill;
		height: 20.
		
	(bricks at: 13)
		hResizing: #spaceFill;
		height: 20.
		
	(bricks at: 2)
		addBrickBack: (bricks at: 5);
		addBrickBack: (bricks at: 6).
		
	(bricks at: 3)
		addBrickBack: (bricks at: 7);
		addBrickBack: (bricks at: 8).
	
	(bricks at: 4)
		addBrickBack: (bricks at: 9);
		addBrickBack: (bricks at: 10).
		
	(bricks at: 5)
		addBrickBack: (bricks at: 11).
		
	(bricks at: 8)
		addBrickBack: (bricks at: 12);
		addBrickBack: (bricks at: 13).
	"self halt."
	^ bricks
	
	! !

!GLMBrickLayouter class methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/2/2015 00:56'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GLMBrickLayouter methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/1/2015 21:08'!
heightTraverser

	^ GLMBrickHeightTraverser uniqueInstance! !

!GLMBrickLayouter methodsFor: 'private' stamp: 'AliakseiSyrel 2/1/2015 20:26'!
layout: aBrick

	aBrick wrappedBounds isWidthDirty
		ifTrue: [ self widthTraverser layoutAround: aBrick inContext: nil ].
	aBrick wrappedBounds isHeightDirty
		ifTrue: [ self heightTraverser layoutAround: aBrick inContext: nil ]! !

!GLMBrickLayouter methodsFor: 'layouting' stamp: 'AliakseiSyrel 2/3/2015 18:26'!
layoutIn: aBrick

	self
		markDependent: aBrick;
		layout: aBrick! !

!GLMBrickLayouter methodsFor: 'private' stamp: 'AliakseiSyrel 2/3/2015 18:26'!
markDependent: aBrick

	aBrick wrappedBounds isWidthDirty
		ifTrue: [ self widthTraverser markDirtyAround: aBrick inContext: nil ].
	aBrick wrappedBounds isHeightDirty
		ifTrue: [ self heightTraverser markDirtyAround: aBrick inContext: nil ]
	! !

!GLMBrickLayouter methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/1/2015 21:08'!
widthTraverser

	^ GLMBrickWidthTraverser uniqueInstance! !

Object subclass: #GLMBrickRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMBrickRenderer commentStamp: 'AliakseiSyrel 10/17/2014 10:33' prior: 0!
A GLMBrickRenderer is most simple separate renderer of Bricks. It support only borders
!

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 01:02'!
bottomLeftCornerShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw top left corner"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds bottomLeft + (width@width negated);
		direction: (width negated@width)/1.4;
		radial: true;
		yourself.
	aCanvas fillRectangle: (aBrick brickBounds bottomLeft - (0@width) corner: (aBrick brickBounds bottomLeft + (width@0))) fillStyle: gradient.! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 01:01'!
bottomRightCornerShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw top right corner"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds corner  - (width@width);
		direction: (width@width)/1.4;
		radial: true;
	yourself.
	
	aCanvas fillRectangle: (aBrick brickBounds corner  - (width@width) corner: (aBrick brickBounds corner)) fillStyle: gradient.! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 00:58'!
bottomShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw bottom shadow"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds bottomCenter - (0@width);
		direction: (0@width);
		yourself.
	aCanvas fillRectangle: ((aBrick brickBounds bottomLeft + (width@width negated)) corner: (aBrick brickBounds bottomLeft - (width @width) + (aBrick brickBounds width @ width))) fillStyle: gradient.! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 00:58'!
leftShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw left shadow"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds leftCenter + (width@0);
		direction: (width@0)negated;
		yourself.
	aCanvas fillRectangle: ((aBrick brickBounds origin + (0@width)) corner: (aBrick brickBounds origin + (width@width negated) + (0@ aBrick brickBounds height))) fillStyle: gradient.! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/24/2015 01:12'!
render: aBrick on: aCanvas
	
	self
		renderBackgroundColorOf: aBrick on: aCanvas;
		renderShadowOf: aBrick on: aCanvas;
		renderBorderOf: aBrick on: aCanvas! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/24/2015 00:46'!
renderBackgroundColorOf: aBrick on: aCanvas

	aCanvas fillRectangle: (aBrick brickBounds expandBy: aBrick shadowWidth negated) color: aBrick color.! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/11/2015 11:46'!
renderBorderOf: aBrick on: aCanvas

	aBrick border renderBorderOf: aBrick on: aCanvas.
"
	|rect|
	
	rect := (aBrick brickBounds origin - (aBrick paddingLeft @ aBrick paddingTop)) corner: (aBrick brickBounds corner + (aBrick paddingRight @ aBrick paddingBottom)).
	aCanvas frameRectangle: rect width: aBrick borderWidth color: aBrick borderColor"! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/24/2015 01:24'!
renderShadowOf: aBrick on: aCanvas

	"no need to even try drawing if shadow width is zero"
	aBrick shadowWidth = 0 ifTrue: [ ^ self ].
	
	self
		topLeftCornerShadowOf: aBrick on: aCanvas;
		topRightCornerShadowOf: aBrick on: aCanvas;
		bottomRightCornerShadowOf: aBrick on: aCanvas;
		bottomLeftCornerShadowOf: aBrick on: aCanvas;
		leftShadowOf: aBrick on: aCanvas;
		topShadowOf: aBrick on: aCanvas;
		rightShadowOf: aBrick on: aCanvas;
		bottomShadowOf: aBrick on: aCanvas
! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 00:58'!
rightShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw top shadow"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds rightCenter - (width@0);
		direction: (width@0);
		yourself.
	aCanvas fillRectangle: ((aBrick brickBounds topRight + (width negated@width)) corner: (aBrick brickBounds corner + (width@width negated))) fillStyle: gradient.! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 00:57'!
shadowGradientFor: aBrick

	^ GradientFillStyle ramp: { 0.0 -> (aBrick shadowColor) . 1.0 -> (aBrick shadowColor alpha: 0)}! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 00:58'!
topLeftCornerShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw top left corner"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds origin + (width@width);
		direction: (width@width)/1.4 negated;
		radial: true;
		yourself.
	aCanvas fillRectangle: (aBrick brickBounds origin corner: (aBrick brickBounds origin + (width@width))) fillStyle: gradient.! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 01:01'!
topRightCornerShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw top right corner"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds topRight  - (width@width negated);
		direction: (width@width negated)/1.4;
		radial: true;
	yourself.
	
	aCanvas fillRectangle: (aBrick brickBounds topRight - (width@0) corner: (aBrick brickBounds topRight + (0@width))) fillStyle: gradient.! !

!GLMBrickRenderer methodsFor: 'private-shadow' stamp: 'AliakseiSyrel 1/24/2015 00:58'!
topShadowOf: aBrick on: aCanvas
	|gradient width|
	width := aBrick shadowWidth.
	"draw top shadow"
	gradient := (self shadowGradientFor: aBrick)
		origin: aBrick brickBounds topCenter + (0@width);
		direction: (0@width)negated;
		yourself.
		
	aCanvas fillRectangle: ((aBrick brickBounds origin + (width@0)) corner: (aBrick brickBounds origin - (width@0) + (aBrick brickBounds width @ width))) fillStyle: gradient.! !

GLMBrickRenderer subclass: #GLMInteractableBrickRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMInteractableBrickRenderer commentStamp: 'AliakseiSyrel 10/17/2014 10:34' prior: 0!
A GLMInteractableBrickRenderer is more advanced Brick renderer, that is used in all interactable Bricks to allow on-fly change of background color or image
!

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/24/2015 01:13'!
render: aBrick on: aCanvas

	self
		renderBackgroundColorOf: aBrick on: aCanvas;
		renderShadowOf: aBrick on: aCanvas;
		renderColorOf: aBrick on: aCanvas;
		renderImageOf: aBrick on: aCanvas;
		renderBorderOf: aBrick on: aCanvas! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/24/2015 01:14'!
renderColorOf: aBrick on: aCanvas
	|color|
	color := aBrick currentColor.
	color ifNotNil: [
		aCanvas fillRectangle: (aBrick brickBounds expandBy: aBrick shadowWidth negated) color: color ]! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/24/2015 01:14'!
renderImageOf: aBrick on: aCanvas
	|image|
	
	image := aBrick currentImage.
	
	image ifNotNil: [
		aCanvas
			translucentImage: (GLMBrick resizeImage: image scale: ((aBrick brickBounds expandBy: aBrick shadowWidth negated) extent / image extent))
			at: (aBrick brickBounds expandBy: aBrick shadowWidth negated) origin ]! !

Object subclass: #GLMBrickThemer
	uses: GLMBrickScrollpaneStyle + GLMBrickRubricStyle
	instanceVariableNames: 'modules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Theme'!

GLMBrickThemer class
	uses: GLMBrickScrollpaneStyle classTrait + GLMBrickRubricStyle classTrait
	instanceVariableNames: ''!

GLMBrickThemer subclass: #GLMBrickDarkThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Theme'!

!GLMBrickDarkThemer methodsFor: 'brick' stamp: 'AliakseiSyrel 1/30/2015 12:06'!
contentBackgroundColor

	^ Color darkGray darker! !

!GLMBrickDarkThemer methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 13:58'!
scrollbarColor

	^ Color black alpha: 0.5! !

!GLMBrickDarkThemer methodsFor: 'brick' stamp: 'AliakseiSyrel 1/30/2015 12:28'!
textColor

	^ Color white slightlyDarker! !

!GLMBrickThemer methodsFor: 'brick-modules' stamp: 'AliakseiSyrel 1/30/2015 16:18'!
addModule: aThemerModule named: aSymbol

	self modules at: aSymbol put: aThemerModule.
	aThemerModule themer: self.
	^ aThemerModule! !

!GLMBrickThemer methodsFor: 'brick' stamp: 'AliakseiSyrel 1/26/2015 13:10'!
backgroundColor

	^ Color transparent! !

!GLMBrickThemer methodsFor: 'brick' stamp: 'AliakseiSyrel 1/30/2015 11:52'!
contentBackgroundColor

	^ Color white! !

!GLMBrickThemer methodsFor: 'brick-modules' stamp: 'AliakseiSyrel 1/30/2015 16:11'!
doesNotUnderstand: aMessage

	^ self modules at: aMessage selector ifAbsent: [ super doesNotUnderstand: aMessage ]
	! !

!GLMBrickThemer methodsFor: 'brick-modules' stamp: 'AliakseiSyrel 1/30/2015 15:58'!
modules

	^ modules ifNil: [ modules := Dictionary new ]! !

!GLMBrickThemer methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 2/11/2015 13:50'!
popupErrorThemer

	^ self
		registerModule: GLMBrickPopupErrorThemer new
		to: self
		named: #popupThemer! !

!GLMBrickThemer methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 2/11/2015 13:49'!
popupHelpThemer

	^ self
		registerModule: GLMBrickPopupHelpThemer new
		to: self
		named: #popupThemer! !

!GLMBrickThemer methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 2/11/2015 13:50'!
popupSuccessThemer

	^ self
		registerModule: GLMBrickPopupSuccessThemer new
		to: self
		named: #popupThemer! !

!GLMBrickThemer methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 2/11/2015 13:45'!
popupThemer

	^ self
		registerModule: GLMBrickPopupThemer new
		to: self! !

!GLMBrickThemer methodsFor: 'brick-modules' stamp: 'AliakseiSyrel 2/11/2015 13:37'!
registerModule: aModule to: aThemer

	^ self
		registerModule: aModule
		to: aThemer
		named: thisContext sender selector! !

!GLMBrickThemer methodsFor: 'brick-modules' stamp: 'AliakseiSyrel 2/11/2015 13:36'!
registerModule: aModule to: aThemer named: aString
	"Registers aModule to aThemer. It stores modules in a dictionaty where a key is a selector of my caller method. It allows to customize bricks that are not added to the application (in this case they don't have access to custom themer normaly, because owner is nil) using the same api as added one."
	^ self modules
		at: aString
		ifAbsent: [ aThemer addModule: aModule named: aString ]! !

!GLMBrickThemer methodsFor: 'brick' stamp: 'AliakseiSyrel 1/30/2015 12:26'!
textColor

	^ Color black! !

Object subclass: #GLMBrickThemerModule
	instanceVariableNames: 'themer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Theme'!

GLMBrickThemerModule subclass: #GLMBrickPopupThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Theme'!

GLMBrickPopupThemer subclass: #GLMBrickPopupErrorThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Theme'!

!GLMBrickPopupErrorThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 14:31'!
backgroundColor
	"FBC9C1"
	^ Color r: 251 g: 201 b: 193 range: 255! !

!GLMBrickPopupErrorThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 14:25'!
borderColor

	^ Color r: 225 g: 124 b: 108 range: 255! !

!GLMBrickPopupErrorThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 14:07'!
textColor

	^ Color r: 206 g: 38 b: 11 range: 255! !

GLMBrickPopupThemer subclass: #GLMBrickPopupHelpThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Theme'!

!GLMBrickPopupHelpThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 13:41'!
backgroundColor

	^ Color r: 190 g: 236 b: 250 range: 255! !

!GLMBrickPopupHelpThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 13:41'!
borderColor

	^ Color r: 48 g:194 b:240 range: 255! !

!GLMBrickPopupHelpThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 13:41'!
textColor

	^ Color r: 16 g: 172 b: 221 range: 255! !

GLMBrickPopupThemer subclass: #GLMBrickPopupSuccessThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Theme'!

!GLMBrickPopupSuccessThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/11/2015 14:28'!
backgroundColor

	^ Color r: 204 g: 229 b: 204 range: 255! !

!GLMBrickPopupSuccessThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/11/2015 14:29'!
borderColor
	"#7FBF7F"
	^ Color r: 127 g: 191 b: 127 range: 255! !

!GLMBrickPopupSuccessThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/11/2015 14:29'!
textColor
	
	^ Color r: 0 g: 115 b: 0 range: 255! !

!GLMBrickPopupThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 13:45'!
backgroundColor

	^ Color white! !

!GLMBrickPopupThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 13:45'!
borderColor

	^ Color lightGray! !

!GLMBrickPopupThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 13:41'!
borderWidth

	^ 1! !

!GLMBrickPopupThemer methodsFor: 'brick-popup' stamp: 'AliakseiSyrel 2/11/2015 13:45'!
textColor

	^ Color lightGray darker! !

!GLMBrickThemerModule methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 15:56'!
themer

	^ themer! !

!GLMBrickThemerModule methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 15:56'!
themer: anObject
	themer := anObject! !

Object subclass: #GLMPhlowPort
	instanceVariableNames: 'transmissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowPort methodsFor: 'adding' stamp: 'AliakseiSyrel 1/23/2015 21:51'!
addTransmission: aTransmission

	(self transmissions includes: aTransmission) ifTrue: [ ^ self ].
	self transmissions add: aTransmission! !

!GLMPhlowPort methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 21:09'!
transmissions

	^ transmissions ifNil: [ transmissions := OrderedCollection new ]! !

!GLMPhlowPort methodsFor: 'transmitting' stamp: 'AliakseiSyrel 1/23/2015 21:34'!
transmit

	self transmissions do: #transmit! !

Object subclass: #GLMPhlowTableColumn
	instanceVariableNames: 'computation title style'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowTableColumn methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 12:13'!
computation
	^ computation! !

!GLMPhlowTableColumn methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 12:13'!
computation: anObject
	computation := anObject! !

!GLMPhlowTableColumn methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 12:13'!
style
	^ style! !

!GLMPhlowTableColumn methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 12:13'!
style: anObject
	style := anObject! !

!GLMPhlowTableColumn methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 12:13'!
title
	^ title! !

!GLMPhlowTableColumn methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/12/2015 12:13'!
title: anObject
	title := anObject! !

Object subclass: #GLMPhlowTarget
	instanceVariableNames: 'phlowObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

GLMPhlowTarget subclass: #GLMPhlowDestination
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowDestination class methodsFor: 'instance creation' stamp: 'AndreiChis 1/23/2015 14:50'!
target: anObject port: aPortObject

	^ self new phlowObject: anObject; port: aPortObject; yourself! !

!GLMPhlowDestination methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 22:31'!
phlowValue: anObject value: anotherObject

	self port phlowValue: (self phlowObject phlowValue: anotherObject) value: anObject
	! !

!GLMPhlowDestination methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:04'!
port
	^ port! !

!GLMPhlowDestination methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:05'!
port: anObject
	"port can be anything"
	port := anObject! !

GLMPhlowTarget subclass: #GLMPhlowOrigin
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowOrigin class methodsFor: 'instance creation' stamp: 'AndreiChis 1/23/2015 14:51'!
target: anObject slot: aSlotSymbol

	^ self new phlowObject: anObject; slot: ((anObject class slotsDictionary at: aSlotSymbol)); yourself! !

!GLMPhlowOrigin methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:06'!
slot
	^ slot! !

!GLMPhlowOrigin methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:06'!
slot: anObject
	"must be a GLMPhlowSlot"
	slot := anObject! !

!GLMPhlowTarget methodsFor: 'accessing' stamp: 'AndreiChis 1/23/2015 14:48'!
phlowObject
	^ phlowObject! !

!GLMPhlowTarget methodsFor: 'accessing' stamp: 'AndreiChis 1/23/2015 14:48'!
phlowObject: anObject
	phlowObject := anObject! !

Object subclass: #GLMPhlowTransmission
	instanceVariableNames: 'origins destination transformation action condition phlow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:09'!
action
	^ action! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 21:39'!
action: anObject

	action := anObject! !

!GLMPhlowTransmission methodsFor: 'adding' stamp: 'AliakseiSyrel 1/23/2015 21:51'!
addOrigin: anObject
	"anObject must be a GLMPhlowOrigin"
	
	(self origins includes: anObject) ifTrue: [ ^ self ].
	"registering new origin"
	self origins add: anObject.
	"adding myself to the outgoing transmissions of origin"
	anObject phlowObject addTransmission: self from: anObject slot name! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 23:43'!
condition
	^ condition! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 23:43'!
condition: anObject
	condition := anObject! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:07'!
destination
	^ destination! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:07'!
destination: anObject
	destination := anObject! !

!GLMPhlowTransmission methodsFor: 'private' stamp: 'AliakseiSyrel 1/23/2015 21:37'!
gatherPortValues
	"returns a Collection containing values of all assosiated origins"
	^ self origins collect: [ :each | each slot read: each phlowObject ]! !

!GLMPhlowTransmission methodsFor: 'private' stamp: 'AliakseiSyrel 1/23/2015 21:48'!
meetsCondition: aCollection
	
	^ ((self condition phlowValue: self destination phlowObject withEnoughArguments: aCollection) = false) not! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 21:13'!
origins

	^ origins ifNil: [ origins := OrderedCollection new ]! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 22:28'!
phlow
	^ phlow! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 22:28'!
phlow: anObject
	phlow := anObject! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:09'!
transformation
	^ transformation! !

!GLMPhlowTransmission methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/22/2015 21:09'!
transformation: anObject
	transformation := anObject! !

!GLMPhlowTransmission methodsFor: 'transmission' stamp: 'AliakseiSyrel 1/23/2015 22:31'!
transmit
	|portValues value|
	
	portValues := self gatherPortValues.
	
	"we transmit only if meets condition"
	(self meetsCondition: portValues) ifFalse: [ ^ self ].
	"obtaining slot value and transforming it"
	value := self transformation phlowValue: self destination phlowObject withEnoughArguments: portValues.
	"transmiting transformed value to destination port"
	self destination phlowValue: value value: self phlow.
	"performing specified action"
	self action phlowValue: self destination phlowObject value: value
	! !

Object subclass: #GLMPhlowTransmissionBuilder
	instanceVariableNames: 'transmissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Phlow'!

!GLMPhlowTransmissionBuilder class methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/24/2015 02:14'!
phlow: anObject

	^ self new newWithPhlow: anObject! !

!GLMPhlowTransmissionBuilder methodsFor: 'combining' stamp: 'AliakseiSyrel 1/24/2015 02:22'!
+ anotherBuilder

	self transmissions addAll: anotherBuilder transmissions! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:20'!
from: anObject
	
	self transmissions do: [ :each | each addOrigin: (GLMPhlowOrigin target: (each phlow phlowValue: each phlow) slot: anObject) ].! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting-deprecated' stamp: 'AliakseiSyrel 1/22/2015 21:48'!
from: anObject port: aSlotSymbol

	^ self from: anObject slot: aSlotSymbol! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:16'!
from: anObject slot: aSlotSymbol
	"anObject must be an instance of class having GLMPhlowTrait for example GLMBrick"
	"aSlotSymbol must be a name of existing GLMPhlowSlot in anObject"
	self transmissions do: [ :each |
		|from|
		from := anObject phlowValue: each phlow.
		each addOrigin: (GLMPhlowOrigin target: from slot: aSlotSymbol) ].! !

!GLMPhlowTransmissionBuilder methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/24/2015 02:13'!
newWithPhlow: anObject

	self transmissions add: (GLMPhlowTransmission new phlow: anObject)! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:20'!
to: anObject

	self transmissions do: [ :each | each destination: (GLMPhlowDestination 
		target: each phlow 
		port: (each phlow class slotsDictionary at: anObject)) ]! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:17'!
to: anObject port: aPortObject

	self transmissions do: [ :each  | each destination: (GLMPhlowDestination target: anObject port: aPortObject) ]! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:17'!
to: anObject slot: aSlotSymbol
	"anObject must be an instance of class having GLMPhlowTrait for example GLMBrick"
	"aSlotSymbol must be a name of existing Slot in anObject"
	self transmissions do: [ :each | each destination: (GLMPhlowDestination 
		target: anObject 
		port: (anObject class slotsDictionary at: aSlotSymbol)) ]! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:21'!
toPort: anObject

	^ self transmissions do: [ :each  | each destination: (GLMPhlowDestination target: each phlow port: anObject) ]! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:18'!
transformed: anObject

	self transmissions do: [ :each | each transformation: anObject ]! !

!GLMPhlowTransmissionBuilder methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/24/2015 02:11'!
transmissions

	^  transmissions ifNil: [ transmissions := OrderedCollection new ]! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:18'!
when: anObject

	self transmissions do: [ :each | each condition: anObject ]! !

!GLMPhlowTransmissionBuilder methodsFor: 'scripting' stamp: 'AliakseiSyrel 1/24/2015 02:18'!
with: anObject

	self transmissions do: [ :each | each action: anObject ]! !

!Object methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/11/2015 15:19'!
asBrick

	^ GLMMorphBrick on: self asMorph! !

!Object methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/20/2015 17:22'!
brickValue: aBrick

	^ self! !

!Object methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 21:13'!
phlowValue: anObject

	^ self! !

!Object methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/22/2015 21:33'!
phlowValue: anObject value: otherObject

	^ self! !

!Object methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/23/2015 21:46'!
phlowValue: anObject withEnoughArguments: aCollection

	^ self! !

!UITheme methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 1/30/2015 17:58'!
brickThemer

	^ GLMBrickThemer new! !
GLMBrickBorder initialize!
GLMBrickBounds initialize!
